using System.Runtime.InteropServices;
using System.Collections.Generic;
using System.EnterpriseServices;
using System.Text;
using System.Data;
using System;
using CommLayerFactory;
using ICommLayer;
using DBFactory;

namespace ControlSystem
{
    
    /// <summary>
    /// Creator:Richard.liu
    /// ص
    /// </summary>
   
    public class CControl
    {
        private Object thisLock = new Object();
        DBOperator dbo =CStaticClass.dbo;
        DBOperator dboM = CStaticClass.dboM;
        Model.MError errs;
        Model.MDevice devinfo;
        ISendDeviceOrder sdo;
        CCommonFunction ccf = new CCommonFunction();
       // CGetState cgs = new CGetState();
        //CGetState gs = new CGetState();
        int _DeviceIdx = 0;//豸
        int _routeID = 0;//·Ψһ
        int _serialNumber = 0;//·ϵ豸
        int _ManageTaskIdx = 0;//
        int _ManageKindIdx = 0;//
        int _DeviceOrder = 0;//豸
        int _LockedState = 0;
        int _Associate = 0;
        int _ManTaskReserve = 0;
        string _AheadDetect = "";
        int _NumParam1=0;
        int _NumParam2 = 0;
        int _NumParam3 = 0;
        int _NumParam4 = 0;
        int _NumParam5 = 0;
        int _NumParam6 = 0;
        string _TxtParam = "-";
        int _DeviceKind = 0;
        int _OutsideAltDevice = 0;
        int _InsideAltDevice = 0;
        int _StartDevice = 0;
        int _EndDevice = 0;
        int _RouteKind = 0;
        int _CorrelDoubleFork = -1;
        //int _UseAwayFork = 1;
        int _AgvNo = 65535;
        string _CControlError = "";//ص˵
        //20110329
        int LastMachine = 0;//һεͻ
        int RightUseTimes = 0;//12049
        int LeftUseTimes = 0;//12054

        public string CControlError
        {
            get { return _CControlError; }
            set { _CControlError = value; }
        }

        public CControl()
        {
            //dbo.Open();
        }
        //~CControl()
        //{
        //    dbo.Close();
        //}
        public void StartOrder()
        {
           
            //ȼһ񵥵ġһʣеĵһ豸Ƿռãռִһ񵥣
            //Ȼһ豸F_AheadDetectǷ㣬ִһ񵥣
            //ʼִʱͬеĹ豸F_AssociateDeviceIndex,׼豸ָ
            //ҵ¼״̬F_StatusΪ1,豸Ϊռ״̬T_Base_deviceF_LockedState=豸ָ
            //дIO_Controlִ״̬FSTATUS=1;T_Manage_Taskִ״̬FSTATUS=1
            //·ϸF_LockedDeviceIndexжӦ豸ǹ豸
            string  taskkind =string.Empty ;
            
            try
            {
                
                if (CStaticClass.AutoOrder == true)
                {
                    taskkind = " (F_ManageTaskKindIndex = 1 or F_ManageTaskKindIndex = 2 or F_ManageTaskKindIndex = 4) "; //ɵԶ
                    
                }
                else
                {
                    if (FrmControlMonitor.FormInstance.GetObjectText("tsStatus").IndexOf(_CControlError) < 0)
                    {
                        
                        FrmControlMonitor.FormInstance.FlashPanit("tsStatus", _CControlError, true);
                    }
                    return;
                }

                DataView dvM = new DataView();
                string strM = "";
                char[] sep = new char[1] { '-' };
                string aa = DateTime.Now.Second.ToString() + "-" + DateTime.Now.Millisecond.ToString();
                //ù
                string strsql = "SELECT DISTINCT F_ManageTaskIndex AS MIndex,F_MonitorTaskLevel,F_ManageTaskKindIndex FROM T_Monitor_Task where " +
                    taskkind + " order by F_ManageTaskKindIndex desc, F_MonitorTaskLevel desc, F_ManageTaskIndex asc";
                
                DataView dv =  dbo.ExceSQL(strsql).Tables[0].DefaultView;
                if (dv.Count > 0)
                {
                    for (int i = 0; i < dv.Count; i++)
                    {
                        try
                        {
                            //1ȡÿݵĵһ豸ָ 
                            strM = "select top 1  min(F_MonitorIndex) as minMidx,f_status from T_Monitor_Task where " + taskkind + " and F_ManageTaskIndex = " + dv[i]["MIndex"] + " GROUP BY F_MonitorIndex, F_Status";
                            dvM = dbo.ExceSQL(strM).Tables[0].DefaultView;
                            if (dvM.Count > 0 && dvM[0]["minMidx"] != DBNull.Value)
                            {

                                if (dvM[0]["F_Status"].ToString() == "0")
                                {
                                    SendMonitorTask(Convert.ToInt32(dvM[0]["minMidx"]));
                                }
                                else
                                {
                                    continue;
                                }
                                
                            }
                            else
                            {
                                continue;
                            }
                        }
                        catch(Exception ex)
                        {
                            _CControlError = "ʱ"+ex.Message ;
                        }
                        
                    }//for
                    //20091107
                    
                    dv = null;
                    
                    dvM = null;
                    
                    return  ;
                }
                else
                {
                    //20091107
                    
                    dv = null;
                    
                    dvM = null;
                    //_CControlError = "ûִУ";
                    if (FrmControlMonitor.FormInstance.GetObjectText("tsStatus").IndexOf(_CControlError) < 0)
                    {
                        FrmControlMonitor.FormInstance.FlashPanit("tsStatus",_CControlError,true );
                    }
                    return;
                }
                
                
            }
            catch (Exception ex)
            {
                
                throw ex;
            }
        }
        /// <summary>
        /// ȡÿݵĵһ豸Ƿ,trueʾfalseʾ
        /// </summary>
        /// <param name="minMidx"></param>
        /// <returns>trueʾfalseʾ</returns>
        public bool GetFirstDeviceIFLocked(int minMidx, bool checkLockedstate)
        {
            char[] sep = new char[1] { '-' };
            int msgIdx = 0;//Ϣ
            int adidx = 0;//豸豸ָ
            DataView dv;
            try
            {

                //Ҫ͵Ϣ
                if (GetSendInfo(minMidx) == false) { return true; }

                int DeviceIdx = _DeviceIdx;//豸
                int routeID = _routeID;//·Ψһ
                int serialNumber = _serialNumber;//·ϵ豸
                int ManageTaskIdx = _ManageTaskIdx;//
                int ManageKindIdx = _ManageKindIdx;//
                int DeviceOrder = _DeviceOrder;//豸
                int LockedState = _LockedState;
                int Associate = _Associate;
                int ManTaskReserve = _ManTaskReserve;
                string AheadDetect = _AheadDetect;
                int NumParam1 = _NumParam1;
                int NumParam2 = _NumParam2;
                int NumParam3 = _NumParam3;
                int NumParam4 = _NumParam4;
                int NumParam5 = _NumParam5;
                int NumParam6 = _NumParam6;
                string TxtParam = _TxtParam;
                int DeviceKind = _DeviceKind;
                int OutsideAltDevice = _OutsideAltDevice;
                int InsideAltDevice = _InsideAltDevice;
                int StartDevice = _StartDevice;
                int EndDevice = _EndDevice;
                int RouteKind = _RouteKind;
                int AgvNo = _AgvNo;


                #region 豸ʱǷԶĵ
                
                if (CStaticClass.DeviceErrorAutoModifyRoutePath == "1")
                {//20100108
                    #region ֻRGVйصжϸ·
                    //20100108 ͻĽӻԽָĵ
                    if ((_DeviceKind == 4) || ((_DeviceKind == 2) && ((_DeviceOrder == 3))) && (RouteKind != 3))
                    {
                        bool IfModify = false, IfUseNegativeDevice = false;//20100610
                        //20091102 RGVĵһǰ˶ָҪ·
                        if ((_DeviceKind == 4) && (_DeviceOrder == 7) &&
                            (ccf.GetSerialNumberFromRouteDevice(_routeID, _DeviceIdx) >
                            ccf.GetSerialNumberFromRouteDevice(_routeID, _NumParam1)))
                        {
                            dv = dbo.ExceSQL("SELECT MIN(F_MonitorIndex) AS mmi FROM dbo.T_Monitor_Task WHERE (F_ManageTaskIndex = " + ManageTaskIdx + ") AND (F_ManageTASKKINDINDEX = 1)").Tables[0].DefaultView;
                            if (dv.Count > 0)
                            {
                                //20091218

                                if ((dv[0]["mmi"] != DBNull.Value) && (dv[0]["mmi"].ToString() == minMidx.ToString()))
                                {
                                    IfModify = true;
                                    IfUseNegativeDevice = true;//20100610
                                }
                            }
                            
                        }
                        else if ((_DeviceKind == 4) && ((_DeviceOrder == 3) || (_DeviceOrder == 5)))
                        {//20100108ԴͻԽӦüƣػ
                            devinfo = Model.CGetInfo.DeviceInfo[DeviceIdx];
                            if ((devinfo.RunState == 0) && (devinfo.HaveGoods == true))
                            {
                                IfModify = true;
                                IfUseNegativeDevice = false;//20100610
                            }
                            devinfo = null;
                        }
                        else
                        {
                            IfModify = true;
                            IfUseNegativeDevice = true;//20100610

                        }



                        if (IfModify == true)
                        {
                            int altsn = ccf.GetSerialNumberFromRouteDevice(_routeID, _OutsideAltDevice);
                            string sql = "SELECT F_SerialNumber FROM T_Base_Device,T_Base_Route_Device,T_Base_Device_State where " +
                            " T_Base_Device.F_DeviceIndex = T_Base_Route_Device.F_DeviceIndex and F_ErrorCode =F_DeviceErrorIndex and " +
                            " T_Base_Device_State.F_DeviceKindIndex = T_Base_Device.F_DeviceKindIndex AND T_Base_Device.F_ErrorCode > 0 AND " +
                            " T_Base_Route_Device.F_SerialNumber > " + _serialNumber + " AND T_Base_Route_Device.F_SerialNumber > " +
                            altsn + " AND T_Base_Route_Device.F_RouteIDSub = " + _routeID + " and F_ErrorLevel=2 ";
                            dv= dbo.ExceSQL(sql).Tables[0].DefaultView;
                            if (dv.Count > 0)
                            {
                                //жܷĵ;ĵ;ManageTaskIdxManageKindIdx ĵȫĵ
                                if (GetUsableDestination(_ManageTaskIdx, _ManageKindIdx) == true)
                                {
                                    
                                    return true;
                                }
                            }
                            #region RGVĿλñռҪĵ
                            //20100610
                            devinfo = null;
                            if (_DeviceKind == 4)
                            {//RGV
                                devinfo = Model.CGetInfo.GetDeviceInfo(CDisassembleTask.GetNextDevice(_routeID, _serialNumber)[0]);
                            }
                            else
                            {//ͻͻ
                                devinfo = Model.CGetInfo.GetDeviceInfo(CDisassembleTask.GetNextDevice(_routeID, _serialNumber)[0]);//RGV
                                int sn = 0;
                                if (devinfo != null)
                                {
                                    sn = ccf.GetSerialNumberFromRouteDevice(_routeID, devinfo.DeviceIndex);
                                }
                                devinfo  = Model.CGetInfo.GetDeviceInfo(CDisassembleTask.GetNextDevice(_routeID, sn)[0]);//ӻͻ
                                
                            }
                            if (devinfo != null)
                            {
                                if (devinfo.HaveGoods == true)
                                {//Ŀλñռãĵ
                                    if (GetRGVIdleDestination(_ManageTaskIdx, _ManageKindIdx, devinfo.DeviceIndex, IfUseNegativeDevice) == true)
                                    {
                                        return true;
                                    }
                                }
                            }
                            #endregion
                        }
                        
                    }
                    #endregion

                }

                #endregion


                //жF_PriorMonitorֵǷڣھͲִС
                //sql = "SELECT T_Monitor_Task.F_MonitorIndex FROM T_Monitor_Task,T_Monitor_Task T_Monitor_Task_1 WHERE "+
                //    " T_Monitor_Task.F_PriorMonitor = T_Monitor_Task_1.F_MonitorIndex AND (T_Monitor_Task.F_PriorMonitor IS NOT NULL)";
                //dv = dbo.ExceSQL(sql).Tables[0].DefaultView;
                //if (dv.Count > 0)
                //{
                //    return true;
                //}

                
                if (_DeviceIdx == 1001)
                {//20100512 AGV
                    if (AgvNo != 65535)//Ѿ䳵ŵAGVŶӦ豸Ƿ
                    {
                        LockedState = Convert.ToInt32(dbo.GetSingle("SELECT F_LockedState FROM T_Base_Device where F_DeviceIndex="+(1001+AgvNo)+""));
                        if(LockedState>0)return true;
                    }
                    if (AheadDetectOK(minMidx, _AheadDetect) == true)//ǰͨ
                    {
                        #region ˫AGV⣬ͬĹǷAheadDetectOK
                        //20100323
                        devinfo = Model.CGetInfo.GetDeviceInfo(_DeviceIdx);
                        if (devinfo.IfCorrelDoubleFork == "1")
                        {
                            if (Model.CGeneralFunction.DoubleForkIfSync(minMidx, _DeviceIdx, _DeviceKind) == true)
                            {
                                string[] df = Model.CGeneralFunction.GetDoubleForkMonitorInfo(minMidx, _DeviceIdx);
                                if (df != null)
                                {
                                    if (AheadDetectOK(Convert.ToInt32(df[0]), df[1]) == false)//˫ǰʧ
                                    {
                                        return true;
                                    }
                                    #region ָǵһָܷ
                                    int rmankind = Model.CGeneralFunction.GetManageTaskKindIndexFromMonitor(Convert.ToInt32(df[0]));
                                    int rman = Model.CGeneralFunction.GetManageTaskIndexfromMonitor(Convert.ToInt32(df[0]));
                                    dv = dbo.ExceSQL("SELECT MIN(F_MonitorIndex) AS mmi FROM dbo.T_Monitor_Task WHERE (F_ManageTaskIndex = " + rman + ") AND (F_ManageTASKKINDINDEX = " + rmankind + ")").Tables[0].DefaultView;
                                    if (dv.Count > 0)
                                    {
                                        if ((dv[0]["mmi"] != DBNull.Value) && (dv[0]["mmi"].ToString() != df[0]))
                                        {
                                            return true;
                                        }
                                    }
                                    #endregion
                                }

                            }
                            
                        }
                        #endregion

                        return false;
                    }
                    else
                    {
                        return true;
                    }
                }
                else
                {
                    //һ豸ǷռãRGVͶѶҪǷֲʱûִʱµĵ

                    if (((_LockedState == 0) && (checkLockedstate == true)) || (checkLockedstate == false))
                    {

                        #region RGVѶǷ񱻵ԤԼF_ManTaskReserve

                        if (_ManTaskReserve > 0)
                        {
                            devinfo = Model.CGetInfo.GetDeviceInfo(_DeviceIdx);
                            if (devinfo.IfCorrelDoubleFork == "1")
                            {
                                string[] df = Model.CGeneralFunction.GetDoubleForkMonitorInfo(minMidx, _DeviceIdx);
                                if (df != null)
                                {
                                    int rman = Model.CGeneralFunction.GetManageTaskIndexfromMonitor(Convert.ToInt32(df[0]));
                                    int rmankind = Model.CGeneralFunction.GetManageTaskKindIndexFromMonitor(Convert.ToInt32(df[0]));
                                    if ((_ManTaskReserve.ToString() != _ManageKindIdx.ToString() + _ManageTaskIdx.ToString()) && (_ManTaskReserve.ToString() != rmankind.ToString() + rman.ToString()))
                                    {
                                        return true;
                                    }
                                }
                                else//20100702ɾʱԤԼ
                                {
                                    object rob = dbo.GetSingle("SELECT F_RELATIVECONTORLID FROM T_Manage_Task WHERE (F_ManageTaskKindIndex = "+_ManageKindIdx+") AND (FID = "+_ManageTaskIdx+") AND (F_RELATIVECONTORLID <> - 1)");
                                    string rlres = string.Empty ;
                                    if (rob != null)
                                    {
                                        rlres = _ManageKindIdx.ToString() + rob.ToString();
                                    }
                                    else
                                    {
                                        rob = dbo.GetSingle("SELECT FID FROM T_Manage_Task WHERE (F_ManageTaskKindIndex = " + _ManageKindIdx + ") AND (F_RELATIVECONTORLID = " + _ManageTaskIdx + ") ");
                                        if (rob != null)
                                        {
                                            rlres = _ManageKindIdx.ToString() + rob.ToString();
                                        }
                                    }
                                    if ((_ManTaskReserve.ToString() != _ManageKindIdx.ToString() + _ManageTaskIdx.ToString())&&(_ManTaskReserve.ToString() !=rlres))
                                    {
                                        return true;
                                    }
                                }
                                
                            }
                            else
                            {
                                if (_ManTaskReserve.ToString() != _ManageKindIdx.ToString() + _ManageTaskIdx.ToString())
                                {
                                    return true;
                                }
                            }
                            
                        }


                        #endregion

                        #region жϴ󳵵˶3215ָǷ񴥷3215-3213
                        //if ((_DeviceIdx == 3301) && (_DeviceOrder == 7) && ((_NumParam1 != 3215) && (_NumParam1 != 3233)))
                        //{
                        //    DataView dvma = dbo.ExceSQL("select FID, F_ManageTaskKindIndex,FENDDEVICE from T_Manage_Task where F_ManageTaskKindIndex=" +
                        //        ccf.GetManageTaskKindIndexFromMonitor(minMidx) + " and fid=" + ccf.GetManageTaskIndexfromMonitor(minMidx)
                        //        + " and FENDDEVICE=3215").Tables[0].DefaultView;
                        //    if (dvma.Count > 0)
                        //    {
                        //        int startdev = 3215;
                        //        int dcode = 3213;
                        //        if (CStaticClass.GetDevicePhotoelectric(32151) == 1)
                        //        {
                        //            DataView dv11 = dbo.ExceSQL("select FSTARTDEVICE,FENDDEVICE from T_Manage_Task where FSTARTDEVICE=" + startdev + " and FENDDEVICE=" + dcode + "").Tables[0].DefaultView;
                        //            if (dv11.Count <= 0)
                        //            {
                        //                int fid = ccf.GetTempManageIdx();
                        //                //ccf.RecordMaxTempManageTaskFID(fid);
                        //                string warehouse = "13";
                        //                DataView dvw = dbo.ExceSQL("SELECT F_WarehouseIndex  FROM T_Warehouse").Tables[0].DefaultView;
                        //                if (dvw.Count > 0)
                        //                {
                        //                    warehouse = dvw[0]["F_WarehouseIndex"].ToString();
                        //                }

                        //                string sql = "INSERT INTO T_Manage_Task" +
                        //              "(FID, F_ManageTaskKindIndex,FPALLETBARCODE,FMANAGETASKTYPE,FCONTROLTASKTYPE, FTASKLEVEL, FISRETURN," +
                        //              "FWAREHOUSE, FSTARTCELL, FSTARTDEVICE, FENDDEVICE, FENDCELL, " +
                        //              "FSTATUS, FBEGTIME, FENDTIME,FIntoStepOK,FREMARK,FLANEWAY,FSTACK)" +
                        //              "VALUES (" + fid + ",2,'-','0','3','1','1','" + warehouse + "','-','"
                        //              + startdev + "','" + dcode + "','-',"
                        //              + "'0','-','-','0','',0,0)";

                        //                dbo.ExceSQL(sql);
                        //            }
                        //        }
                        //    }
                        //}
                        #endregion

                        #region Ƿ赲豸

                        ////3.5Ƿ赲豸
                        //BlockDevice = ccf.GetBlockDevice(_DetailIndex);
                        //if ((BlockDevice != null) && (BlockDevice!= ""))
                        //{
                        //    split = BlockDevice.Split(sep);
                        //    adidx = GetMonitorTaskIndex(Convert.ToInt32(split[0]), Convert.ToInt32(split[1]));

                        //    //6赲豸
                        //    //CStaticClass.MessageIndex++;
                        //    CStaticClass.MessageIndex = 1;
                        //    msgIdx = (CStaticClass.MessageIndex);
                        //    sdo = CommModeCreate.CreateSendDeviceOrder(Convert.ToInt32(split[1]));
                        //    //жǷΪѶ豸
                        //    bool sendok;
                        //    if ((ccf.GetDeviceKindIdx(Convert.ToInt32(split[0])) == 1) || (ccf.GetDeviceKindIdx(Convert.ToInt32(split[0])) == 4) || (ccf.GetDeviceKindIdx(Convert.ToInt32(split[0])) == 6))
                        //    {
                        //        int[] gc = ccf.GetCoordinatesFromMonitorTask(adidx);//
                        //        if (gc != null)
                        //        {
                        //            //1Ѷ4RGV6AGVҪŻȣ豸F_NeedOptimize='1'
                        //            //ֱдT_Monitor_Task_Child
                        //            if (ccf.NeedOptimize(_DeviceIdx) == true)
                        //            {
                        //                ccf.InsertMonitorOptimizeChildTask(adidx);
                        //                sendok = true;
                        //            }
                        //            else
                        //            {
                        //                sendok = sdo.SendDeviceOrder(msgIdx, adidx, Convert.ToInt32(split[1]),
                        //                    Convert.ToInt32(split[0]), gc[0], gc[1], gc[2], gc[3], gc[4], gc[5]);
                        //            }

                        //        }
                        //        else
                        //            return true;

                        //    }
                        //    else
                        //    {
                        //        sendok = sdo.SendDeviceOrder(msgIdx, adidx, Convert.ToInt32(split[1]), Convert.ToInt32(split[0]));
                        //    }
                        //    if (sendok == false)
                        //    {
                        //        return true;
                        //    }
                        //}

                        #endregion
                        #region ָһ̻
                        if (18007 == NumParam4)
                        {
                            #region ѡһĵ̻
                            

                        //    if (LastMachine == 0)//һεѡҲ̻
                        //    {
                        //        LastMachine = 12049;
                        //        RightUseTimes=1;

                        //    }
                        //    else
                        //    {
                        //        if (RightUseTimes == 1)//
                        //        {
                        //            LastMachine = 12049;
                        //            RightUseTimes = 0;
                        //        }
                        //        else                                                                      
                        //            if (LeftUseTimes == 1)
                        //            {
                        //                LastMachine = 12054;
                        //                LeftUseTimes = 0;
                        //            } 
                        //            else
                        //            if (LeftUseTimes == 0)
                        //            {
                        //                if (LastMachine == 12049)
                        //                {
                        //                    LastMachine = 12054;
                        //                    LeftUseTimes = 1;
                        //                }
                        //                else
                        //                {
                        //                    LastMachine = 12049;
                        //                    RightUseTimes = 1;
                        //                }
                        //            }

                        //            else
                        //                if (RightUseTimes == 0)
                        //                {
                        //                    if (LastMachine == 12054)
                        //                    {
                        //                        LastMachine = 12049;
                        //                        RightUseTimes = 1;
                        //                    }
                        //                    else
                        //                    {
                        //                        LastMachine = 12054;
                        //                        LeftUseTimes = 1;
                        //                    }

                        //                }

                        //}
                            #endregion
                            #region ѡеĵ̻

                        if (LastMachine == 0)//һεѡҲ̻
                        {
                            LastMachine = 12049;
                            RightUseTimes = 1;

                        }
                        else
                        {
                            if (LastMachine == 12049)
                            {
                                LastMachine = 12054;
                                LeftUseTimes = 1;
                            }
                            else
                            {
                                LastMachine = 12049;
                                RightUseTimes = 1;
                            }


                        }
                        #endregion
                            dbo.ExceSQL("update T_Monitor_Task set F_NumParam4= " + LastMachine + " where F_MonitorIndex= " + minMidx);
                            dbo.ExceSQL("UPDATE T_Manage_Task SET FENDDEVICE=" + LastMachine + " where FID=" + ManageTaskIdx + " and F_ManageTaskKindIndex=" + ManageKindIdx+ "");

                            return true;
                        }


                        #endregion
                        //3F_AheadDetect(⿪ر顰;)
                        if (AheadDetectOK(minMidx, _AheadDetect) == true)//ǰͨ
                        {
                            #region ˫Ѷ⣬ͬF_CorrelDoubleForkǷAheadDetectOK
                            //20100323
                            devinfo = Model.CGetInfo.GetDeviceInfo(_DeviceIdx);
                            if (devinfo.IfCorrelDoubleFork == "1")
                            {
                                if (Model.CGeneralFunction.DoubleForkIfSync(minMidx, _DeviceIdx, _DeviceKind) == true)
                                {
                                    string[] df = Model.CGeneralFunction.GetDoubleForkMonitorInfo(minMidx, _DeviceIdx);
                                    if (df != null)
                                    {
                                        if (AheadDetectOK(Convert.ToInt32(df[0]), df[1]) == false)//˫ǰʧ
                                        {
                                            return true;
                                        }
                                        #region ָǵһָܷ
                                        int rmankind = Model.CGeneralFunction.GetManageTaskKindIndexFromMonitor(Convert.ToInt32(df[0]));
                                        int rman = Model.CGeneralFunction.GetManageTaskIndexfromMonitor(Convert.ToInt32(df[0]));
                                        dv = dbo.ExceSQL("SELECT MIN(F_MonitorIndex) AS mmi FROM dbo.T_Monitor_Task WHERE (F_ManageTaskIndex = " + rman + ") AND (F_ManageTASKKINDINDEX = "+rmankind+")").Tables[0].DefaultView;
                                        if (dv.Count > 0)
                                        {
                                            if ((dv[0]["mmi"] != DBNull.Value) && (dv[0]["mmi"].ToString() != df[0]))
                                            {
                                                return true;
                                            }
                                        }
                                        #endregion
                                    }
                                    
                                }
                                else
                                {//20100406ѶȡͻʱͻǷ谭Ѷȡͻ̽Ϣ

                                }
                            }
                            #endregion

                            //ͬеĹ豸F_AssociateDeviceIndex
                            //4Ƿй豸
                            //AssociateDevice = ccf.GetAssociateDevice(minMidx);
                            if (_Associate != 0)
                            {
                                //5УҵеĹ豸豸ָ,ܷУ
                                //ظݹ鵽2
                                //split = AssociateDevice.Split(sep);
                                adidx = _Associate;
                                if (adidx != 0)
                                {
                                    if (ccf.GetAssociateMonitor(minMidx) == 0)
                                    {
                                        if (FrmControlMonitor.FormInstance.GetObjectText("tsStatus").IndexOf("豸ָ" + minMidx.ToString() + "޷ù" + adidx.ToString() + "ܷʹ") < 0)
                                        {

                                            FrmControlMonitor.FormInstance.FlashPanit("tsStatus", "豸ָ" + minMidx.ToString() + "޷ù" + adidx.ToString() + "ܷʹ", true);
                                        }
                                        return true;
                                    }
                                    if (GetFirstDeviceIFLocked(adidx, false) == false)
                                    {
                                        //6͹豸
                                        //CStaticClass.MessageIndex++;
                                        CStaticClass.MessageIndex = 1;
                                        msgIdx = (CStaticClass.MessageIndex);
                                        sdo = CommModeCreate.CreateSendDeviceOrder(_DeviceIdx);
                                        //жǷΪѶ豸
                                        bool sendok;
                                        int[] gc = new int[6] { _NumParam2, _NumParam3, _NumParam1, _NumParam5, _NumParam6, _NumParam4 }; //ccf.GetCoordinatesFromMonitorTask(adidx);//

                                        if ((_DeviceKind == 1) || (_DeviceKind == 6))
                                        {

                                            //1Ѷ4RGV6AGVҪŻȣ豸F_NeedOptimize='1'
                                            //ֱдT_Monitor_Task_Child
                                            if (ccf.NeedOptimize(_DeviceIdx) == true)
                                            {
                                                ccf.InsertMonitorOptimizeChildTask(adidx);
                                                sendok = true;
                                            }
                                            else
                                            {
                                                sendok = sdo.SendDeviceOrder(msgIdx, adidx, _DeviceOrder,
                                                    _DeviceIdx, gc[0], gc[1], gc[2], gc[3], gc[4], gc[5]);
                                            }

                                        }
                                        else if (_DeviceKind == 4)
                                        {
                                            if (ccf.NeedOptimize(_DeviceIdx) == true)
                                            {
                                                ccf.InsertMonitorOptimizeChildTask(adidx);
                                                sendok = true;
                                            }
                                            else
                                            {
                                                sendok = sdo.SendDeviceOrder(msgIdx, adidx, _DeviceOrder, _DeviceIdx, gc[2]);
                                            }

                                        }
                                        else
                                        {
                                            sendok = sdo.SendDeviceOrder(msgIdx, adidx, _DeviceOrder, _DeviceIdx, gc[5]);
                                        }
                                        if (sendok == false)
                                        {
                                            return true;
                                        }
                                        else
                                        {
                                            //8ҵ¼״̬F_StatusΪ1,豸Ϊռ״̬T_Base_deviceF_LockedState=豸ָ
                                            dbo.ExceSQL("update T_Monitor_Task set F_StartTime='" + DateTime.Now.ToString("u") + "',F_Status='1' where F_MonitorIndex=" + adidx);
                                            //dbo.ExceSQL("update T_Base_device set F_LockedState=" + adidx + " where F_DeviceIndex=" + _DeviceIdx);


                                            //صԭ豸ֵ
                                            _DeviceIdx = DeviceIdx;//豸
                                            _routeID = routeID;//·Ψһ
                                            _serialNumber = serialNumber;//·ϵ豸
                                            _ManageTaskIdx = ManageTaskIdx;//
                                            _ManageKindIdx = ManageKindIdx;//
                                            _DeviceOrder = DeviceOrder;//豸
                                            _LockedState = LockedState;
                                            _Associate = Associate;
                                            _ManTaskReserve = ManTaskReserve;
                                            _AheadDetect = AheadDetect;
                                            _NumParam1 = NumParam1;
                                            _NumParam2 = NumParam2;
                                            _NumParam3 = NumParam3;
                                            _NumParam4 = NumParam4;
                                            _NumParam5 = NumParam5;
                                            _NumParam6 = NumParam6;
                                            _TxtParam = TxtParam;
                                            _DeviceKind = DeviceKind;
                                            _OutsideAltDevice = OutsideAltDevice;
                                            _InsideAltDevice = InsideAltDevice;
                                            _StartDevice = StartDevice;
                                            _EndDevice = EndDevice;
                                            _RouteKind = RouteKind;
                                            _AgvNo = AgvNo;
                                            return false;
                                        }
                                    }
                                    else
                                    {
                                        return true;
                                    }
                                }
                                else//
                                {
                                    //صԭ豸ֵ
                                    _DeviceIdx = DeviceIdx;//豸
                                    _routeID = routeID;//·Ψһ
                                    _serialNumber = serialNumber;//·ϵ豸
                                    _ManageTaskIdx = ManageTaskIdx;//
                                    _ManageKindIdx = ManageKindIdx;//
                                    _DeviceOrder = DeviceOrder;//豸
                                    _LockedState = LockedState;
                                    _Associate = Associate;
                                    _ManTaskReserve = ManTaskReserve;
                                    _AheadDetect = AheadDetect;
                                    _NumParam1 = NumParam1;
                                    _NumParam2 = NumParam2;
                                    _NumParam3 = NumParam3;
                                    _NumParam4 = NumParam4;
                                    _NumParam5 = NumParam5;
                                    _NumParam6 = NumParam6;
                                    _TxtParam = TxtParam;
                                    _DeviceKind = DeviceKind;
                                    _OutsideAltDevice = OutsideAltDevice;
                                    _InsideAltDevice = InsideAltDevice;
                                    _StartDevice = StartDevice;
                                    _EndDevice = EndDevice;
                                    _RouteKind = RouteKind;
                                    _CControlError = "ֵõ豸ָϸ·ļĹ豸ָƥ䣬ϵͳΪûй豸ָ";
                                    return false;
                                }

                            }
                            else
                            {
                                //صԭ豸ֵ
                                _DeviceIdx = DeviceIdx;//豸
                                _routeID = routeID;//·Ψһ
                                _serialNumber = serialNumber;//·ϵ豸
                                _ManageTaskIdx = ManageTaskIdx;//
                                _ManageKindIdx = ManageKindIdx;//
                                _DeviceOrder = DeviceOrder;//豸
                                _LockedState = LockedState;
                                _Associate = Associate;
                                _ManTaskReserve = ManTaskReserve;
                                _AheadDetect = AheadDetect;
                                _NumParam1 = NumParam1;
                                _NumParam2 = NumParam2;
                                _NumParam3 = NumParam3;
                                _NumParam4 = NumParam4;
                                _NumParam5 = NumParam5;
                                _NumParam6 = NumParam6;
                                _TxtParam = TxtParam;
                                _DeviceKind = DeviceKind;
                                _OutsideAltDevice = OutsideAltDevice;
                                _InsideAltDevice = InsideAltDevice;
                                _StartDevice = StartDevice;
                                _EndDevice = EndDevice;
                                _RouteKind = RouteKind;

                                return false;
                            }
                        }
                        else
                        {
                            return true;
                        }

                    }
                    else
                    {

                        return true;

                    }
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                dv = null;
            }
        }
        /// <summary>
        /// ָ豸ִȾǷ
        /// </summary>
        /// <param name="minMidx">Ψһ</param>
        /// <returns>Ƿͨtrueʾ豸ִȾ</returns>
        public bool AheadDetectOK(int minMidx, string _AheadDetect)
        {
            //(⿪ر顰;)
            DataView dv;//20100319
            DataView dvdv;
            DataTable dt;
            try
            {

                int[] States;

                int DeviceIdx = _DeviceIdx;
                int TaskIdx = minMidx;
                int fid = ccf.GetManageTaskIndexfromMonitor(TaskIdx);
                int mti = ccf.GetManageTaskKindIndexFromMonitor(TaskIdx);
                int DeviceKind = ccf.GetDeviceKindIdx(DeviceIdx);//20100617
                //20100706
                devinfo = Model.CGetInfo.GetDeviceInfo(DeviceIdx);
                if (devinfo.CommType == "OPCClient")//20100706 ֻOPCClientͨѶ͵ļ豸״̬
                {
                     #region OPCͨѶ豸豸Ƿ
                        
                        
                        //gds = CommModeCreate.CreateGetDeviceState(DeviceIdx);
                        try
                        {
                            //States = gds.GetDeviceState(DeviceIdx, TaskIdx);//1,2,5豸
                            States = CStaticClass.GetDeviceState(DeviceIdx);

                        }
                        catch (Exception ex)
                        {
                            if (FrmControlMonitor.FormInstance.GetObjectText("tsStatus").IndexOf("ȡ״̬ʱ" + ex.Message) < 0)
                            {

                                FrmControlMonitor.FormInstance.FlashPanit("tsStatus", "ȡ״̬ʱ" + ex.Message, true);
                            }
                            return false;
                        }
                        if (States == null)//ûյκηֵ
                        {
                            if (FrmControlMonitor.FormInstance.GetObjectText("tsStatus").IndexOf("ʱǰûյPLCݣ") < 0)
                            {

                                FrmControlMonitor.FormInstance.FlashPanit("tsStatus", "ʱǰûյPLCݣ", true);
                            }
                            return false;
                        }
                        if ((States[1] == 1) || (States[1] >= 30))//л߹
                        {
                            if (States[1] >= 30)
                            {
                                devinfo = Model.CGetInfo.GetDeviceInfo(DeviceIdx);
                                int ErrId = States[1];
                                //20090910
                                //й¼Ĺ豸ţظ
                                string devstr = "SELECT F_DeviceIndex FROM T_Base_Device where F_DeviceIndex=" + DeviceIdx + " and F_ErrorTaskNo=" + TaskIdx + "";
                                dt = dbo.ExceSQL(devstr).Tables[0];
                                if (dt.Rows.Count >= 1)
                                {
                                    //dbo.ExceSQL("update T_Monitor_Task set F_Status= " + ErrId + "  where (F_MonitorIndex= " + TaskIdx + ") and ((F_Status<> " + ErrId + ") and (F_Status<> 3))");
                                    return false;
                                }
                                //¼ϵ豸ִе
                                dbo.ExceSQL("update T_Base_Device set F_ErrorTaskNo= " + TaskIdx + "  where F_DeviceIndex= " + DeviceIdx);

                                if (CStaticClass.IsEquals(devinfo.ReturnMessage, States, 2) == true) return false;

                                //if ((_DeviceKind == 2) || (_DeviceKind == 4))
                                //{//ͻ
                                //    sdo = CommModeCreate.CreateSendDeviceOrder(DeviceIdx);
                                //    sdo.SendDeviceOrder(2, 0, 0, DeviceIdx, 0);
                                //}
                                //if (_DeviceKind == 1) //ѶRGV
                                //{

                                //    sdo = CommModeCreate.CreateSendDeviceOrder(DeviceIdx);
                                //    sdo.SendDeviceOrder(2, 0, 0, DeviceIdx, 0, 0, 0, 0, 0, 0);
                                //}
                                errs = Model.CGetInfo.GetErrorInfo(Convert.ToInt32(_DeviceKind.ToString() + States[1].ToString()));
                                if (FrmControlMonitor.FormInstance.GetObjectText("tsStatus").IndexOf("豸" + DeviceIdx + "йϣ" + errs.ErrorName) < 0)
                                {

                                    FrmControlMonitor.FormInstance.FlashPanit("tsStatus", "豸" + DeviceIdx + "йϣ" + errs.ErrorName, true);
                                }
                                FrmMain.FormInstance.notifyIcon1.BalloonTipText = ":" + devinfo.DeviceName + "," + DeviceIdx + "ϣ" + errs.ErrorName;
                                FrmMain.FormInstance.notifyIcon1.ShowBalloonTip(10000, "", devinfo.DeviceName + "," + DeviceIdx + "ϣ" + errs.ErrorName, System.Windows.Forms.ToolTipIcon.Warning);
                                if (mti == 1)
                                {
                                    dboM.ExceSQL("update IO_Control set ERROR_TEXT='" + "׼ִйʱ" + devinfo.DeviceName + "," + DeviceIdx + errs.ErrorName + "' where Control_ID=" + fid);
                                }
                                dbo.ExceSQL("update T_Manage_Task set FERRORCODE='" + "׼ִйʱ" + devinfo.DeviceName + "," + DeviceIdx + errs.ErrorName + "' where F_ManageTaskKindIndex=" + mti + " and FID=" + fid);
                            }
                            return false;
                        }
                        //20110724 
                        if (devinfo.DeviceKind == 1 && States[3]== 0)//ѶΪ0ʱ
                        {
                            return false;
                        }
                        #endregion
                   
                }
                else
                {
                    //Ӽ20100319 AGVָ67AGVŲʱ1219ͳָ1220ִָлѷͣǰʧܣҪȴ

                    //if (ccf.GetDeviceOrderFromMonitor(minMidx) == 67)
                    //{
                    //    dv = dbo.ExceSQL("SELECT F_MonitorIndex FROM T_Monitor_Task WHERE (F_DeviceIndex = 1219) AND (F_DeviceCommandIndex = 6) AND (F_Status > 0)").Tables[0].DefaultView;
                    //    if (dv.Count > 0)
                    //    {
                    //        return false;
                    //    }
                    //    dv = dbo.ExceSQL("SELECT F_MonitorIndex FROM T_Monitor_Task WHERE (F_DeviceIndex = 1220) AND (F_Status > 0)").Tables[0].DefaultView;
                    //    if (dv.Count > 0)
                    //    {
                    //        return false;
                    //    }
                    //}
                }




                 #region 񵥶//20101011
                int CONTROLTASKTYPE = ccf.GetFCONTROLTASKTYPEFromManageTask(mti, fid);
                if (ccf.GetCorrel_DeviceIndex(devinfo.DeviceIndex,true) == 0)//豸Թ
                {
                    string[] CorrelInfo = ccf.GetCorrel_DeviceInfo(devinfo.DeviceIndex,true);
                    if (CorrelInfo==null) return false;
                    //20100406ⶥʱҪ⣺1102̽-110211121͵λ-11212йʱ1102̽-11022

                    if(CONTROLTASKTYPE == 1)//
                    {
                        if ((CStaticClass.GetDevicePhotoelectric(CorrelInfo[5]) == 1) )//&& (CStaticClass.GetDevicePhotoelectric(CorrelInfo[2]) == 1))//2λ(Ҫλ)
                        {
                            #region ȴ
                            //CStaticClass.DoubleForkWaitTime涨ʱڵȴ110211027תȴ
                            dv = dbo.ExceSQL("SELECT F_TaskIndex,F_DeviceIndex,F_Remark FROM T_Base_PLC_Ask WHERE (F_TaskIndex =" + TaskIdx + ") AND (F_Remark <> '') AND (F_DeviceIndex=" + devinfo.DeviceIndex + ")").Tables[0].DefaultView;
                            if (dv.Count > 0)
                            {   
                               if((Convert.ToDateTime(dv[0]["F_Remark"]).AddSeconds(Convert.ToInt32(CStaticClass.DoubleForkWaitTime)) > DateTime.Now) ||
                           //   (GetIOControlStatus(minMidx) != Model.CGeneralFunction.TASKSINGLEFORKRUN) ||
                                    ((CStaticClass.GetDevicePhotoelectric(CorrelInfo[6]) == 1) && (CStaticClass.GetDeviceRunState(int.Parse(CorrelInfo[4])) == 0)))//20110106
                                {
                                    if ((CStaticClass.GetDevicePhotoelectric(CorrelInfo[6]) == 1)
                                        && (CStaticClass.GetDeviceRunState(int.Parse(CorrelInfo[4])) == 0)
                                        && (CStaticClass.GetDevicePhotoelectric(CorrelInfo[1]) == 1))//1̽,ڸλ//20110106
                                    {
                                        //ұع˫ԣ
                                        int mfid = GetEnableDoubleForkManageTask(1, devinfo.DeviceIndex, fid);
                                        if (mfid > 0)
                                        {
                                            dbo.ExecuteSql("update T_Manage_Task set F_RELATIVECONTORLID=" + mfid + " where F_ManageTaskKindIndex=" + mti + " and FID=" + fid);
                                            dbo.ExecuteSql("update T_Manage_Task set FUseAwayFork='0',F_RELATIVECONTORLID=" + fid + " where F_ManageTaskKindIndex=" + mti + " and FID=" + mfid);
                                            dbo.ExecuteSql("update T_Monitor_Task set F_UseAwayFork='0' where F_ManageTASKKINDINDEX=" + mti + " and F_ManageTaskIndex=" + mfid + "");
                                            //Ѿ·һԶķԭҪĵ
                                            AlterRoutePath(mti, mfid, CONTROLTASKTYPE, '0', devinfo.DeviceIndex);
                                            return true;
                                        }
                                        return false;
                           
                                    }
                                    else
                                    {
                                        return false;
                                    }
                                }
                                else
                                {//ȴʱ߹ǿִе
                                    if (CStaticClass.GetDeviceRunState(int.Parse(CorrelInfo[4])) == 1)//20110106
                                    {
                                        string dtime = DateTime.Now.ToString("u");
                                        dtime = dtime.Substring(0, dtime.Length - 1);
                                        dbo.ExecuteSql("update T_Base_PLC_Ask set F_Remark='" + dtime + "' where (F_DeviceIndex=" + devinfo.DeviceIndex + ")");
                                        //20110108
                                        dbo.ExecuteSql("update T_Monitor_Task set F_UseAwayFork='1' where F_ManageTASKKINDINDEX=" + mti + " and F_ManageTaskIndex=" + fid + "");
                                        dbo.ExecuteSql("update T_Manage_Task set FUseAwayFork='1' where F_ManageTASKKINDINDEX=" + mti + " and FID=" + fid + "");
                  
                                        return false;
                                    }
                                   //ȴʱ
                                    dbo.ExecuteSql("update T_Base_PLC_Ask set F_TaskIndex=0,F_Remark='' where (F_DeviceIndex=" + devinfo.DeviceIndex + ")");
                                   //20110108
                                    dbo.ExecuteSql("update T_Monitor_Task set F_UseAwayFork='1' where F_ManageTASKKINDINDEX=" + mti + " and F_ManageTaskIndex=" + fid + "");
                                    dbo.ExecuteSql("update T_Manage_Task set FUseAwayFork='1' where F_ManageTASKKINDINDEX=" + mti + " and FID=" + fid + "");
                                    dboM.ExceSQL("update IO_Control set CONTROL_STATUS=" + Model.CGeneralFunction.TASKSINGLEFORKRUN + " where CONTROL_ID=" + fid);

                                    return true;

                                }
                            }
                            else//20101220ʼ¼2б俪ʼȴʱ
                            {
                                dv = dbo.ExceSQL("SELECT F_TaskIndex,F_DeviceIndex,F_Remark FROM T_Base_PLC_Ask WHERE (F_TaskIndex =0) AND (F_Remark = '') AND (F_DeviceIndex=" + devinfo.DeviceIndex + ")").Tables[0].DefaultView;
                                if (dv.Count > 0)
                                {
                                    string dtime = DateTime.Now.ToString("u");
                                    dtime = dtime.Substring(0, dtime.Length - 1);
                                    dbo.ExecuteSql("update T_Base_PLC_Ask set F_TaskIndex=" + TaskIdx + ",F_Remark='" + dtime + "' where (F_DeviceIndex=" + devinfo.DeviceIndex + ")");
                                    dbo.ExecuteSql("update T_Monitor_Task set F_UseAwayFork='1' where F_ManageTASKKINDINDEX=" + mti + " and F_ManageTaskIndex=" + fid + "");
                                    dbo.ExecuteSql("update T_Manage_Task set FUseAwayFork='1' where F_ManageTASKKINDINDEX=" + mti + " and FID=" + fid + "");
                                    //Ѿ·һԶķԭҪĵ
                                    AlterRoutePath(mti, fid, CONTROLTASKTYPE, '1', devinfo.DeviceIndex);
                                    return false;
                                }
                                else//20110401
                                {
                                    dv = dbo.ExceSQL("SELECT FID,F_RELATIVECONTORLID FROM T_Manage_Task where F_RELATIVECONTORLID=-1 and F_ManageTaskKindIndex=" + mti + " and FID=" + fid+"").Tables[0].DefaultView;
                                if(dv.Count>0)
                                {
                                    if (CStaticClass.GetDevicePhotoelectric(CorrelInfo[6]) == 1)//1лִе
                                    {
                                      return false;
                                    }
                                }
                                }
                            }

                            #endregion
                        }
                        else
                        {
                            return false;
                        }
                    }
                    else
                    if (CONTROLTASKTYPE == 2)//´վ̨ͳָʱж1л2λл״̬
                    {
                        if ((CStaticClass.GetDevicePhotoelectric(CorrelInfo[5]) == 0) && (CStaticClass.GetDevicePhotoelectric(CorrelInfo[6]) == 0))
                        {
                            return false ;
                        }
                    }

                }

                #endregion
                #region ǰϢ
                if ((_AheadDetect != "") && (_AheadDetect != null))
                {


                    char[] cc = new char[1];
                    cc[0] = ';';
                    string[] AheadDetect = _AheadDetect.Split(cc);
                    char[] dd = new char[1] { '.' };//20101118
                    string[] DS;

                    //ͨ๤IGetDeviceState
                    //IGetDeviceState GDS;
                    int s = 0;
                    //int[] sss;
                    int fs = 1;
                    //int[] fsss;
                    //ȡ翪ֵ
                    for (int i = AheadDetect.GetLowerBound(0); i <= AheadDetect.GetUpperBound(0); i++)
                    {
                        if (AheadDetect[i].Trim().Length <= 0) continue;
                        if (AheadDetect[i].Trim().Substring(0, 1).ToUpper() == "H")//߼̽
                        {
                            DeviceKind = ccf.GetDeviceKindIdx(Convert.ToInt32(AheadDetect[i].Trim().Substring(1)));
                            if (DeviceKind == 9)
                            {//̨Ҫӹ豸ȡ
                                if (dboM.ExceSQL("SELECT FID FROM T_ITEMDEVICESTATION WHERE (FCODE = '" + AheadDetect[i].Trim().Substring(1) + "') AND (FSTATUS = '1002')").Tables[0].DefaultView.Count > 0)
                                {
                                    fs = fs & 1;
                                }
                                else
                                {
                                    fs = fs & 0;
                                }
                            }
                            else
                            {
                                //豸ȡ
                                dvdv = dbo.ExceSQL("SELECT F_DeviceIndex, F_HaveGoods FROM T_Base_Device where F_DeviceIndex=" +
                                    Convert.ToInt32(AheadDetect[i].Trim().Substring(1)) + "").Tables[0].DefaultView;
                                if (dvdv.Count > 0)
                                {
                                    fs = fs & Convert.ToInt32(dvdv[0]["F_HaveGoods"]);
                                }
                            }
                            continue;
                        }
                        if (AheadDetect[i].Trim().Substring(0, 1).ToUpper() == "N")//߼̽
                        {
                            DeviceKind = ccf.GetDeviceKindIdx(Convert.ToInt32(AheadDetect[i].Trim().Substring(1)));
                            if (DeviceKind == 9)
                            {//̨Ҫӹ豸ȡ;20101028ƻ̨վ̨Ƿ
                                //if (dboM.ExceSQL("SELECT FID FROM T_ITEMDEVICESTATION WHERE (FCODE = '" + AheadDetect[i].Trim().Substring(1) + "') AND (FSTATUS = '1002')").Tables[0].DefaultView.Count > 0)
                                //{
                                //    fs = fs & 1;
                                //}
                                //else
                                //{
                                //    fs = fs & 0;
                                //}
                            }
                            else
                            {
                                //豸ȡ
                                dvdv = dbo.ExceSQL("SELECT F_DeviceIndex, F_HaveGoods FROM T_Base_Device where  F_DeviceIndex=" +
                                    Convert.ToInt32(AheadDetect[i].Trim().Substring(1)) + "").Tables[0].DefaultView;
                                if (dvdv.Count > 0)
                                {
                                    s = s + Convert.ToInt32(dvdv[0]["F_HaveGoods"]);
                                }
                            }
                            continue;
                        }
                        //20090803豸Ƿidle
                        if (AheadDetect[i].Trim().Substring(0, 1).ToUpper() == "I")//豸Ƿidle
                        {
                            States = CStaticClass.GetDeviceState(Convert.ToInt32(AheadDetect[i].Trim().Substring(1)));

                            if (States != null)
                            {
                                s = s + States[1];
                            }
                            continue;
                        }

                        #region 20101118豸ź

                        //豸ĹźţD-12001.0ʾͻ12001ڿD12001.1ʾͻ12001ڿ
                        //D-12001.2ʾͻ12001ĶλߵλD12001.3ʾͻ12001Ķڵλǵ͵λ
                        if (AheadDetect[i].Trim().Substring(0, 1).ToUpper() == "D")
                        {
                            DS = AheadDetect[i].Trim().Substring(1).Split(dd);
                            int devicebyte = 0; int devbit = 0;
                            int.TryParse(DS[0], out devicebyte);
                            int.TryParse(DS[1], out devbit);
                            //жǷ⸺ֵǷ㿪ִǰᣩ
                            if (devicebyte < 0)
                            {
                                //ͨѶӿڻùĿ
                                //GDS = CommModeCreate.CreateGetDeviceState(-Convert.ToInt32(AheadDetect[i]));+

                                //fsss = GDS.GetDeviceState(-Convert.ToInt32(AheadDetect[i]), Convert.ToInt32(dvD[0]["F_MonitorIndex"]));
                                int fsn = CStaticClass.GetDevicePhotoelectric(-devicebyte, devbit);
                                //if (fsss == null)
                                //{
                                //    this._CControlError = GDS.CommLayerError;
                                //    return false;
                                //}
                                if (fsn == -1)//20101220
                                {
                                    return false;
                                }
                                fs = fs & fsn;
                            }
                            else
                            {//ΪĿ
                                //ͨѶӿڻùĿ
                                //GDS = CommModeCreate.CreateGetDeviceState(Convert.ToInt32(AheadDetect[i]));
                                //sss = GDS.GetDeviceState(Convert.ToInt32(AheadDetect[i]), Convert.ToInt32(dvD[0]["F_MonitorIndex"]));
                                int sssn = CStaticClass.GetDevicePhotoelectric(devicebyte, devbit);
                                //if (sss == null)
                                //{
                                //    this._CControlError = GDS.CommLayerError;
                                //    return false;
                                //}
                                if (sssn == -1)//20101220
                                {
                                    return false;
                                }
                                s = s + sssn;
                            }
                        }

                        #endregion

                    }
                    if ((s == 0) && (fs == 1))
                    {
                        //if (CStaticClass.AGVAllowSingleFork == "0")//20100710
                        //{
                        //    #region AGVȡͻĵһ񣬼ͻǷִ
                        //    //һżһ
                        //    string[] outstation = new string[4] { "2241", "2242", "3241", "3242" };
                        //    if ((Array.IndexOf(outstation, DeviceIdx.ToString()) >= 0) && (Model.CGeneralFunction.GetDoubleForkMonitorInfo(TaskIdx, DeviceIdx) == null))
                        //    {
                        //        if ((DeviceIdx % 2) == 0)
                        //        {
                        //            dvdv = dbo.ExceSQL("SELECT F_MonitorIndex FROM T_Monitor_Task WHERE F_DeviceIndex = " + (DeviceIdx - 1) + " AND F_Status > 0").Tables[0].DefaultView;
                        //            if (dvdv.Count > 0)
                        //            {
                        //                return false;
                        //            }
                        //            if (CStaticClass.GetDevicePhotoelectric(ccf.GetBindingDeviceIndexOut(DeviceIdx - 1)) == 1)
                        //            {
                        //                return false;
                        //            }
                        //        }
                        //        else
                        //        {
                        //            dvdv = dbo.ExceSQL("SELECT F_MonitorIndex FROM T_Monitor_Task WHERE F_DeviceIndex = " + (DeviceIdx + 1) + " AND F_Status > 0").Tables[0].DefaultView;
                        //            if (dvdv.Count > 0)
                        //            {
                        //                return false;
                        //            }
                        //            if (CStaticClass.GetDevicePhotoelectric(ccf.GetBindingDeviceIndexOut(DeviceIdx + 1)) == 1)
                        //            {
                        //                return false;
                        //            }
                        //        }
                        //    }
                        //    #endregion
                        //}
                        //return true;//20101011
                    }
                    else
                    {
                        return false;
                    }

                }
                else
                {
                    //豸ûǰ⿪
                    //return true;//20101011

                }
                                #endregion
                //20101011
                #region ˫ѶȡڴжǷ˫桢֤˫ǷΪ˫漫޻λ
                if ((devinfo.DeviceKind == 1) && (devinfo.IfCorrelDoubleFork == "1") && (ccf.GetDeviceOrderFromMonitor(minMidx) == 4) && (CONTROLTASKTYPE == 1))
                {
                    string[] CorrelInfo = ccf.GetCorrel_DeviceInfo(minMidx);
                    if (CorrelInfo == null) return false;

                    string[] corrinfo=Model.CGeneralFunction.GetDoubleForkMonitorInfo(minMidx, devinfo.DeviceIndex);
                    
                    if (corrinfo == null)
                    {
                      int IfCorrel = ccf.GetCorrel_DeviceIndex(minMidx);
                      if (IfCorrel == 0)//ѶִеʱҪж1޻20110108
                      {

                          if (CStaticClass.GetDevicePhotoelectric(CorrelInfo[6]) != 0)
                          {

                              return false;
                          }
                          //20110108
                          dbo.ExecuteSql("update T_Monitor_Task set F_UseAwayFork='1' where F_ManageTASKKINDINDEX=" + mti + " and F_ManageTaskIndex=" + fid + "");
                          dbo.ExecuteSql("update T_Manage_Task set FUseAwayFork='1' where F_ManageTASKKINDINDEX=" + mti + " and FID=" + fid + "");
         
                          //漫޻λж
                          string ChangeForkCell = IfLimitCellChangeFork(minMidx);
                          if (ChangeForkCell != "-")//Ҫ
                          {
                              ChangeEndCellCode(minMidx, ChangeForkCell, devinfo.DeviceIndex);
                          }

                      }
                       
                        #region ˫Եվ̨ĵڴ˵ȴ˫漫޻λ
                        else if (IfCorrel> 0)
                        {
                            //string[] CorrelInfo = ccf.GetCorrel_DeviceInfo(minMidx);
                            //if (CorrelInfo == null) return false;
                           
                            if(CStaticClass.GetDevicePhotoelectric(int.Parse(CorrelInfo[5])) == 1)
                            {
                                dv = dbo.ExceSQL("SELECT F_TaskIndex,F_DeviceIndex,F_Remark FROM T_Base_PLC_Ask WHERE (F_TaskIndex =" + TaskIdx + ") AND (F_Remark <> '') AND (F_DeviceIndex=" + CorrelInfo[0] + ")").Tables[0].DefaultView;
                                if (dv.Count > 0)
                                {
                                    CorrelInfo = ccf.GetCorrelOther_DeviceInfo(Convert.ToInt32(CorrelInfo[8]));//վ̨Ϣ
                                    //(Convert.ToDateTime(dv[0]["F_Remark"]).AddSeconds(Convert.ToInt32(CStaticClass.DoubleForkWaitTime)) > DateTime.Now)
                                    if ((GetIOControlStatus(TaskIdx) != Model.CGeneralFunction.TASKSINGLEFORKRUN)
                                       || ((CStaticClass.GetDevicePhotoelectric(int.Parse(CorrelInfo[5])) == 1)) && (CStaticClass.GetDeviceRunState(int.Parse(CorrelInfo[4])) == 0))//20110106
                                    {//ûʱ߽
                                        if ((CStaticClass.GetDevicePhotoelectric(int.Parse(CorrelInfo[5])) == 1)//
                                            && (CStaticClass.GetDeviceRunState(int.Parse(CorrelInfo[4])) == 0))////20110106
                                        {
                                            //ұع˫ԣ
                                            int mfid = GetEnableDoubleForkManageTask(1,devinfo.DeviceIndex, int.Parse(CorrelInfo[0]), fid);
                                            if (mfid > 0)
                                            {
                                                #region ˫ͬΪǰ޺ߺ޲ִ
                                                if ((IfInSameLimitX(fid, mfid,mti) == true) && (mti == 1))
                                                {
                                                    dboM.ExecuteSql(" update IO_CONTROL set CONTROL_STATUS=" + Model.CGeneralFunction.TASKSINGLEFORKRUN + " WHERE (CONTROL_ID = " + fid + ")");
                                                    dboM.ExecuteSql(" update IO_CONTROL set CONTROL_STATUS=" + Model.CGeneralFunction.TASKSINGLEFORKRUN + " WHERE (CONTROL_ID = " + mfid + ")");
                                                    return true;
                                                }
                                                #endregion
                                                dbo.ExecuteSql("update T_Manage_Task set F_RELATIVECONTORLID=" + mfid + " where F_ManageTaskKindIndex=" + mti + " and FID=" + fid);
                                                dbo.ExecuteSql("update T_Manage_Task set F_RELATIVECONTORLID=" + fid + " where F_ManageTaskKindIndex=" + mti + " and FID=" + mfid);
                                                return false;
                                            }
                                            else
                                            {
                                                return false;
                                            }
                                            
                                        }
                                        else
                                        {
                                            return false;
                                        }
                                    }
                                    else
                                    {//ȴʱ߹ǿִе
                                        if (CStaticClass.GetDeviceRunState(int.Parse(CorrelInfo[4])) == 1)//20110106
                                        {//ڶԵͻУ¼ʱ
                                            string dtime = DateTime.Now.ToString("u");
                                            dtime = dtime.Substring(0, dtime.Length - 1);
                                            dbo.ExecuteSql("update T_Base_PLC_Ask set F_Remark='" + dtime + "' where (F_DeviceIndex=" + int.Parse(CorrelInfo[0]) + ")");
                                            return false;
                                        }
                                        else
                                        {//ʱ߹ǿִе
                                            dbo.ExecuteSql("update T_Base_PLC_Ask set F_TaskIndex=0,F_Remark='' where (F_DeviceIndex=" + int.Parse(CorrelInfo[0]) + ")");
                                            return true;
                                        }

                                    }
                                }
                                else
                                {
                                    dv = dbo.ExceSQL("SELECT F_TaskIndex,F_DeviceIndex,F_Remark FROM T_Base_PLC_Ask WHERE (F_TaskIndex =0) AND (F_Remark = '') AND (F_DeviceIndex=" + int.Parse(CorrelInfo[0]) + ")").Tables[0].DefaultView;
                                    if (dv.Count > 0)
                                    {
                                        string dtime = DateTime.Now.ToString("u");
                                        dtime = dtime.Substring(0, dtime.Length - 1);
                                        dbo.ExecuteSql("update T_Base_PLC_Ask set F_TaskIndex=" + TaskIdx + ",F_Remark='" + dtime + "' where (F_DeviceIndex=" + int.Parse(CorrelInfo[0]) + ")");
                                        
                                        return false;
                                    }
                                
                                }
                           
                            }
                        }

                        #endregion
                    }
                    else
                    {
                        #region ˫ڴ֤ǷΪ˫漫޻λ˫޻λʹ˫浹λ޸
                        //ѵλΪȡͻĿλȡͻڵλ߼ǰ
                        //浹λʱ׷ӵλ---Ҫļ޻λȡͻ
                        if (CStaticClass.GetDevicePhotoelectric(CorrelInfo[6]) == 0)//˫Ҫж1л20110108
                        {

                            return false;
                        }

                        #region Լ
                        string ChangeForkCell = IfLimitCellChangeFork(minMidx);
                        
                        #endregion
                        #region 
                        string ChangeForkCell1 = IfLimitCellChangeFork(int.Parse(corrinfo[0]));
                        
                        #endregion
                        if ((ChangeForkCell != "-") && (ChangeForkCell1 != "-"))
                        {//͹Ҫ棬޸Ļλ

                        }
                        else if ((ChangeForkCell != "-")&& (ChangeForkCell1 == "-"))//Ҫ
                        {
                            ChangeEndCellCode(minMidx, ChangeForkCell, devinfo.DeviceIndex);
                        }
                        else if ((ChangeForkCell1 != "-") && (ChangeForkCell == "-"))//Ҫ
                        {
                            ChangeEndCellCode(int.Parse(corrinfo[0]), ChangeForkCell1, devinfo.DeviceIndex);
                        }
                        #endregion
                    }

                    

                    
                }
                #endregion

                #region ˫AGVȡڴжǷ˫桢֤˫ǷΪ˫漫޻λ

                //if ((devinfo.DeviceKind == 6) && (devinfo.IfCorrelDoubleFork == "1") && (ccf.GetDeviceOrderFromMonitor(minMidx) == 1) && (CONTROLTASKTYPE == 1))
                //{

                //    string[] corrinfo = Model.CGeneralFunction.GetDoubleForkMonitorInfo(minMidx, devinfo.DeviceIndex);

                //    if (corrinfo == null)
                //    {
                //        #region ˫Եվ̨ĵڴ˵ȴ˫漫޻λ
                //        if (GetIOControlStatus(TaskIdx) != Model.CGeneralFunction.TASKSINGLEFORKRUN)
                //        {//ûǿƵִ
                            
                //            //ҹվ̨
                //            int agvCorrel = GetAGVCorrelIndex(TaskIdx);
                //            if (agvCorrel != -1)
                //            {
                //                //ұع˫ԣ
                //                int mfid = GetAGVEnableDoubleForkManageTask(1,agvCorrel);
                //                if (mfid > 0)
                //                {
                //                    #region ˫ͬΪǰ޺ߺ޲ִ
                //                    if ((IfInSameLimitX(fid, mfid,mti) == true) && (mti==1))
                //                    {
                //                        dboM.ExecuteSql(" update IO_CONTROL set CONTROL_STATUS="+Model.CGeneralFunction.TASKSINGLEFORKRUN+" WHERE (CONTROL_ID = "+fid+")");
                //                        dboM.ExecuteSql(" update IO_CONTROL set CONTROL_STATUS=" + Model.CGeneralFunction.TASKSINGLEFORKRUN + " WHERE (CONTROL_ID = " + mfid + ")");
                //                        return true;
                //                    }
                //                    #endregion
                //                    dbo.ExecuteSql("update T_Manage_Task set F_RELATIVECONTORLID=" + mfid + " where F_ManageTaskKindIndex=" + mti + " and FID=" + fid);
                //                    dbo.ExecuteSql("update T_Manage_Task set F_RELATIVECONTORLID=" + fid + " where F_ManageTaskKindIndex=" + mti + " and FID=" + mfid);
                //                    return true;
                //                }

                //                else
                //                    return false;
                //            }
                //            else
                //                return true ;
                //        }
                //        else
                //        {//ǿִе
                //            return true;

                //        }
                        

                //        #endregion
                //    }

                //}
                #endregion




                #region ˫ж 
                int StartDevice = _StartDevice;//ǰ
                int EndDevice = _EndDevice;//ǰյ
                int DeviceOrder = _DeviceOrder;//豸

                int END = 12604;
                string sqlstr = string.Empty;

                #region Ѷִгʱж϶ѶִгȡָʱжǷͻǷ޻
                if (DeviceIdx == 11005 && DeviceOrder == 4 && CONTROLTASKTYPE == 2 && EndDevice == END)//
                { //
                    string checkdevice = "12603;12604";
                    int freecount = ccf.GetTransDeviceGoodsCounts(checkdevice);
                    if (freecount > 0)
                    {
                        return false;
                    }

                    sqlstr = string.Format("SELECT FID  FROM T_Manage_Task WHERE  FCONTROLTASKTYPE=1  and  FSTARTDEVICE ={0}", END);
                    dv = dbo.ExceSQL(sqlstr).Tables[0].DefaultView;
                    if (dv.Count > 0)
                    {
                        return false;
                    }



                } 
                #endregion
                #region ͻִʱж
                if (DeviceIdx == END && DeviceOrder == 6 && CONTROLTASKTYPE == 1)//
                { 
                    //гִ
                    sqlstr = string.Format("SELECT FID  FROM T_Manage_Task WHERE  FCONTROLTASKTYPE=2  and FSTATUS > 0  and  FENDDEVICE ={0}", END);
                    dv = dbo.ExceSQL(sqlstr).Tables[0].DefaultView;
                    if (dv.Count > 0)
                    {
                        return false;
                    }



                }
                #endregion
                #endregion

                return true;//20101011


            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                dv = null;
                dt = null;
                dvdv = null;
            }
        }

        /// <summary>
        /// ÷Ϣ
        /// </summary>
        /// <param name="minMidx">豸ָ</param>
        public bool  GetSendInfo(int minMidx)
        {
            DataView dvD ;
            try
            {
                
                string strD = "";
                strD = "SELECT F_DeviceKindIndex,F_NumParam1,F_NumParam2,F_NumParam3,F_NumParam4," +
                    "F_NumParam5,F_NumParam6,F_TxtParam,F_AheadDetect,F_ManTaskReserve,F_LockedState," +
                    "F_Associate,F_SerialNumber,F_RouteID,F_DeviceIndex,F_DeviceCommandIndex," +
                    "F_MonitorIndex,F_ManageTaskIndex,F_ManageTaskKindIndex,F_OutsideAltDevice," +
                    "F_InsideAltDevice,F_StartDevice,F_EndDevice,F_RouteKind,F_CorrelDoubleFork,F_UseAwayFork,F_AgvNo " +
                    " FROM  V_Monitor_Route_Device where F_MonitorIndex=" + minMidx;
                dvD = dbo.ExceSQL(strD).Tables[0].DefaultView;

                if (dvD.Count > 0)
                {
                    if (dvD[0]["F_AheadDetect"] != DBNull.Value)
                    {
                        _AheadDetect = dvD[0]["F_AheadDetect"].ToString();
                    }
                    else
                    {
                        _AheadDetect = "";
                    }
                    if (dvD[0]["F_ManTaskReserve"] != DBNull.Value)
                    {
                        _ManTaskReserve = Convert.ToInt32(dvD[0]["F_ManTaskReserve"]);
                    }
                    else
                    {
                        _ManTaskReserve = 0;
                    }
                    if (dvD[0]["F_Associate"] != DBNull.Value)
                    {
                        _Associate = Convert.ToInt32(dvD[0]["F_Associate"]);
                    }
                    else
                    {
                        _Associate = 0;
                    }
                    if (dvD[0]["F_LockedState"] != DBNull.Value)
                    {
                        _LockedState = Convert.ToInt32(dvD[0]["F_LockedState"]);
                    }
                    else
                    {
                        _LockedState = 0;
                    }
                    if (dvD[0]["F_NumParam1"] != DBNull.Value)
                    {
                        _NumParam1 = Convert.ToInt32(dvD[0]["F_NumParam1"]);
                    }
                    else
                    {
                        _NumParam1 = 0;
                    }
                    if (dvD[0]["F_NumParam2"] != DBNull.Value)
                    {
                        _NumParam2 = Convert.ToInt32(dvD[0]["F_NumParam2"]);
                    }
                    else
                    {
                        _NumParam2 = 0;
                    }
                    if (dvD[0]["F_NumParam3"] != DBNull.Value)
                    {
                        _NumParam3 = Convert.ToInt32(dvD[0]["F_NumParam3"]);
                    }
                    else
                    {
                        _NumParam3 = 0;
                    }
                    if (dvD[0]["F_NumParam4"] != DBNull.Value)
                    {
                        _NumParam4 = Convert.ToInt32(dvD[0]["F_NumParam4"]);
                    }
                    else
                    {
                        _NumParam4 = 0;
                    }
                    if (dvD[0]["F_NumParam5"] != DBNull.Value)
                    {
                        _NumParam5 = Convert.ToInt32(dvD[0]["F_NumParam5"]);
                    }
                    else
                    {
                        _NumParam5 = 0;
                    }
                    if (dvD[0]["F_NumParam6"] != DBNull.Value)
                    {
                        _NumParam6 = Convert.ToInt32(dvD[0]["F_NumParam6"]);
                    }
                    else
                    {
                        _NumParam6 = 0;
                    }
                    if (dvD[0]["F_TxtParam"] != DBNull.Value)
                    {
                        _TxtParam = dvD[0]["F_TxtParam"].ToString();
                    }
                    else
                    {
                        _TxtParam = "-";
                    }
                    _serialNumber = Convert.ToInt32(dvD[0]["F_SerialNumber"]);
                    _routeID = Convert.ToInt32(dvD[0]["F_RouteID"]);
                    _DeviceIdx = Convert.ToInt32(dvD[0]["F_DeviceIndex"]);
                    _DeviceOrder = Convert.ToInt32(dvD[0]["F_DeviceCommandIndex"]);
                    _ManageKindIdx = Convert.ToInt32(dvD[0]["F_ManageTaskKindIndex"]);
                    _ManageTaskIdx = Convert.ToInt32(dvD[0]["F_ManageTaskIndex"]);
                    _DeviceKind = Convert.ToInt32(dvD[0]["F_DeviceKindIndex"]);
                    if (dvD[0]["F_OutsideAltDevice"] != DBNull.Value)
                    {
                        _OutsideAltDevice = Convert.ToInt32(dvD[0]["F_OutsideAltDevice"]);
                    }
                    else 
                    {
                        _OutsideAltDevice = 0;
                    }
                    if (dvD[0]["F_InsideAltDevice"] != DBNull.Value)
                    {
                        _InsideAltDevice = Convert.ToInt32(dvD[0]["F_InsideAltDevice"]);
                    }
                    else
                    {
                        _InsideAltDevice = 0;
                    }
                    _StartDevice = Convert.ToInt32(dvD[0]["F_StartDevice"]);
                    _EndDevice = Convert.ToInt32(dvD[0]["F_EndDevice"]);
                    _RouteKind = Convert.ToInt32(dvD[0]["F_RouteKind"]);
                    if (dvD[0]["F_CorrelDoubleFork"] != DBNull.Value)
                    {
                        _CorrelDoubleFork = Convert.ToInt32(dvD[0]["F_CorrelDoubleFork"]);
                    }
                    else
                    {
                        _CorrelDoubleFork = -1;
                    }
                    if (dvD[0]["F_AgvNo"] != DBNull.Value)
                    {
                        _AgvNo = Convert.ToInt32(dvD[0]["F_AgvNo"]);
                    }
                    else
                    {
                        _AgvNo = 65535;
                    }
                    return true;
                }
                else
                {
                    return false;
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                dvD = null;
            }
        }
        /// <summary>
        /// ָŵ
        /// </summary>
        /// <param name="MonitorIndex"></param>
        /// <returns></returns>
        public bool SendMonitorTask(int MonitorIndex)
        {
            
            lock (thisLock)
            {
                char[] sep = new char[1] { '-' };
                int msgIdx = 0;//Ϣ
                bool sendok;
                //string aa222 = DateTime.Now.Second.ToString() + "-" + DateTime.Now.Millisecond.ToString();
                #region ˫豸ָִͬУ;Ѷǰλý豸ָ
                MonitorIndex = GetDoubleForkMinRouteTask(MonitorIndex);
                #endregion
                //string aa22 = DateTime.Now.Second.ToString() + "-" + DateTime.Now.Millisecond.ToString();
                //Ҫ͵Ϣ
               // 20121014
                if (GetSendInfo(MonitorIndex) == false) { return false; }

                #region ֹ

                if (ccf.GetManageTaskKindIndexFromMonitor(MonitorIndex) == 4)
                {
                    //20120915
                   // if (AheadDetectOK(MonitorIndex, ccf.GetBeDetectedDevices(_DeviceIdx)) == false) 
                    if (AheadDetectOK(MonitorIndex, ccf.GetBeDetectedDevices(_DeviceIdx)) == false) //
                    {
                        return false;
                    }

                    //CStaticClass.MessageIndex++;
                    CStaticClass.MessageIndex = 1;
                    msgIdx = (CStaticClass.MessageIndex);

                    sdo = CommModeCreate.CreateSendDeviceOrder(_DeviceIdx);

                    int[] gc = new int[6] {_NumParam2, _NumParam3, _NumParam1, _NumParam5, _NumParam6, _NumParam4 };

                    if ((_DeviceKind == 1) || (_DeviceKind == 6))
                    {

                        sendok = sdo.SendDeviceOrder(msgIdx, MonitorIndex, _DeviceOrder,
                            _DeviceIdx, gc[0], gc[1], gc[2], gc[3], gc[4], gc[5]);
                       // CommonClassLib.CCarryConvert.WriteDarkCasket("send", "1111", _DeviceIdx.ToString(), "------");

                    }
                    else if (_DeviceKind == 4)
                    {
                        if (ccf.NeedOptimize(_DeviceIdx) == true)
                        {
                            ccf.InsertMonitorOptimizeChildTask(MonitorIndex);
                            sendok = true;
                        }
                        else
                        {

                            sendok = sdo.SendDeviceOrder(msgIdx, MonitorIndex, _DeviceOrder, _DeviceIdx, gc[2]);
                        }

                    }
                    else
                    {


                        sendok = sdo.SendDeviceOrder(msgIdx, MonitorIndex, _DeviceOrder, _DeviceIdx, gc[5]);
                    }
                    if (sendok == false)
                    {
                        if (sdo.CommLayerError != null)
                        {
                            if (FrmControlMonitor.FormInstance.GetObjectText("tsStatus").IndexOf(sdo.CommLayerError) < 0)
                            {
                                FrmControlMonitor.FormInstance.FlashPanit("tsStatus", sdo.CommLayerError, true);

                            }
                        }
                        return false;
                    }
                    else
                    {
                        //////////////////////////
                        ccf.SendOrderSuccess(_ManageKindIdx, _ManageTaskIdx, MonitorIndex, _DeviceIdx, _routeID);
                        #region ˫ͬͬʱ淢ɹ
                        //20100323
                        devinfo = Model.CGetInfo.GetDeviceInfo(_DeviceIdx);
                        if (devinfo.IfCorrelDoubleFork == "1")
                        {
                            if (Model.CGeneralFunction.DoubleForkIfSync(MonitorIndex, _DeviceIdx, _DeviceKind) == true)
                            {
                                string[] df = Model.CGeneralFunction.GetDoubleForkMonitorInfo(MonitorIndex, _DeviceIdx);
                                if (df != null)
                                {
                                    ccf.SendOrderSuccess(ccf.GetManageTaskKindIndexFromMonitor(Convert.ToInt32(df[0])), ccf.GetManageTaskIndexfromMonitor(Convert.ToInt32(df[0])), Convert.ToInt32(df[0]), Convert.ToInt32(df[2]), Convert.ToInt32(df[3]));
                                    //dbo.ExceSQL("update T_Monitor_Task set F_CorrelDoubleFork=" + df[0] + " where F_MonitorIndex=" + MonitorIndex + "");
                                    //dbo.ExceSQL("update T_Monitor_Task set F_CorrelDoubleFork=" + MonitorIndex + " where F_MonitorIndex=" + df[0] + "");
                                }
                            }
                        }
                        #endregion
                        return true;
                    }

                }

                #endregion

                #region Զ(taskkind == 12)
                //(taskkind == 12)Զʱ
                ///////////////////////////////////////
                //2--6Ӧݹú
                ///////////////////////////////////////
                /////////////////////
                //20100208
                #region δRGV䳵޸ǰ

                #endregion
                ////////////////////


                //2ȡÿݵĵһ豸״̬
                //string aa221 = DateTime.Now.Second.ToString() + "-" + DateTime.Now.Millisecond.ToString();

                if (GetFirstDeviceIFLocked(MonitorIndex, true) == false)//ûб
                {
                  
                    
                    //7ʹ豸
                    //CStaticClass.MessageIndex++;
                    CStaticClass.MessageIndex = 1;
                    msgIdx = (CStaticClass.MessageIndex);
                    sdo = CommModeCreate.CreateSendDeviceOrder(_DeviceIdx);
                    //ж豸ǷΪѶRGVͣǣ
                    int[] gc = new int[6] { _NumParam2, _NumParam3, _NumParam1, _NumParam5, _NumParam6, _NumParam4 };//
                    if (gc == null)
                    {
                        this._CControlError += "ʱȡ豸꣡";
                        return false;
                    }
                    if ((_DeviceKind == 1) || (_DeviceKind == 6))
                    {

                        //1Ѷ4RGV6AGVҪŻȣ豸F_NeedOptimize='1'
                        //ֱдT_Monitor_Task_Child
                        if (ccf.NeedOptimize(_DeviceIdx) == true)
                        {
                            ccf.InsertMonitorOptimizeChildTask(MonitorIndex);
                            sendok = true;
                        }
                        else
                        {
                            sendok = sdo.SendDeviceOrder(msgIdx, MonitorIndex, _DeviceOrder,
                                _DeviceIdx, gc[0], gc[1], gc[2], gc[3], gc[4], gc[5]);
                        }


                    }
                    else if (_DeviceKind == 4) // RGV
                    {
                        if (ccf.NeedOptimize(_DeviceIdx) == true)
                        {
                            ccf.InsertMonitorOptimizeChildTask(MonitorIndex);
                            sendok = true;
                        }
                        else
                        {
                            sendok = sdo.SendDeviceOrder(msgIdx, MonitorIndex, _DeviceOrder, _DeviceIdx, gc[2]);
                        }

                    }
                    else
                    {
                        sendok = sdo.SendDeviceOrder(msgIdx, MonitorIndex, _DeviceOrder, _DeviceIdx, gc[5]); // ͻķָ  _NumParam4ʾĿλ
                        if (_DeviceOrder == 7 || _DeviceOrder == 8)
                        {
                           // cgs.ActionComplete(_DeviceIdx, MonitorIndex, 1);
                        }
                       
                    }


                    if (sendok == false)
                    {
                        if (sdo.CommLayerError != null)
                        {
                            if (FrmControlMonitor.FormInstance.GetObjectText("tsStatus").IndexOf(sdo.CommLayerError) < 0)
                            {

                                FrmControlMonitor.FormInstance.FlashPanit("tsStatus", sdo.CommLayerError, true);
                            }
                        }
                        return false;
                    }
                    else//ɹ
                    {
                        //////////////////////////
                        dbo.ExecuteSql("update T_Monitor_Task set F_SendFlag='1' where F_MonitorIndex=" + MonitorIndex);//20100905ֻط
                        ccf.SendOrderSuccess(_ManageKindIdx, _ManageTaskIdx, MonitorIndex, _DeviceIdx, _routeID);
                        #region ˫ͬͬʱ淢ɹ
                        //20100323
                        devinfo = Model.CGetInfo.GetDeviceInfo(_DeviceIdx);
                        if (devinfo.IfCorrelDoubleFork == "1")
                        {
                            if (Model.CGeneralFunction.DoubleForkIfSync(MonitorIndex, _DeviceIdx, _DeviceKind) == true)
                            {
                                string[] df = Model.CGeneralFunction.GetDoubleForkMonitorInfo(MonitorIndex, _DeviceIdx);
                                if (df != null)
                                {
                                    ccf.SendOrderSuccess(ccf.GetManageTaskKindIndexFromMonitor(Convert.ToInt32(df[0])), ccf.GetManageTaskIndexfromMonitor(Convert.ToInt32(df[0])), Convert.ToInt32(df[0]), Convert.ToInt32(df[2]), Convert.ToInt32(df[3]));
                                    //dbo.ExceSQL("update T_Monitor_Task set F_CorrelDoubleFork=" + df[0] + " where F_MonitorIndex=" + MonitorIndex + "");
                                    //dbo.ExceSQL("update T_Monitor_Task set F_CorrelDoubleFork=" + MonitorIndex + " where F_MonitorIndex=" + df[0] + "");
                                }
                            }
                        }
                        #endregion
                        return true;
                    }
                }
                else
                {
                    return false;
                }

                #endregion
            }
        }

        int GetDeviceFromMonitor(int monitorIndex)
        {
            DataView dv = dbo.ExceSQL("SELECT F_MonitorIndex, F_DeviceIndex FROM T_Monitor_Task WHERE (F_MonitorIndex = " + monitorIndex + ")").Tables[0].DefaultView;
            if (dv.Count > 0)
            {
                return Convert.ToInt32(dv[0]["F_DeviceIndex"]);
            }
            else
            {
                return -1;
            }
        }

        /// <summary>
        /// ȡõĿλã߳վ̨
        /// </summary>
        /// <param name="manageTaskIdx"></param>
        /// <param name="manageKindIdx"></param>
        /// <returns></returns>
        bool  GetUsableDestination(int manageTaskIdx,int manageKindIdx )
        {
            //20100610һ·ãٵյ豸
            Dictionary<int, int> advDev=new Dictionary<int,int>();
            object ob;


            DataView dv = dbo.ExceSQL("SELECT * FROM T_Manage_Task WHERE (FID = " + manageTaskIdx + ") AND (F_ManageTaskKindIndex = " + manageKindIdx + ")").Tables[0].DefaultView;
            if (dv.Count <= 0)
            {
                return false ;
            }
            DataRowView dr = dv[0];

            //20091107
            DataView dvIO = dboM.ExceSQL("select CONTROL_ID, CONTROL_STATUS from IO_Control where (CONTROL_ID = " + Convert.ToInt32(dr["FID"]) + ") AND ((CONTROL_STATUS=" + Model.CGeneralFunction.TASKALTERROUTEAPPLY + ") or (CONTROL_STATUS=" + Model.CGeneralFunction.TASKALTERROUTEREPLY + "))").Tables[0].DefaultView;
            if (dvIO.Count <= 0)
            {
                //ֻĵ·޸ĵԶ·
                if (dr["F_ManageTaskKindIndex"].ToString() != "1") return false;
                string sql = "";
                string adviceDev = "";
                DataTable dtd = dbo.ExceSQL("SELECT F_TASKKIND, F_DESTINATION FROM T_Base_Destination WHERE (F_TASKKIND = " + dr["FCONTROLTASKTYPE"] + ") and (F_AbendStation=1) and (F_DESTINATION=" + dr["FENDDEVICE"] + ")").Tables[0];
                if (dtd.Rows.Count > 0)//ԭյӦվ̨ôվ̨Ҫı
                {
                    adviceDev = dtd.Rows[0]["F_DESTINATION"].ToString();
                    return false;
                }
                else
                {
                    //ҿĿλ
                    DataTable dt = dbo.ExceSQL("SELECT F_TASKKIND, F_DESTINATION FROM T_Base_Destination WHERE (F_TASKKIND = " + dr["FCONTROLTASKTYPE"] + ") and (F_DESTINATION <>" + dr["FENDDEVICE"] + ") and (F_AbendStation=0)").Tables[0];
                    if (dt.Rows.Count > 0)
                    {
                        for (int i = 0; i < dt.Rows.Count; i++)
                        {
                            if (CDisassembleTask.MinRouteID(Convert.ToInt32(dr["FSTARTDEVICE"]), Convert.ToInt32(dt.Rows[i]["F_DESTINATION"]), dr["FUseAwayFork"]) != -1)
                            {

                                //20100610ͳƵյ豸ִе
                                ob = dbo.GetSingle("SELECT count(FENDDEVICE) as counts FROM T_Manage_Task where FENDDEVICE='" + dt.Rows[i]["F_DESTINATION"] + "' and fstatus>0");
                                advDev.Add(Convert.ToInt32(dt.Rows[i]["F_DESTINATION"]),Convert.ToInt32(ob));

                                //20100610 break;
                            }
                        }
                        if (advDev.Count == 0)//20100610
                        {

                            return false;


                        }
                        else
                        {//20100610
                            int mincount=9999;
                            foreach (int aaa in advDev.Keys)
                            {
                                if (advDev[aaa] < mincount)
                                {
                                    mincount = advDev[aaa];
                                    adviceDev = aaa.ToString();
                                }
                            }
                            if (adviceDev == "")
                            {

                                return false;

                            }
                        }
                    }
                    else
                    {//20100610
                        return false;
                    }
                }

                //DataView DV = dboM.ExceSQL("select IO_CONTROL_APPLY_SEQ.NEXTVAL FROM DUAL").Tables[0].DefaultView;
                //20101108int fid = dboM.GetManageTableIndex("IO_CONTROL_APPLY");
                string dtime = DateTime.Now.ToString("u");
                dtime = dtime.Substring(0, dtime.Length - 1);
                //20091128
                dboM.TransBegin();
                try
                {
                    dboM.ExceSQL(" update IO_CONTROL set CONTROL_STATUS="+Model.CGeneralFunction.TASKALTERROUTEAPPLY+" where CONTROL_ID=" + dr["FID"] + "");
                    //޸//20101108CONTROL_APPLY_ID, " + fid + ",
                    sql = "INSERT INTO IO_CONTROL_APPLY ( CONTROL_ID,CONTROL_APPLY_TYPE,WAREHOUSE_CODE, STOCK_BARCODE, DEVICE_CODE, APPLY_TASK_STATUS, CREATE_TIME, " +
                            " CONTROL_APPLY_REMARK)" +
                    "VALUES (" + dr["FID"] + ",2,'" + dr["FSTARTWAREHOUSE"] + "','" + dr["FPALLETBARCODE"] + "','" + adviceDev + "',0,'" + dtime + "',null)";
                    
                    dboM.ExceSQL(sql);
                    dboM.TransCommit();
                    //ManageTaskIdxManageKindIdx ĵȫĵ
                    dbo.ExceSQL("UPDATE T_Monitor_Task SET  F_Status = 3 WHERE (F_ManageTaskIndex = " + manageTaskIdx + ") AND (F_ManageTASKKINDINDEX =" + manageKindIdx + ")");
                    return true;
                }
                catch (Exception ex)
                {
                    _CControlError = "ָĵʱ" + ex.Message;
                    dboM.TransRollback();
                    return false;
                }
                                    
                    
            }
            else
            {
                return false;

            }
        }
        /// <summary>
        /// ȡRGVõĿλã߳վ̨
        /// </summary>
        /// <param name="manageTaskIdx"></param>
        /// <param name="manageKindIdx"></param>
        /// <param name="IfUseNegativeDevice">Ƿѡ豸ǰ豸ǰ豸RGV߷ķ</param>
        /// <returns></returns>
        bool GetRGVIdleDestination(int manageTaskIdx, int manageKindIdx,int RGVGateDevice, bool IfUseNegativeDevice)
        {

            //20100610 t_Base_device F_UsableEndDeviceֶδ߳Եȵ豸飨ԷֺŸ
            //λڵǰ豸ǰ棨RGV߷ķ򣩣ֻڷRGVȡ͵һ˶ʱʹã
            //ǰ豸豸ڷͻ֮ǰʹ.ֱRGV
            //T_Base_RGV_GateֶΡF_EndDeviceڼʱһRGVͻĶӦ豸
            //߳ʱվ̨һͻӦĳվ̨

            //ɱĿλõѡԭRGVĿλÿСĿλòִеĵ

            DataView dv;
            DataRowView dr;
            string sql = "";
            string adviceDev = "";
            char[] cc = new char[1] { ';' };
            string[] sp;
            DataView dvIO;
            Dictionary<int, int> advDev=new Dictionary<int,int>();
            object ob;

            try
            {
                dv = dbo.ExceSQL("SELECT * FROM T_Manage_Task WHERE (FID = " + manageTaskIdx + ") AND (F_ManageTaskKindIndex = " + manageKindIdx + ")").Tables[0].DefaultView;
                if (dv.Count <= 0)
                {
                    return false;
                }
                dr = dv[0];
                //ֻĵ·޸ĵԶ·
                if (dr["F_ManageTaskKindIndex"].ToString() != "1") return false;
                dvIO = dboM.ExceSQL("select CONTROL_ID, CONTROL_STATUS from IO_Control where (CONTROL_ID = " + Convert.ToInt32(dr["FID"]) + ") AND ((CONTROL_STATUS=" + Model.CGeneralFunction.TASKALTERROUTEAPPLY + ") or (CONTROL_STATUS=" + Model.CGeneralFunction.TASKCANCEL + ") or(CONTROL_STATUS=" + Model.CGeneralFunction.TASKALTERROUTEREPLY + "))").Tables[0].DefaultView;
                if (dvIO.Count <= 0)
                {

                    #region T_Base_DeviceF_UsableEndDeviceҿյ豸
                    DataView dvu = dbo.ExceSQL("select F_UsableEndDevice from T_Base_Device where F_UsableEndDevice is not null and F_DeviceIndex=" + RGVGateDevice + "").Tables[0].DefaultView;
                    if (dvu.Count > 0)
                    {
                        int enddv = 0, DESTINATION = 0;
                        sp = dvu[0]["F_UsableEndDevice"].ToString().Split(cc);

                        for (int i = sp.GetLowerBound(0); i <= sp.GetUpperBound(0); i++)
                        {
                            if (Microsoft.VisualBasic.Information.IsNumeric(sp[i]) == false) continue;
                            enddv = Convert.ToInt32(sp[i]);
                            if (enddv < 0)
                            {
                                //ǰ豸ǰ豸RGV߷ķ
                                if (IfUseNegativeDevice == true)
                                {
                                    enddv = -(enddv);
                                }
                                else
                                {
                                    continue;
                                }
                            }
                            devinfo = Model.CGetInfo.GetDeviceInfo(enddv);
                            if ((devinfo.HaveGoods == true)||(devinfo.RunState==2))
                            {//Ŀλñռû߹
                                continue;
                            }
                            ob = dbo.GetSingle("SELECT F_EndDevice FROM T_Base_RGV_Gate WHERE (F_RGVGateDeviceIndex = " + enddv + ") AND (F_EndDevice IS NOT NULL)");
                            if (ob == null) continue;
                            DESTINATION = Convert.ToInt32(ob);
                            if (CDisassembleTask.MinRouteID(Convert.ToInt32(dr["FSTARTDEVICE"]), DESTINATION) != -1)
                            {
                                //20100609ͳƵյ豸ִе
                                ob = dbo.GetSingle("SELECT count(FENDDEVICE) as counts FROM T_Manage_Task where FENDDEVICE='" + DESTINATION + "' and fstatus>0");
                                advDev.Add(DESTINATION, Convert.ToInt32(ob));

                            }

                        }
                    }
                    else
                    {
                        return false;
                    }
                    dvu = null;
                    if (advDev.Count<=0)
                    {
                        return false;
                    }
                    else
                    {
                        int mincount = 9999;
                        foreach (int aaa in advDev.Keys)
                        {
                            if (advDev[aaa] < mincount)
                            {
                                mincount = advDev[aaa];
                                adviceDev = aaa.ToString();
                            }
                        }
                        if (adviceDev == "")
                        {

                            return false;

                        }
                    }
                    #endregion

                    //20101108int fid = dboM.GetManageTableIndex("IO_CONTROL_APPLY");
                    string dtime = DateTime.Now.ToString("u");
                    dtime = dtime.Substring(0, dtime.Length - 1);

                    dboM.TransBegin();
                    try
                    {
                       
                        dboM.ExceSQL(" update IO_CONTROL set CONTROL_STATUS=" + Model.CGeneralFunction.TASKALTERROUTEAPPLY + " where CONTROL_ID=" + dr["FID"] + " and CONTROL_STATUS<>" + Model.CGeneralFunction.TASKCANCEL + "");
                        //޸//20101108CONTROL_APPLY_ID," + fid + ",
                        sql = "INSERT INTO IO_CONTROL_APPLY ( CONTROL_ID, WAREHOUSE_CODE, STOCK_BARCODE, DEVICE_CODE, APPLY_TASK_STATUS, CREATE_TIME,CONTROL_APPLY_REMARK)" +
                        "VALUES (" + dr["FID"] + ",'" + dr["FENDWAREHOUSE"] + "','" + dr["FPALLETBARCODE"] + "','" + adviceDev + "',0,'" + dtime + "',null)";
                        dboM.ExceSQL(sql);
                        dboM.TransCommit();
                        //ManageTaskIdxManageKindIdx ĵȫĵ
                        dbo.ExceSQL("UPDATE T_Monitor_Task SET  F_Status = 3 WHERE (F_ManageTaskIndex = " + manageTaskIdx + ") AND (F_ManageTASKKINDINDEX =" + manageKindIdx + ")");

                        return true;
                    }
                    catch (Exception ex)
                    {
                        dboM.TransRollback();
                        _CControlError = "ָĵʱ" + ex.Message;
                        return false;
                    }
                }
                else
                {
                    return false;
                }
            }
            catch (Exception ex)
            {
                _CControlError = "ָĵʱ" + ex.Message;
                return false;
            }
            finally
            {
                dv = null;
                dr = null;
                cc = null;
                sp = null;
                dvIO = null;
            }
        }
        /// <summary>
        /// ڶ˫ĵ
        /// </summary>
        /// <param name="controlTaskType"></param>
        /// <param name="devindex">豸</param>
        /// <returns></returns>
        int GetEnableDoubleForkManageTask(int controlTaskType, int devindex,int FID)
        {
            DataView dv0;
            string sql = "SELECT F_MonitorIndex,T_Monitor_Task.F_ManageTaskIndex,T_Monitor_Task.F_ManageTASKKINDINDEX FROM T_Monitor_Task ,T_Manage_Task where T_Monitor_Task.F_ManageTaskIndex = T_Manage_Task.FID AND T_Monitor_Task.F_ManageTASKKINDINDEX = T_Manage_Task.F_ManageTaskKindIndex AND F_DeviceIndex=" + devindex + " and FCONTROLTASKTYPE=" + controlTaskType;
            DataView dv = dbo.ExceSQL(sql).Tables[0].DefaultView;
            if (dv.Count > 0)
            {
                for (int i = 0; i < dv.Count; i++)
                {
                    dv0 = dbo.ExceSQL("select min(F_MonitorIndex) as mm from T_Monitor_Task where F_ManageTaskIndex=" + dv[i]["F_ManageTaskIndex"] + " and F_ManageTASKKINDINDEX=" + dv[i]["F_ManageTASKKINDINDEX"] + " ").Tables[0].DefaultView;
                    if (dv0.Count > 0)
                    {
                        if (dv0[0]["mm"].ToString() == dv[i]["F_MonitorIndex"].ToString())
                        {
                            if (FID != Convert.ToInt32(dv[i]["F_ManageTaskIndex"]))
                            {
                                return Convert.ToInt32( dv[i]["F_ManageTaskIndex"]);
                            }
                        }
                    }
                }
                return -1;
            }
            else
            {
                return -1;
            }
        }
        /// <summary>
        /// öѶڶԵվ̨ȡ˫
        /// </summary>
        /// <param name="controlTaskType"></param>
        /// <param name="Stackdevindex">Ѷ豸</param>
        /// <param name="StationDevice">վ̨豸</param>
        /// <param name="FID"></param>
        /// <returns></returns>
        int GetEnableDoubleForkManageTask(int controlTaskType, int Stackdevindex,int StationDevice, int FID)
        {
            DataView dv1 = dbo.ExceSQL("SELECT F_ZXY FROM T_Base_Lane_Gate,T_Base_LaneInfo WHERE "+
                "(T_Base_Lane_Gate.F_LaneIndex = T_Base_LaneInfo.F_LaneDeviceIndex) and (T_Base_LaneInfo.F_StackIndex = " +
                Stackdevindex + ") and (F_LaneGateDeviceIndex=" + StationDevice + ")").Tables[0].DefaultView;
            if (dv1.Count <= 0) return -1;
            char[] cc = new char[1] {'-' };
            string[] zxy = dv1[0]["F_ZXY"].ToString().Split(cc);
            DataView dv0;
            string sql = "SELECT F_MonitorIndex,T_Monitor_Task.F_ManageTaskIndex,T_Monitor_Task.F_ManageTASKKINDINDEX "+
                " FROM T_Monitor_Task ,T_Manage_Task where T_Monitor_Task.F_ManageTaskIndex = T_Manage_Task.FID AND "+
                "T_Monitor_Task.F_ManageTASKKINDINDEX = T_Manage_Task.F_ManageTaskKindIndex AND F_DeviceIndex=" +
                Stackdevindex + " and FCONTROLTASKTYPE=" + controlTaskType + " and F_NumParam1=" + zxy[0] + 
                " and F_NumParam2=" + zxy[1] + " and F_NumParam3=" + zxy[2] + "";
            DataView dv = dbo.ExceSQL(sql).Tables[0].DefaultView;
            if (dv.Count > 0)
            {
                for (int i = 0; i < dv.Count; i++)
                {
                    dv0 = dbo.ExceSQL("select min(F_MonitorIndex) as mm from T_Monitor_Task where F_ManageTaskIndex=" + dv[i]["F_ManageTaskIndex"] + " and F_ManageTASKKINDINDEX=" + dv[i]["F_ManageTASKKINDINDEX"] + " ").Tables[0].DefaultView;
                    if (dv0.Count > 0)
                    {
                        if (dv0[0]["mm"].ToString() == dv[i]["F_MonitorIndex"].ToString())
                        {
                            if (FID != Convert.ToInt32(dv[i]["F_ManageTaskIndex"]))
                            {
                                return Convert.ToInt32(dv[i]["F_ManageTaskIndex"]);
                            }
                        }
                    }
                }
                return -1;
            }
            else
            {
                return -1;
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="Mankind"></param>
        /// <param name="FID"></param>
        /// <param name="ControlTaskType"></param>
        /// <param name="UseAwayFork">Զ</param>
        void AlterRoutePath(int Mankind,int FID,int ControlTaskType,char UseAwayFork,int NowDevice)
        {
            DataView dv; DataView dv1; DataView dvnew;
            
            //ҵǰ·ǷĻƥ䣬ƥĸĵ
            try
            {
                dv = dbo.ExceSQL("SELECT  T_Monitor_Task.F_MonitorIndex,T_Monitor_Task.F_DeviceIndex FROM T_Monitor_Task,T_Base_Route_Device where "+
                    " T_Monitor_Task.F_RouteID = T_Base_Route_Device.F_RouteIDSub AND T_Monitor_Task.F_DeviceIndex = T_Base_Route_Device.F_DeviceIndex and T_Monitor_Task.F_ManageTaskIndex="+
                    FID+" and T_Monitor_Task.F_ManageTASKKINDINDEX="+Mankind+" and T_Base_Route_Device.F_UseAwayFork<>'"+UseAwayFork+"'").Tables[0].DefaultView;
                if (dv.Count > 0)
                {
                    dv = dbo.ExceSQL("select * from T_Manage_Task where F_ManageTaskKindIndex=" + Mankind + " and FID=" + FID).Tables[0].DefaultView;
                    if (dv.Count > 0)
                    {
                        //20100702
                        string sql = "SELECT T_Base_Route_Device.F_RouteIDSub FROM T_Base_Route,T_Base_Route_Device where T_Base_Route.F_RouteID = T_Base_Route_Device.F_RouteID " +
                            " and (T_Base_Route_Device.F_UseAwayFork = '" + UseAwayFork + "') AND (T_Base_Route_Device.F_DeviceIndex = " + NowDevice + ") AND (T_Base_Route.F_StartDevice = " +
                            dv[0]["FSTARTDEVICE"] + ") AND (T_Base_Route.F_EndDevice = " + dv[0]["FENDDEVICE"] + " and F_RouteKind="+ControlTaskType+")";
                        dv1 = dbo.ExceSQL(sql).Tables[0].DefaultView;
                        if (dv1.Count > 0)
                        {
                            int routeidNew=Convert.ToInt32( dv1[0][0]);
                            //ɾԭ޸·񣬲µֻ豸ʼ
                            dbo.ExceSQL("DELETE FROM T_Monitor_Task WHERE (F_ManageTaskIndex = " + FID + ") AND (F_ManageTASKKINDINDEX ="+Mankind+")");
                            if (CDisassembleTask.CreateMonitor(Mankind, FID, routeidNew, dv[0], 3) > 0)
                            {
                                dvnew = dbo.ExceSQL("SELECT F_MonitorIndex FROM T_Monitor_Task WHERE (F_ManageTaskIndex = " +
                                                FID + ") AND (F_ManageTASKKINDINDEX = "+Mankind+") AND (F_DeviceIndex = " +
                                                NowDevice + ") AND (F_RouteID = " + routeidNew +
                                                ") AND (F_Status = 3) ").Tables[0].DefaultView;
                                if (dvnew.Count > 0)
                                {
                                    dbo.ExceSQL("delete from T_Monitor_Task where F_MonitorIndex<" + dvnew[0]["F_MonitorIndex"] + " and (F_ManageTaskIndex = " +
                                    FID + ") AND (F_ManageTASKKINDINDEX = "+Mankind+") AND (F_Status = 3)");
                                    
                                    dbo.ExceSQL("update  T_Monitor_Task set F_Status =0 where  (F_ManageTaskIndex = " +
                                    FID + ") AND (F_ManageTASKKINDINDEX = "+Mankind+") AND (F_Status = 3)");


                                }
                            }
                        }
                        
                    }
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                dv = null;
                dv1 = null;
                dvnew = null;
            }
        }
        int GetDoubleForkMinRouteTask(int taskno)
        {
            DataView dv;
            //˫ֱӷtaskno˫浫ǿֱͬӷtaskno
            //˫治ͬķ뵱ǰѶλ̵taskno
            
            int manKind=Model.CGeneralFunction.GetManageTaskKindIndexFromMonitor(taskno);
            int manFid=Model.CGeneralFunction.GetManageTaskIndexfromMonitor(taskno);
            int deviceindex = Model.CGeneralFunction.GetDeviceIndexFromMonitor(taskno);
            int devKind=Model.CGeneralFunction.GetDeviceKindIdx(deviceindex);
            int devOrder = Model.CGeneralFunction.GetDeviceOrderFromMonitor(taskno);
            
            devinfo = Model.CGetInfo.GetDeviceInfo(deviceindex);
           // string aa1212q = DateTime.Now.Second.ToString() + "-" + DateTime.Now.Millisecond.ToString();
            int nX=Model.CGeneralFunction.GetXCoorFromMonitor(taskno,deviceindex,devOrder);
            int nY=Model.CGeneralFunction.GetYCoorFromMonitor(taskno,deviceindex,devOrder);
           // string aa212q = DateTime.Now.Second.ToString() + "-" + DateTime.Now.Millisecond.ToString();
            double  nXY = 0, doubleXY = 0;
            int doubleX=Model.CGeneralFunction.GetDoubleForkX(manKind,manFid,deviceindex,devOrder);
            //string aa212 = DateTime.Now.Second.ToString() + "-" + DateTime.Now.Millisecond.ToString();
            int doubleY=Model.CGeneralFunction.GetDoubleForkY(manKind,manFid,deviceindex,devOrder);
           // string aa122 = DateTime.Now.Second.ToString() + "-" + DateTime.Now.Millisecond.ToString();
            if (devinfo.IfCorrelDoubleFork == "1")
            {
                string[] df = Model.CGeneralFunction.GetDoubleForkMonitorInfo(taskno, deviceindex);
                if(df==null)return taskno;
                if (Model.CGeneralFunction.DoubleForkIfSync(taskno, deviceindex, devKind) == false)
                {
                    #region ָǵһָܷ
                    int rmankind = Model.CGeneralFunction.GetManageTaskKindIndexFromMonitor(Convert.ToInt32(df[0]));
                    int rman = Model.CGeneralFunction.GetManageTaskIndexfromMonitor(Convert.ToInt32(df[0]));
                    dv = dbo.ExceSQL("SELECT MIN(F_MonitorIndex) AS mmi FROM dbo.T_Monitor_Task WHERE (F_ManageTaskIndex = " + rman + ") AND (F_ManageTASKKINDINDEX = " + rmankind + ")").Tables[0].DefaultView;
                    if (dv.Count > 0)
                    {
                        if ((dv[0]["mmi"] != DBNull.Value) && (dv[0]["mmi"].ToString() != df[0]))
                        {
                            return taskno;
                        }
                    }
                    #endregion
                    if (devKind == 1)//Ѷ
                    {//ڵλִи
                        if(devOrder==5)//ͻָʱж20110425
                        {
                            if (false == IfExcuteFirst(taskno))
                            {
                                return Convert.ToInt32(df[0]);
                            }
                            if (false == IfExcuteFirst(Convert.ToInt32(df[0])))
                            {
                                return taskno;
                            }

                        }
                        nXY = Math.Pow((double)(nX - devinfo.XCoor), 2) + (Math.Pow((double)(nY - devinfo.YCoor), 2));
                        doubleXY = Math.Pow((double)(doubleX - devinfo.XCoor), 2) + (Math.Pow((double)(doubleY - devinfo.YCoor), 2));
                        if (nXY < doubleXY)
                        {
                            return taskno;
                        }
                        else
                        {
                            return Convert.ToInt32(df[0]);
                        }
                    }
                    else if (devKind == 6)//AGV
                    {
                        nXY =Convert.ToInt32(dbo.GetSingle("SELECT F_Sequence FROM T_Base_AGV_Gate WHERE (F_AGVGateDeviceIndex = "+nX+")"));
                        doubleXY = Convert.ToInt32(dbo.GetSingle("SELECT F_Sequence FROM T_Base_AGV_Gate WHERE (F_AGVGateDeviceIndex = " + doubleX + ")"));
                        if (nXY < doubleXY)
                        {
                            return taskno;
                        }
                        else
                        {
                            return Convert.ToInt32(df[0]);
                        }
                    }
                    else
                    {
                        return taskno;
                    }
                }
                else
                {
                    return taskno;
                }

            }
            else
            {
                return taskno;
            }
        }

        int CountAGVTask(int taskno)
        {//2ܼ

            //ÿAGVֻͨAGVһ˫һ˫һһ
            //F_status>0С2ʱжF_status>0Ƿtaskno˫й򷵻3򷵻ʵʵ
            //F_status>0ڻ2ʱ3
            int devindex = GetDeviceFromMonitor(taskno);
            int devorder = ccf.GetDeviceOrderFromMonitor(taskno);
            int devStation=Model.CGeneralFunction.GetXCoorFromMonitor(taskno, devindex, devorder);
            string  bt = " < 3000 ";
            if (devStation < 3000)
            {//¥
                bt = " < 3000 ";
            }
            else
            {//¥
                bt = " > 3000 ";
            }
            int agvc = dbo.ExceSQL("SELECT F_MonitorIndex FROM T_Monitor_Task WHERE (F_Status > 0) AND (F_NumParam1 "+bt+") AND (F_DeviceIndex = 1001)").Tables[0].DefaultView.Count;
            if (agvc == 1)
            {
                if (Model.CGeneralFunction.GetDoubleForkMonitorInfo(taskno, devindex,0) ==true)
                {
                    return 3;
                }
                else
                {
                    return 0;
                }
            }
            else if (agvc == 0)
            {
                return 0;
            }
            else
            {
                return 3;
            }
        }

        bool IFAGVGate(int devIndex)
        {
            if (dbo.ExceSQL("SELECT F_AGVGateDeviceIndex FROM T_Base_AGV_Gate WHERE (F_AGVGateDeviceIndex = "+devIndex +")").Tables[0].DefaultView.Count > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// Ҫĵλ-Ҫ 20121030
        /// </summary>
        /// <param name="TaskIndex"></param>
        /// <returns></returns>
        string IfLimitCellChangeFork(int TaskIndex)
        {
        //    int[] zxy = ccf.GetCoordinatesFromMonitorTask(TaskIndex);
        //    int xCoor = zxy[4];
        //    string zxystr = (zxy[0].ToString().Length == 1 ? "0" + zxy[0].ToString() : zxy[0].ToString()) + "-" +
        //            ((zxy[1].ToString().Length == 1) ? ("0" + zxy[1].ToString()) : (zxy[1].ToString())) + "-" +
        //            ((zxy[2].ToString().Length == 1) ? ("0" + zxy[2].ToString()) : (zxy[2].ToString()));
        // //   string zxystr = (zxy[3].ToString().Length == 1 ? "0" + zxy[3].ToString() : zxy[3].ToString()) + "-" +
        // //((zxy[4].ToString().Length == 1) ? ("0" + zxy[4].ToString()) : (zxy[4].ToString())) + "-" +
        // //((zxy[5].ToString().Length == 1) ? ("0" + zxy[5].ToString()) : (zxy[5].ToString()));

        //    string UseAwayFork=Model.CGeneralFunction.GetUseAwayFork(TaskIndex);//1,Զ棻0棻'-'û
        //    //жǰ޻λӦý
        //    DataView dv = dbo.ExceSQL("SELECT F_MoveCellCode FROM T_Base_Lane_Gate,T_Base_LaneInfo where T_Base_Lane_Gate.F_LaneIndex = T_Base_LaneInfo.F_LaneDeviceIndex and (T_Base_LaneInfo.F_ForwardLimitX = " + xCoor + ") and F_ZXY='" + zxystr + "'").Tables[0].DefaultView;
        //  // DataView dv = dbo.ExceSQL("SELECT F_MoveCellCode FROM T_Base_LaneInfo where F_ForwardLimitX = " + xCoor + "").Tables[0].DefaultView;

        //    if (dv.Count > 0)
        //    {
        //        if (UseAwayFork == "1")
        //        {
        //            return dv[0]["F_MoveCellCode"].ToString();
        //        }
        //    }
        //    //жϺ޻λӦԶ
        //    dv = dbo.ExceSQL("SELECT F_MoveCellCode FROM T_Base_Lane_Gate,T_Base_LaneInfo where T_Base_Lane_Gate.F_LaneIndex = T_Base_LaneInfo.F_LaneDeviceIndex and (T_Base_LaneInfo.F_BackLimitX = " + xCoor + ") and F_ZXY='" + zxystr + "'").Tables[0].DefaultView;
        //    //dv = dbo.ExceSQL("SELECT F_MoveCellCode FROM T_Base_LaneInfo where F_BackLimitX = " + xCoor + "").Tables[0].DefaultView;

        //    if (dv.Count > 0)
        //    {
        //        if (UseAwayFork == "0")
        //        {
        //            return dv[0]["F_MoveCellCode"].ToString();
        //        }
        //    }

            return "-";
        }

        bool IfExcuteFirst(int TaskIndex)
        {
            int[] zxy = ccf.GetCoordinatesFromMonitorTask(TaskIndex);
            string zxystr = (zxy[3].ToString().Length == 1 ? "0" + zxy[0].ToString() : zxy[3].ToString()) + "-" +
                    ((zxy[4].ToString().Length == 1) ? ("0" + zxy[4].ToString()) : (zxy[4].ToString())) + "-" +
                    ((zxy[5].ToString().Length == 1) ? ("0" + zxy[5].ToString()) : (zxy[5].ToString()));

            DataView dv = dbo.ExceSQL("SELECT F_MoveCellCode FROM T_Base_LaneInfo WHERE (F_MoveCellCode = '" + zxystr + "')").Tables[0].DefaultView;
            if (dv.Count > 0)//λִ
            {
                return false;
            }
            return true;

        }
        /// <summary>
        /// Ҫļ޻λյΪλ
        /// </summary>
        /// <param name="taskindex">豸</param>
        /// <param name="ChangeForkCell">ɸĻĵλ</param>
        void ChangeEndCellCode(int taskindex, string ChangeForkCell,int StackIndex)
        {
            char[] cc=new char[1]{'-'};
            string[] endCell = ChangeForkCell.Split(cc);
            int fid = ccf.GetManageTaskIndexfromMonitor(taskindex);
            int Mankind = ccf.GetManageTaskKindIndexFromMonitor(taskindex);
            //dbo.TransBegin();
            try
            {
                DataView dv = dbo.ExceSQL("SELECT F_LaneGateDeviceIndex FROM T_Base_Lane_Gate,T_Base_Device WHERE (T_Base_Lane_Gate.F_LaneGateDeviceIndex = T_Base_Device.F_DeviceIndex) and (F_ZXY = '" + ChangeForkCell + "')").Tables[0].DefaultView;
                if (dv.Count > 0)
                {

                    dbo.ExecuteSql("update T_Monitor_Task set F_AheadDetect=F_AheadDetect+'" + ";N" + dv[0]["F_LaneGateDeviceIndex"].ToString() + "', F_NumParam4=" + endCell[0] + ",F_NumParam5=" + endCell[1]
                        + ",F_NumParam6=" + endCell[2] + " where F_ManageTaskIndex=" + fid + " and F_ManageTASKKINDINDEX=" + Mankind + " and F_DeviceIndex=" + StackIndex);
                    dbo.ExecuteSql("update T_Manage_Task set FExceptionNO=" + Model.CGeneralFunction.TASKCHANGEFORK + " where FID=" + fid + " and F_ManageTaskKindIndex=" + Mankind);
                }
                    //dbo.TransCommit();
            }
            catch(Exception ex)
            {
                throw ex;
                //dbo.TransRollback();
            }
        }

        int GetIOControlStatus(int TaskIndex)
        {
            int mankind = ccf.GetManageTaskKindIndexFromMonitor(TaskIndex);
            int Fid = ccf.GetManageTaskIndexfromMonitor(TaskIndex);
            if (mankind == 1)
            {
                object ob=dboM.GetSingle("SELECT CONTROL_STATUS FROM IO_CONTROL WHERE (CONTROL_ID = "+Fid+")");
                if (ob != null)
                {
                    return Convert.ToInt32(ob);
                }
                else
                {
                    return Model.CGeneralFunction.TASKSINGLEFORKRUN;
                }
            }
            else
            {
                return Model.CGeneralFunction.TASKSINGLEFORKRUN;
            }
        }
        /// <summary>
        /// AGV˫Ĺվ̨,-1ûй
        /// </summary>
        /// <param name="taskindex">豸ָ</param>
        /// <returns></returns>
        int GetAGVCorrelIndex(int taskindex)
        {
            object ob = dbo.GetSingle("SELECT F_NumParam2 FROM T_Monitor_Task WHERE (F_MonitorIndex = "+taskindex+")");
            if (ob != null)
            {
                int cs = Convert.ToInt32(ob);
                if (cs % 2 == 0)
                {
                    return (cs-1);
                }
                else
                {
                    return (cs + 1);
                }
            }
            else
            {
                return -1;
            }
        }
        /// <summary>
        /// AGVڴվ̨ȡĵ
        /// </summary>
        /// <param name="controltype"></param>
        /// <param name="stationIndex">AGVվ̨</param>
        /// <returns></returns>
        int GetAGVEnableDoubleForkManageTask(int controltype, int stationIndex)
        {
            string sql = "SELECT T_Monitor_Task.F_ManageTaskIndex  "+
                " FROM T_Monitor_Task ,T_Manage_Task where T_Monitor_Task.F_ManageTaskIndex = T_Manage_Task.FID AND "+
                "T_Monitor_Task.F_ManageTASKKINDINDEX = T_Manage_Task.F_ManageTaskKindIndex and FCONTROLTASKTYPE=" + 
                controltype + " and F_NumParam2=" + stationIndex + " and F_DeviceIndex=1001 and F_DeviceCommandIndex=1";
            DataView dv = dbo.ExceSQL(sql).Tables[0].DefaultView;
            if (dv.Count > 0)
            {
                return Convert.ToInt32(dv[0]["F_ManageTaskIndex"]);
            }
            else
                return -1;
        }
        bool IfInSameLimitX(int fid, int mfid,int manKind)
        {
            //DataView dv = dbo.ExceSQL("SELECT F_ForwardLimitX,F_BackLimitX,FEndCol FROM T_Manage_Task,T_Base_LaneInfo WHERE T_Manage_Task.FLANEWAY = T_Base_LaneInfo.F_LaneDeviceIndex and (F_ManageTaskKindIndex = " + manKind + ") AND (FID = " + fid + ")").Tables[0].DefaultView;
            //if (dv.Count == 0)
            //{
            //    return false;
            //}
            //DataView dv1 = dbo.ExceSQL("SELECT F_ForwardLimitX,F_BackLimitX,FEndCol FROM T_Manage_Task,T_Base_LaneInfo WHERE T_Manage_Task.FLANEWAY = T_Base_LaneInfo.F_LaneDeviceIndex and (F_ManageTaskKindIndex = " + manKind + ") AND (FID = " + mfid + ")").Tables[0].DefaultView;
            //if (dv1.Count == 0)
            //{
            //    return false;
            //}
            //if ((dv[0]["FEndCol"].ToString() == dv[0]["F_ForwardLimitX"].ToString()) && (dv1[0]["F_ForwardLimitX"].ToString() == dv1[0]["FEndCol"].ToString()))
            //{
            //    return true;
            //}
            //if ((dv[0]["FEndCol"].ToString() == dv[0]["F_BackLimitX"].ToString()) && (dv1[0]["F_BackLimitX"].ToString() == dv1[0]["FEndCol"].ToString()))
            //{
            //    return true;
            //}
            return false;
        }
    }
}
