using System;
using System.Collections.Generic;
using System.Text;
using Opc;
using Opc.Da;
using OpcCom;
using System.Threading;
using System.Data;
using DBFactory;
namespace OPCClient
{
    public static class CCommonOPCClient
    {
        public static DBOperator dbo = new DBOperator();
        //20110216
        private static int _connectCount = 0;
        public static int ConnectCount
        {
            get { return CCommonOPCClient._connectCount; }
            set {
                if (value == 0)
                {
                    _opcError = "";
                }
                CCommonOPCClient._connectCount = value; 
            }
        }
        // 20120427ϲS7ӱ־ 1- B
        static StringBuilder sbc = new StringBuilder();
        public static int[] ErrorCount = new int[2] {0,0 };

        private static int[] _plcStates=null ;

        public static int[] PlcStates
        {
            get { return CCommonOPCClient._plcStates; }
            //set { CCommonOPCClient._plcStates = value; }
        }
        
        /// <summary>
        /// 20110309ĵڱǩݱ仯¼
        /// </summary>
        /// <param name="subscriptionHandle">ͻ˾</param>
        /// <param name="requestHandle"></param>
        /// <param name="values">ǩֵ</param>
        public static void OnDataChange(object subscriptionHandle, object requestHandle, ItemValueResult[] values)
        {
            //subscriptionHandleӦ豸豸ࣨͬ豸ͨѶ֡ͬ
            //ֱɣ翪أPLC
            try
            {
                //devinfo = Model.CGetInfo.GetDeviceInfo(System.Convert.ToInt32(subscriptionHandle));
                //foreach (ItemValueResult item in values)
                //{//ÿһItemValueResult
                //    if (item.ClientHandle == null)
                //    {//Ϣ
                //        continue;
                //    }
                //    //豸ͲͨѶЭ
                //    switch(devinfo.DeviceKind)
                //    {
                //        #region Ѷ
                //        case 1:

                //            break;
                //        #endregion

                //        #region ͻ
                //        case 2:

                //            break;
                //        #endregion

                //        #region RGV
                //        case 4:

                //            break;
                //        #endregion

                //        #region ַϢ
                //        case 7:
                            
                //            break;
                //        #endregion

                //        #region ֳ
                //        case 22:

                //            break;
                //        #endregion

                //        #region һŹַϢ
                //        case 21:
                            
                //            break;
                //        #endregion

                //        #region Ϣ
                //        case 24:

                //            break;
                //        #endregion

                //    }
                //}
            }
            catch (Exception ex)
            {
                _opcError = "ȡOPCʱ" + ex.Message;
                
            }
        }

        

        //WriteCompleteص
        public static void OnWriteComplete(object requestHandle, Opc.IdentifiedResult[] values)
        {
            /*Console.WriteLine("첽дname:{0},value:{1}", values[0].ItemName, values[0].GetType());
            if ((int)requestHandle == 2)
                Console.WriteLine("¼źžΪ{0}", requestHandle);*/
        }

        static private string _PLCconnectionID = "S7:[S7 connection_1]";
        /// <summary>
        /// PLCӵID磺"S7:[S7 connection_1]"
        /// "S7:[@LOCALSERVER]"
        /// </summary>
        public static string PlcConnectionID
        {
            get { return CCommonOPCClient._PLCconnectionID; }
            set { CCommonOPCClient._PLCconnectionID = value; }
        }
        static private string _opcError;
        static private bool _IfConnectOPCServer=false ;
        static private string _hostname;
        /// <summary>
        /// OPC ServerĻƻIPַ
        /// </summary>
        public static string Hostname
        {
            get { return CCommonOPCClient._hostname; }
            set { CCommonOPCClient._hostname = value; }
        }
        static private string _progID;
        /// <summary>
        /// OPC Serverĳʶ磺OPC.SimaticNET
        /// </summary>
        public static string ProgID
        {
            get { return CCommonOPCClient._progID; }
            set { CCommonOPCClient._progID = value; }
        }
        public static string OpcError
        {
            get { return CCommonOPCClient._opcError; }
            set { CCommonOPCClient._opcError = value; }
        }
        static private Opc.Da.Server m_server = null;//ݴȡ
        static private Opc.Server[] servers;
        static private Opc.Da.Subscription subscription = null;//󣨶ߣ
        static private Opc.Da.SubscriptionState state = null;//飨ߣ״̬൱OPC淶Ĳ
        static private Opc.Da.Subscription _readSubscription = null;//󣨶ߣ
        static private Opc.Da.SubscriptionState _readstate = null;//飨ߣ״̬൱OPC淶Ĳ
        static private Opc.Da.Subscription _writeSubscription = null;//󣨶ߣ
        static private Opc.Da.SubscriptionState _writestate = null;//飨ߣ״̬൱OPC淶Ĳ
        static private Opc.Da.Subscription _tempSubscription = null;//󣨶ߣ
        static private Opc.Da.SubscriptionState _tempstate = null;//飨ߣ״̬൱OPC淶Ĳ
        static private Opc.IDiscovery m_discovery = new OpcCom.ServerEnumerator();//öٻCOMĽӿڣеĴ
        /// <summary>
        /// 豸Ӧ豸ġ
        /// </summary>
        public static SubscriptionCollection  SubscriptionGroup = new SubscriptionCollection();//󼯺ϣ߼ϣ//20110309
        //static Model.MDevice devinfo;//20110309
        /// <summary>
        /// 20110309ÿ豸һĺDataChange¼
        /// </summary>
        public static void CreateSubscriptionGroup()
        {
            if (_IfConnectOPCServer == false)
            {
                _hostname = CommonClassLib.AppSettings.GetValue("HostName");
                _progID = CommonClassLib.AppSettings.GetValue("OPCProgID");
                if (ConnectOPCServer(_hostname, _progID) == false) return ;
            }
            DataView dv = dbo.ExceSQL("SELECT F_DeviceIndex, F_DBW2Address, F_DBWGetLength, F_S7Connection FROM T_Base_Device where F_DBW2Address >=0 and F_DBWGetLength>0 order by F_DeviceIndex asc").Tables[0].DefaultView;
            
            for (int i = 0; i < dv.Count; i++)
            {
                //趨豸״̬
                _tempstate = new Opc.Da.SubscriptionState();//飨ߣ״̬൱OPC淶Ĳ
                _tempstate.Name = dv[i]["F_DeviceIndex"].ToString();//
                _tempstate.ServerHandle = null;//ľ
                _tempstate.ClientHandle = dv[i]["F_DeviceIndex"].ToString();//ͻ˸ľ
                _tempstate.Active = true;//顣
                _tempstate.UpdateRate = 100;//ˢƵΪ100롣
                _tempstate.Deadband = 0;// ֵΪ0ʱ˸κݱ仯֪ͨ顣
                _tempstate.Locale = null;//õֵ
                //豸
                _tempSubscription = (Opc.Da.Subscription)m_server.CreateSubscription(_tempstate);//豸
                //ӱǩ
                ////itemб
                Item[] items = new Item[1];//item
                
                for (int ii = 0; ii < items.Length; ii++)//itemʼֵ
                {
                    items[ii] = new Item();//һItem
                    items[ii].ClientHandle = Guid.NewGuid().ToString();//ͻ˸ľ
                    items[ii].ItemPath = null; //ڷе·
                    items[ii].ItemName = dv[i]["F_S7Connection"].ToString() +
                        Model.CGeneralFunction.DBGet + ",byte" + 
                        dv[i]["F_DBW2Address"].ToString() + "," +
                        (System.Convert.ToInt32(dv[i]["F_DBWGetLength"])).ToString(); //ڷе֡
                }

                //ӶItem
                ItemResult[] irs = _tempSubscription.AddItems(items);
                //¼
                _tempSubscription.DataChanged += new Opc.Da.DataChangedEventHandler(OnDataChange);
                SubscriptionGroup.Add(_tempSubscription);
                //_tempSubscription.RemoveItems(_tempSubscription.Items);
            }
        }
        /// <summary>
        /// ȡOPCıʶ
        /// </summary>
        /// <param name="hostname"></param>
        /// <returns></returns>
        public static List<string> GetOpcServers(string hostname)
        {
            try
            {
                servers = m_discovery.GetAvailableServers(Specification.COM_DA_20, hostname, null);
                //daverʾݴȡ淶汾Specification.COMDA_202.0汾
                //hostΪnullʾҪκ簲ȫ֤
                if (servers != null)
                {
                    List<string> ser =new List<string>();;
                    foreach (Opc.Da.Server server in servers)
                    {
                        ser.Add(server.Name);
                    }
                    return ser;
                }
                return null;
            }
            catch (Exception ex)
            {
                _opcError = "ȡOPCʱ" + ex.Message;
                return null;
            }
        }
        /// <summary>
        /// ָOPC
        /// </summary>
        /// <param name="hostname"></param>
        /// <param name="ProgID">OPCʶ磺"OPC.SimaticNET"</param>
        /// <returns></returns>
        public static bool ConnectOPCServer(string hostname, string ProgID)
        {
            try
            {
                
                GetOpcServers(hostname);
                //if (ProgID.Contains(hostname) == false)
                //{
                //    ProgID = hostname + "." + ProgID;
                //}
                foreach (Opc.Da.Server server in servers)
                {
                    //serverΪҪӵOPCݴȡ
                    if (String.Compare(server.Name,  ProgID, true) == 0)//ΪtrueԴСд
                    {
                        m_server = server;//ӡ
                        break;
                        
                    }
                }
                //ӷ
                if (m_server != null)//ǿӷ
                {
                    m_server.Connect();
                    _IfConnectOPCServer = true;
                    CreateItemGroup();
                    return true;
                }
                else
                {
                    _IfConnectOPCServer = false;
                    return false;
                }
                
            }
            catch (Exception ex)
            {
                _opcError ="OPCݴȡʱ"+ ex.Message;
                _IfConnectOPCServer = false;
                return false;
            }
            
        }
        /// <summary>
        /// OPC飨ߣڱ
        /// </summary>
        /// <param name="groupname">OPC飨ߣ</param>
        /// <param name="itemnames">ָб,ֵ"S7:[S7 connection_1]DB1,INT1"</param>
        /// <returns></returns>
        public static Opc.Da.Subscription CreateItemGroup(string groupname, string[] itemnames)
        {
            string[] itemName ;
            //itemб
            Item[] items;
            ItemResult[] irs;
            try
            {
                if (_IfConnectOPCServer == false)
                {
                    if (ConnectOPCServer(_hostname, _progID) == false) return null;
                }
                //趨״̬
                state = new Opc.Da.SubscriptionState();//飨ߣ״̬൱OPC淶Ĳ
                state.Name = groupname;//
                state.ServerHandle = null;//ľ
                state.ClientHandle = Guid.NewGuid().ToString();//ͻ˸ľ
                state.Active = true;//顣
                state.UpdateRate = 50;//ˢƵΪ100롣
                state.Deadband = 0;// ֵΪ0ʱ˸κݱ仯֪ͨ顣
                state.Locale = null;//õֵ


                //
                subscription = (Opc.Da.Subscription)m_server.CreateSubscription(state);//

                //Itemб
                //ӦΪ:{Byte,Byte,Char,Short,String,Word,Boolean}
                itemName = itemnames;//{ "S7:[S7 connection_1]DB1,INT1", "S7:[@LOCALSERVER]DB1,INT20", "S7:[@LOCALSERVER]DB1,INT30", "S7:[@LOCALSERVER]DB1,INT50" };

                //itemб
                items = new Item[itemName.Length];//item
                int i;
                for (i = 0; i < items.Length; i++)//itemʼֵ
                {
                    items[i] = new Item();//һItem
                    items[i].ClientHandle = Guid.NewGuid().ToString();//ͻ˸ľ
                    items[i].ItemPath = null; //ڷе·
                    items[i].ItemName = itemName[i]; //ڷе֡
                }

                //Item
                irs = subscription.AddItems(items);
                return subscription;
            }
            catch (Exception ex)
            {
                //if ((m_server == null) || (m_server.IsConnected == false))
                //{
                _IfConnectOPCServer = false;
                //}
                _opcError = "OPCʱ" + ex.Message;
                return null;
            }
            finally
            {
                itemName=null;
                //itemб
                items=null;
                irs=null;
            }
        }
        /// <summary>
        /// OPC飨ߣڱ
        /// </summary>
        /// <param name="groupname">OPC飨ߣ</param>
        /// <returns></returns>
        public static Opc.Da.Subscription CreateItemGroup(string groupname)
        {
            try
            {
                if (_IfConnectOPCServer == false)
                {
                    if (ConnectOPCServer(_hostname, _progID) == false) return null;
                }
                //趨״̬
                state = new Opc.Da.SubscriptionState();//飨ߣ״̬൱OPC淶Ĳ
                state.Name = groupname;//
                state.ServerHandle = null;//ľ
                state.ClientHandle = Guid.NewGuid().ToString();//ͻ˸ľ
                state.Active = true;//顣
                state.UpdateRate = 50;//ˢƵΪ100롣
                state.Deadband = 0;// ֵΪ0ʱ˸κݱ仯֪ͨ顣
                state.Locale = null;//õֵ


                //
                subscription = (Opc.Da.Subscription)m_server.CreateSubscription(state);//

                
                return subscription;
            }
            catch (Exception ex)
            {
                //if ((m_server == null) || (m_server.IsConnected == false))
                //{
                _IfConnectOPCServer = false;
                //}
                _opcError = "OPCʱ" + ex.Message;
                return null;
            }
        }
        /// <summary>
        /// Ĭ飺readwriteʱдtempGroup
        /// </summary>
        /// <returns></returns>
        public static void  CreateItemGroup()
        {
            try
            {
                //if (_IfConnectOPCServer == false)
                //{
                //    if (ConnectOPCServer(_hostname, _progID) == false) return ;
                //}
                #region ȫǩ
                //20110216
                
                //趨ȡ״̬
                _readstate = new Opc.Da.SubscriptionState();//飨ߣ״̬൱OPC淶Ĳ
                _readstate.Name = "readopc";//
                _readstate.ServerHandle = null;//ľ
                _readstate.ClientHandle = Guid.NewGuid().ToString();//ͻ˸ľ
                _readstate.Active = true;//顣
                _readstate.UpdateRate = 50;//ˢƵΪ100롣
                _readstate.Deadband = 0;// ֵΪ0ʱ˸κݱ仯֪ͨ顣
                _readstate.Locale = null;//õֵ
                //Ӷ
                _readSubscription = (Opc.Da.Subscription)m_server.CreateSubscription(_readstate);//ȡ
                //20110216
                //string[] itemName;
                //DataView dv = dbo.ExceSQL("SELECT F_S7Connection,F_DBW2Address,F_DBWGetLength  FROM T_Base_Device WHERE (F_DeviceKindIndex = 28)").Tables[0].DefaultView;
                //if (dv.Count > 0)
                //{
                //    itemName=new string[dv.Count];
                //    for(int i=0;i<dv.Count;i++)
                //    {
                //        itemName[i] = dv[i]["F_S7Connection"] + Model.CGeneralFunction.DBGet + ",byte"
                //            + dv[i]["F_DBW2Address"].ToString() + "," + ((int)dv[i]["F_DBWGetLength"]).ToString();
                //    }
                //    //{ "S7:[S7 connection_1]DB1,INT1", "S7:[@LOCALSERVER]DB1,INT20", "S7:[@LOCALSERVER]DB1,INT30", "S7:[@LOCALSERVER]DB1,INT50" };
                //}
                //else
                //{
                //    return ;
                //}
                ////itemб
                //Item[] items = new Item[itemName.Length];//item
                //int i;
                //for (i = 0; i < items.Length; i++)//itemʼֵ
                //{
                //    items[i] = new Item();//һItem
                //    items[i].ClientHandle = Guid.NewGuid().ToString();//ͻ˸ľ
                //    items[i].ItemPath = null; //ڷе·
                //    items[i].ItemName =  itemName[i]; //ڷе֡
                //}

                ////ӶItem
                //ItemResult[] irs = _readSubscription.AddItems(items);
                //_plcStates = new int[System.Convert.ToInt32( devinfo28.Dbw2Getlength)];
                //_readSubscription.DataChanged += new Opc.Da.DataChangedEventHandler(OnDataChange);
                #endregion

                //趨д״̬
                _writestate = new Opc.Da.SubscriptionState();//飨ߣ״̬൱OPC淶Ĳ
                _writestate.Name = "writeopc";//
                _writestate.ServerHandle = null;//ľ
                _writestate.ClientHandle = Guid.NewGuid().ToString();//ͻ˸ľ
                _writestate.Active = true;//顣
                _writestate.UpdateRate = 50;//ˢƵΪ100롣
                _writestate.Deadband = 0;// ֵΪ0ʱ˸κݱ仯֪ͨ顣
                _writestate.Locale = null;//õֵ
                //д
                _writeSubscription = (Opc.Da.Subscription)m_server.CreateSubscription(_writestate);//д

                //趨ʱ״̬
                _tempstate = new Opc.Da.SubscriptionState();//飨ߣ״̬൱OPC淶Ĳ
                _tempstate.Name = "opctemp";//
                _tempstate.ServerHandle = null;//ľ
                _tempstate.ClientHandle = Guid.NewGuid().ToString();//ͻ˸ľ
                _tempstate.Active = true;//顣
                _tempstate.UpdateRate = 50;//ˢƵΪ100롣
                _tempstate.Deadband = 0;// ֵΪ0ʱ˸κݱ仯֪ͨ顣
                _tempstate.Locale = null;//õֵ
                //д
                _tempSubscription = (Opc.Da.Subscription)m_server.CreateSubscription(_tempstate);//д
                
            }
            catch (Exception ex)
            {
                //if ((m_server == null) || (m_server.IsConnected == false))
                //{
                _IfConnectOPCServer = false;
                //}
                _opcError = "OPCʱ" + ex.Message;
                return ;
            }
        }
        /// <summary>
        /// OPC飨ߣڱ
        /// </summary>
        /// <param name="plcConnectionID">̬жÿPLCӵıʶ</param>
        /// <param name="groupname">OPC飨ߣ</param>
        /// <param name="itemnames">ָб,ֵ"DB1,INT1"</param>
        /// <returns></returns>
        public static Opc.Da.Subscription CreateItemGroup(string plcConnectionID,string groupname, string[] itemnames)
        {
            string[] itemName;
            //itemб
            Item[] items;
            ItemResult[] irs;
            try
            {
                if (_IfConnectOPCServer == false)
                {
                    if (ConnectOPCServer(_hostname, _progID) == false) return null;
                }
                //趨״̬
                state = new Opc.Da.SubscriptionState();//飨ߣ״̬൱OPC淶Ĳ
                state.Name = groupname;//
                state.ServerHandle = null;//ľ
                state.ClientHandle = Guid.NewGuid().ToString();//ͻ˸ľ
                state.Active = true;//顣
                state.UpdateRate = 50;//ˢƵΪ100롣
                state.Deadband = 0;// ֵΪ0ʱ˸κݱ仯֪ͨ顣
                state.Locale = null;//õֵ


                //
                subscription = (Opc.Da.Subscription)m_server.CreateSubscription(state);//

                //Itemб
                //ӦΪ:{Byte,Byte,Char,Short,String,Word,Boolean}
                itemName = itemnames;//{ "S7:[S7 connection_1]DB1,INT1", "S7:[@LOCALSERVER]DB1,INT20", "S7:[@LOCALSERVER]DB1,INT30", "S7:[@LOCALSERVER]DB1,INT50" };

                //itemб
                items = new Item[itemName.Length];//item
                int i;
                for (i = 0; i < items.Length; i++)//itemʼֵ
                {
                    items[i] = new Item();//һItem
                    items[i].ClientHandle = Guid.NewGuid().ToString();//ͻ˸ľ
                    items[i].ItemPath = null; //ڷе·
                    items[i].ItemName = plcConnectionID + itemName[i]; //ڷе֡
                }

                //Item
                irs = subscription.AddItems(items);
                return subscription;
            }
            catch (Exception ex)
            {
                //if ((m_server == null) || (m_server.IsConnected == false))
                //{
                _IfConnectOPCServer = false;
                //}
                _opcError = "OPCʱ" + ex.Message;
                return null;
            }
            finally
            {
                itemName=null;
                //itemб
                items=null;
                irs=null;
            }
        }
        
        /// <summary>
        /// ͬȡȫOPCڱֵList+ ":" +ֵ
       /// </summary>
       /// <param name="subscription">OPC</param>
       /// <returns></returns>
        public static List<string> SyncReadAllItems(Opc.Da.Subscription subscription)
        {
            ItemValueResult[] values;
            List<string> itemnamevalue;
            try
            {
                if (_IfConnectOPCServer == false)
                {
                    if (ConnectOPCServer(_hostname, _progID) == false) return null;
                }
                itemnamevalue = new List<string>();
                //עص¼
                //subscription.DataChanged += new Opc.Da.DataChangedEventHandler(OnDataChange);

                //²ͬ
                //¶
                values = subscription.Read(subscription.Items);
                foreach (ItemValueResult value in values)
                {
                    itemnamevalue.Add(value.ItemName + ":" + value.Value);
                    
                }
                //subscription.RemoveItems(subscription.Items);
                //subscription.Dispose();
                return itemnamevalue;
            }
            catch (Exception ex)
            {
                //if ((m_server == null) || (m_server.IsConnected == false))
                //{
                _IfConnectOPCServer = false;
                //}
                _opcError = "ͬʱ" + ex.Message;
                return null;
            }
            finally
            {
                values=null;
                itemnamevalue=null;
            }
        }

        /// <summary>
        /// ȡָS7ConnectionDB1Ӧǩݣֵǩֵɵ
        /// </summary>
        /// <param name="S7Connection">OPC</param>
        /// <returns></returns>
        public static byte[] SyncReadAllItems(string S7Connection)
        {//20110216
            ItemValueResult[] values;
            byte[] itemnamevalue;
            try
            {
                if (_IfConnectOPCServer == false)
                {
                    if (ConnectOPCServer(_hostname, _progID) == false) return null;
                }
                _readSubscription.RemoveItems(_readSubscription.Items);
                string[] itemName= new string[1];
                DataView dv = dbo.ExceSQL("SELECT F_DBW2Address,F_DBWGetLength  FROM T_Base_Device WHERE (F_DeviceKindIndex = 28 and F_S7Connection='"+S7Connection+"')").Tables[0].DefaultView;
                if (dv.Count > 0)
                {
                    
                    itemName[0] = S7Connection + Model.CGeneralFunction.DBGet + ",byte"+ dv[0]["F_DBW2Address"].ToString() + "," + (System.Convert.ToInt32( dv[0]["F_DBWGetLength"])).ToString();
                    
                }
                else
                {
                    return null ;
                }
                
                //itemб
                Item[] items = new Item[itemName.Length];//item
                int i;
                for (i = 0; i < items.Length; i++)//itemʼֵ
                {
                    items[i] = new Item();//һItem
                    items[i].ClientHandle = Guid.NewGuid().ToString();//ͻ˸ľ
                    items[i].ItemPath = null; //ڷе·
                    items[i].ItemName = itemName[i]; //ڷе֡
                }

                //ӶItem
                
                ItemResult[] irs = _readSubscription.AddItems(items);
                //_plcStates = new int[System.Convert.ToInt32(devinfo28.Dbw2Getlength)];
                //_readSubscription.DataChanged += new Opc.Da.DataChangedEventHandler(OnDataChange);
                
                // ÿS7һļ
                sbc.Remove(0, sbc.Length);
                sbc = sbc.Append(S7Connection.Substring(S7Connection.Length - 2, 1));
                int ConnectID = 0;
                switch (S7Connection.Substring(S7Connection.Length - 2, 1))
                {
                    case "A":
                        ConnectID = 9; // 10ŶѶ
                        break;
                    case "B":
                        ConnectID = 10; // ͻ
                        break;
                    default:
                        ConnectID = System.Convert.ToInt32(sbc.ToString()) - 1;
                        break;
                }


                if (ErrorCount[ConnectID] > 1)
                {
                    _opcError = "ͬʱOPC ServerûӵPLCҳظӴ!ȹرأͨѶ·ȷϺ´أ";
                    return null;
                }
                //if (ConnectCount > 1)
                //{
                //    _opcError = "ͬʱOPC ServerûӵPLCҳظӴ!ȹرأͨѶ·ȷϺ´أ";
                //    return null;
                //}
                values = _readSubscription.Read(_readSubscription.Items);
                if (values.Length <= 0)
                {
                    _opcError = "ͬʱOPC ServerûӵPLC!";
                    return null;
                }
                if (values[0].Quality == Quality.Bad)
                {
                    ErrorCount[ConnectID]++;
                    //ConnectCount++;
                    _opcError = "ͬʱOPC ServerûӵPLC!";
                    return null;
                }
                else if (values[0].Quality == Quality.Good)
                {
                    // ȡɹ󣬼
                    ErrorCount[ConnectID] = 0;
                }
                
                Array arr = (Array)values[0].Value;
                itemnamevalue = new byte[arr.GetLength(0)];
                Array.Copy(arr, itemnamevalue, arr.GetLength(0));
                _readSubscription.RemoveItems(_readSubscription.Items);
                //subscription.Dispose();
                return itemnamevalue;
            }
            catch (Exception ex)
            {
                //if ((m_server == null) || (m_server.IsConnected == false))
                //{
                _IfConnectOPCServer = false;
                //}
                _opcError = "ͬʱ" + ex.Message;
                return null;
            }
            finally
            {
                itemnamevalue = null;
                values = null;
            }
        }

        /// <summary>
        /// ȡָǩƵ
        /// </summary>
        /// <param name="itemname">ǩ</param>
        /// <returns></returns>
        public static string SyncReadItemValue(string itemname)
        {
            string[] items = new string[1] { itemname };
            Subscription subs = CreateItemGroup(_PLCconnectionID, Guid.NewGuid().ToString(), items);
            string itemnamevalue = "";
            ItemValueResult[] values = subs.Read(subs.Items);
            try
            {
                if (_IfConnectOPCServer == false)
                {
                    if (ConnectOPCServer(_hostname, _progID) == false) return null;
                }

                if (values.Length > 0)
                {
                    if (values[0].Value != null)
                    {
                        itemnamevalue = values[0].Value.ToString();
                    }
                }
                subs.RemoveItems(subs.Items);
                subs.Dispose();
                return itemnamevalue;
            }
            catch (Exception ex)
            {
                //if ((m_server == null) || (m_server.IsConnected == false))
                //{
                _IfConnectOPCServer = false;
                //}
                _opcError = "ͬʱ" + ex.Message;
                return null;
            }
            finally
            {
                items = null;
                subs = null;
                itemnamevalue = null;
                values = null;
            }
        }

        //20100221
        #region ӼͬдOPC

        /// <summary>
        /// Ӽȡ_readSubscription
        /// </summary>
        /// <returns></returns>
        public static byte[] SyncReadAllItems()
        {
            ItemValueResult[] values;
            byte[] itemnamevalue;
            try
            {
                if (_IfConnectOPCServer == false)
                {
                    if (ConnectOPCServer(_hostname, _progID) == false) return null;
                }
                //List<string> itemnamevalue = new List<string>();
                //עص¼
                //subscription.DataChanged += new Opc.Da.DataChangedEventHandler(OnDataChange);

                //²ͬ
                //¶
                if (ConnectCount > 1)
                {
                    _opcError = "ͬʱOPC ServerûӵPLCҳظӴ!ȹرأͨѶ·ȷϺ´أ";
                    return null;
                }
                values = _readSubscription.Read(_readSubscription.Items);
                if (values.Length <= 0)
                {
                    _opcError = "ͬʱOPC ServerûӵPLC!";
                    return null;
                }
                if (values[0].Quality == Quality.Bad)
                {
                    ConnectCount++;
                    _opcError = "ͬʱOPC ServerûӵPLC!";
                    return null;
                }
                Array arr = (Array)values[0].Value;
                itemnamevalue = new byte[arr.GetLength(0)];
                Array.Copy(arr, itemnamevalue, arr.GetLength(0));
                //subscription.RemoveItems(subscription.Items);
                //subscription.Dispose();
                return itemnamevalue;
            }
            catch (Exception ex)
            {
                //if ((m_server == null) || (m_server.IsConnected == false))
                //{
                _IfConnectOPCServer = false;
                //}
                _opcError = "ͬʱ" + ex.Message;
                return null;
            }
            finally
            {
                itemnamevalue = null;
                values = null;
            }
        }
        /// <summary>
        /// ӼָOPCǩдݣ_writeSubscription飩
        /// </summary>
        /// <param name="itemnames"></param>
        /// <param name="itemvalue"></param>
        /// <returns></returns>
        public static bool SyncWriteAllItemValue(string[] itemnames, string[] itemvalue)
        {
            Item[] items;
            ItemValue[] itemvalues;
            IdentifiedResult[] ir;
            try
            {
                if (_IfConnectOPCServer == false)
                {
                    if (ConnectOPCServer(_hostname, _progID) == false) return false;
                }
                if (ConnectCount > 1)
                {
                    _opcError = "ͬʱOPC ServerûӵPLCҳظӴ!ȹرأͨѶ·ȷϺ´أ";
                    return false;
                }
                //itemб
                items = new Item[itemnames.Length];//item
                int i;
                for (i = 0; i < items.Length; i++)//itemʼֵ
                {
                    items[i] = new Item();//һItem
                    items[i].ClientHandle = Guid.NewGuid().ToString();//ͻ˸ľ
                    items[i].ItemPath = null; //ڷе·
                    items[i].ItemName = _PLCconnectionID + itemnames[i]; //ڷе֡
                }
                _writeSubscription.AddItems(items);
                itemvalues = new ItemValue[_writeSubscription.Items.Length];
                for (int ii = 0; ii < _writeSubscription.Items.Length; ii++)
                {
                    itemvalues[ii] = new ItemValue((ItemIdentifier)_writeSubscription.Items[ii]);
                    itemvalues[ii].Value = itemvalue[ii];
                }

                ir = _writeSubscription.Write(itemvalues);

                _writeSubscription.RemoveItems(_writeSubscription.Items);
                //_writeSubscription.Dispose();
                //GC.Collect();
                return true;
            }
            catch (Exception ex)
            {
                //if ((m_server == null) || (m_server.IsConnected == false))
                //{
                _IfConnectOPCServer = false;
                //}
                _opcError = "ͬдʱ" + ex.Message;
                return false;
            }
            finally
            {
                items=null;
                itemvalues=null;
                ir=null;
            }
        }

        public static bool SyncWriteAllItemValue(StringBuilder[] itemnames, StringBuilder[] itemvalue)
        {
            Item[] items;
            ItemValue[] itemvalues;
            IdentifiedResult[] ir;
            try
            {
                if (_IfConnectOPCServer == false)
                {
                    if (ConnectOPCServer(_hostname, _progID) == false) return false;
                }
                if (ConnectCount > 1)
                {
                    _opcError = "ͬʱOPC ServerûӵPLCҳظӴ!ȹرأͨѶ·ȷϺ´أ";
                    return false;
                }
                //itemб
                items = new Item[itemnames.Length];//item
                int i;
                for (i = 0; i < items.Length; i++)//itemʼֵ
                {
                    items[i] = new Item();//һItem
                    items[i].ClientHandle = Guid.NewGuid().ToString();//ͻ˸ľ
                    items[i].ItemPath = null; //ڷе·
                    items[i].ItemName = _PLCconnectionID + itemnames[i].ToString(); //ڷе֡
                }
                _writeSubscription.AddItems(items);
                itemvalues = new ItemValue[_writeSubscription.Items.Length];
                for (int ii = 0; ii < _writeSubscription.Items.Length; ii++)
                {
                    itemvalues[ii] = new ItemValue((ItemIdentifier)_writeSubscription.Items[ii]);
                    itemvalues[ii].Value = itemvalue[ii].ToString();
                }

                ir = _writeSubscription.Write(itemvalues);

                _writeSubscription.RemoveItems(_writeSubscription.Items);
                //_writeSubscription.Dispose();
                //GC.Collect();
                return true;
            }
            catch (Exception ex)
            {
                //if ((m_server == null) || (m_server.IsConnected == false))
                //{
                _IfConnectOPCServer = false;
                //}
                _opcError = "ͬдʱ" + ex.Message;
                return false;
            }
            finally
            {
                items = null;
                itemvalues = null;
                ir = null;
            }
        }
        /// <summary>
        /// ӼȡָOPCǩݣ_tempSubscription飩
        /// </summary>
        /// <param name="itemnames"></param>
        /// <returns></returns>
        public static object[] SyncReadItemValues(string[] itemnames)
        {
            Item[] items;
            ItemResult[] irs;
            ItemValueResult[] values;
            object[] itemnamevalue;
            try
            {
                string ss; string ss1;
                ss = DateTime.Now.Second.ToString() + "-" + DateTime.Now.Millisecond.ToString();
                if (_IfConnectOPCServer == false)
                {
                    if (ConnectOPCServer(_hostname, _progID) == false) return null;
                }
                //itemб
                items = new Item[itemnames.Length];//item
                int i;
                for (i = 0; i < items.Length; i++)//itemʼֵ
                {
                    items[i] = new Item();//һItem
                    items[i].ClientHandle = Guid.NewGuid().ToString();//ͻ˸ľ
                    items[i].ItemPath = null; //ڷе·
                    items[i].ItemName = _PLCconnectionID + itemnames[i]; //ڷе֡
                }
                irs = _tempSubscription.AddItems(items);

                values = _tempSubscription.Read(_tempSubscription.Items);
                if (values[0].Quality == Quality.Bad)
                {
                    _opcError = "ͬʱOPC ServerûӵPLC!";
                    return null;
                }
                itemnamevalue = new object[values.Length];
                int k = 0;
                foreach (ItemValueResult value in values)
                {
                    itemnamevalue[k] = value.Value;
                    k++;
                }
                //Array.Copy(values.[0].Value, itemnamevalue, values.Length);
                _tempSubscription.RemoveItems(_tempSubscription.Items);
                //_tempSubscription.Dispose();
                //GC.Collect();
                ss1 = DateTime.Now.Second.ToString() + "-" + DateTime.Now.Millisecond.ToString();
                return itemnamevalue;
            }
            catch (Exception ex)
            {
                //if ((m_server == null) || (m_server.IsConnected == false))
                //{
                _IfConnectOPCServer = false;
                //}
                _opcError = "ͬʱ" + ex.Message;
                return null;
            }
            finally
            {
                items=null ;
                irs=null ;
                values=null ;
                itemnamevalue=null ;
            }
        }
        #endregion


        //20100221
        //#region Ӽͬд첽OPC
        //static byte[] AsyncReadAllItemNameValue= new byte[(int)devinfo28.Dbw2Getlength];
        //static bool AsyncReadOK=false ;
        ///// <summary>
        ///// Ӽ첽ȡ_readSubscription
        ///// </summary>
        ///// <returns></returns>
        //public static void AsyncReadAllItems()
        //{
            
        //    try
        //    {
        //        if (_IfConnectOPCServer == false)
        //        {
        //            if (ConnectOPCServer(_hostname, _progID) == false) return ;
        //        }
                
        //        IRequest quest=null ;
        //        _readSubscription.Read(_readSubscription.Items, Guid.NewGuid().ToString(), OnReadComplete,out quest);
                
        //    }
        //    catch (Exception ex)
        //    {
        //        //if ((m_server == null) || (m_server.IsConnected == false))
        //        //{
        //        _IfConnectOPCServer = false;
        //        //}
        //        _opcError = "첽ʱ" + ex.Message;
        //        AsyncReadOK = false;
        //        return ;
        //    }
        //    finally
        //    {
                
        //    }
        //}
        ///// <summary>
        ///// ӼָOPCǩͬдݣ_writeSubscription飩
        ///// </summary>
        ///// <param name="itemnames"></param>
        ///// <param name="itemvalue"></param>
        ///// <returns></returns>
        //public static bool SyncWriteGroupItemValue(string[] itemnames, string[] itemvalue)
        //{
        //    Item[] items;
        //    ItemValue[] itemvalues;
        //    IdentifiedResult[] ir;
        //    try
        //    {
        //        if (AsyncReadOK == false) return false;
        //        if (_IfConnectOPCServer == false)
        //        {
        //            if (ConnectOPCServer(_hostname, _progID) == false) return false;
        //        }
        //        //itemб
        //        items = new Item[itemnames.Length];//item
        //        int i;
        //        for (i = 0; i < items.Length; i++)//itemʼֵ
        //        {
        //            items[i] = new Item();//һItem
        //            items[i].ClientHandle = Guid.NewGuid().ToString();//ͻ˸ľ
        //            items[i].ItemPath = null; //ڷе·
        //            items[i].ItemName = _PLCconnectionID + itemnames[i]; //ڷе֡
        //        }
        //        _writeSubscription.AddItems(items);
        //        itemvalues = new ItemValue[_writeSubscription.Items.Length];
        //        for (int ii = 0; ii < _writeSubscription.Items.Length; ii++)
        //        {
        //            itemvalues[ii] = new ItemValue((ItemIdentifier)_writeSubscription.Items[ii]);
        //            itemvalues[ii].Value = itemvalue[ii];
        //        }

        //        ir = _writeSubscription.Write(itemvalues);

        //        _writeSubscription.RemoveItems(_writeSubscription.Items);
        //        //_writeSubscription.Dispose();
        //        GC.Collect();
        //        return true;
        //    }
        //    catch (Exception ex)
        //    {
        //        //if ((m_server == null) || (m_server.IsConnected == false))
        //        //{
        //        _IfConnectOPCServer = false;
        //        //}
        //        _opcError = "ͬдʱ" + ex.Message;
        //        return false;
        //    }
        //    finally
        //    {
        //        items = null;
        //        itemvalues = null;
        //        ir = null;
        //    }
        //}
        ////ReadCompleteص
        //public static void OnReadComplete(object requestHandle, Opc.Da.ItemValueResult[] values)
        //{
        //    /*Console.WriteLine("첽name:{0},value:{1}", values[0].ItemName, values[0].Value);
        //    if ((int)requestHandle == 1)
        //        Console.WriteLine("¼źžΪ{0}", requestHandle);*/
        //    //ˣֱӽOPC
        //    try
        //    {
        //        if (values.Length <= 0)
        //        {
        //            _opcError = "첽ʱOPC ServerûӵPLC!";
        //            AsyncReadOK = false;
        //            return ;
        //        }
        //        if (values[0].Quality == Quality.Bad)
        //        {
        //            _opcError = "첽ʱOPC ServerûӵPLC!";
        //            AsyncReadOK = false;
        //            return ;
        //        }


        //        Array.Copy((Array)values[0].Value, AsyncReadAllItemNameValue, AsyncReadAllItemNameValue.GetLength(0));// (int)devinfo28.Dbw2Getlength
        //        AsyncReadOK = true;
        //    }
        //    catch (Exception ex)
        //    {
        //        _opcError = "첽ʱ"+ex.Message ;
        //        AsyncReadOK = false;
        //        return;
        //    }
        //    finally
        //    {
        //        values = null;
        //    }
        //}
        //#endregion



        /// <summary>
        /// ͬOPCÿдֵ
        /// </summary>
        /// <param name="subscription">OPC</param>
        /// <param name="itemvalue">ÿֵ</param>
        /// <returns></returns>
        
    }
}
