using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Data.SqlClient;
using System.Text;
using System.Windows.Forms;
using DBFactory;

namespace CommonClassLib
{
    public partial class UCellPanel : UserControl
    {
        #region  
        DBOperator dbo = new DBOperator();
        //ߴ
        int bigWidth = 30; 
        
        int bigHeight =20 ;

        //ݵĲ
        Form parentForm;
        Control controlCellCode;

       
        Control controlShow;
        Control controlBarCode;
        int taskType = -1;

        DataTable tableCellInfoList;                                                //V_CellInfoList
        DataTable tableLines;	                                                    //ȡcmbLinesDataSource

        List<Rectangle> listRecCell = new List<Rectangle>();                        //洢ƻ
        List<string> listCellCode = new List<string>();                             //洢λ
        List<int> listCellID = new List<int>();                                     //洢λFID

        int cellID = -1;                                                            //ST_CELLеFID
        string goodsName;                                                           //

        #region     -------ͼ
        private const int tickFontSpac = 10;                //ʱ߽
        private const int tickTopBounds = 20;               //˱߽
        private const int tickBottomBounds = 30;            //ײ߽
        private const int tickLeftBounds = 60;              //߽
        private const int tickRightBounds = 10;             //Ҷ˱߽
        private const int tickScroll = 15;					//߶
        private const int tickClearance = 3;				//϶
        private Font fontCoordinate;                        //
        #endregion

        #region     -------ͼ
        private int intXMax, intYMax, intXMin, intYMin;
        private Rectangle selectedRec;                                                              //ǰѡĻλ  
        private Rectangle drawedRec;                                                                //ѾƵĻλ
        SolidBrush brushSelectedRec = new SolidBrush(Color.FromArgb(80, Color.Transparent));       //ѡлλɫ
        Color paintBorderColor = Color.Navy;                                                        //ͼ߿ɫ

        string stackDevice = string.Empty;                                                                //Ѷ豸
        string laneway = string.Empty;
        
        string wareHouse = string.Empty;                                                            //ѡĲֿ
        string wareHouseDescription = string.Empty;                                                 //ֿ
        private int selectedZ;                                                                      //ѡ
        private string selectedCellCode = string.Empty;                                             //ѡĻλ
        private int selectedCellStatus;                                                             //ѡĻλ洢״̬
        private int selectedRunStatus;                                                              //ѡĻλ״̬
        private string BoxBarCode = string.Empty;                                                   //Ϣ20110425
        #endregion

        #endregion

        #region 
        /// <summary>
        /// 
        /// </summary>
        public string GoodsName
        {
            set { goodsName = value; }
        }
        /// <summary>
        /// ֿ
        /// </summary>
        public string WareHouse
        {
            get { return this.wareHouse; }
            set
            {
                this.wareHouse = value;
                if (!this.DesignMode)
                {
                    //object obj = bllOperation.GetSingle("FNAME", "T_ITEMWAREHOUSE", "FCODE = '" + value + "'");
                    //if (obj != null)
                    //{
                    cmbWareHouse.SelectedValue = value;
                    //wareHouseDescription = obj.ToString();
                    //}
                }
            }
        }

        /// <summary>
        /// Ѷ豸
        /// </summary>
        public string StackDevice
        {
            get { return stackDevice; }
            set 
            {
                stackDevice = value;
                DataView dv = dbo.ExceSQL("SELECT min(F_Z) FROM ST_CELL WHERE (FStack = " + stackDevice + ")").Tables[0].DefaultView;
                if (dv.Count > 0)
                {
                    SelectedZ = Convert.ToInt32(dv[0][0]);
                }
                
            }
        }

        /// <summary>
        /// 豸
        /// </summary>
        public string Laneway
        {
            get { return laneway; }
            set {

                laneway = value;
                
                DataView dv = dbo.ExceSQL("SELECT min(F_Z) FROM ST_CELL WHERE (Flaneway = " + laneway  + ")").Tables[0].DefaultView;
                if (dv.Count > 0)
                {
                    SelectedZ = Convert.ToInt32(dv[0][0]);
                }
            }
        }
        /// <summary>
        /// طݵĿؼ
        /// </summary>
        public Control ControlCellCode
        {
            get { return controlCellCode; }
            set { controlCellCode = value; }
        }

        /// <summary>
        /// 
        /// </summary>
        public int SelectedZ
        {
            get { return this.selectedZ; }
            set
            {
                if (!this.DesignMode)
                {
                    this.selectedZ = value;
                    //ʼ
                    InitDataTable();
                    this.cmbLine.Text = value.ToString();

                    //»
                    panelCell.Invalidate();
                }
            }
        }

        /// <summary>
        /// λCellCode
        /// </summary>
        public string CellCode
        {
            get { return this.selectedCellCode.TrimEnd(); }
            set
            {
                selectedCellCode = value;
            }
        }

        /// <summary>
        /// λ
        /// </summary>
        public int CellID
        {
            get { return cellID; }
            set { cellID = value; ShowCellInformation(); }
        }

        /// <summary>
        /// 
        /// </summary>
        public string TaskType
        {
            set { taskType = Convert.ToInt32(value); }
        }

        private bool allowWareHouseChanged = false;

        /// <summary>
        /// ֿǷѡ
        /// </summary>
        public bool AllowWareHouseChanged
        {
            set { allowWareHouseChanged = value; cmbWareHouse.Enabled = allowWareHouseChanged; }
        }

        #endregion

        #region 캯

        public UCellPanel()
        {
            InitializeComponent();

            //ʽ
            panelCell.AutoScroll = true;
            this.SetStyle(ControlStyles.UserPaint | ControlStyles.ResizeRedraw | ControlStyles.AllPaintingInWmPaint | ControlStyles.DoubleBuffer, true);
            this.cmbLine.SelectionChangeCommitted += new EventHandler(cmbLine_SelectionChangeCommitted);

            this.fontCoordinate = new Font("Tohoma", 9, FontStyle.Bold);
        }

        /// <summary>
        /// 캯
        /// </summary>
        /// <param name="parent"></param>
        /// <param name="control">ؼ</param>
        /// <param name="type">ManageType</param>
        /// <param name="where">ɸѡ</param>
        public UCellPanel(Form parent, Control control, Control ctrlShow,Control ctrlBarCode, string where)
            : this()
        {
            this.parentForm = parent;
            controlCellCode = control;
            controlShow = ctrlShow;
            controlBarCode = ctrlBarCode;
            //taskType = type;

            //T_WAREHOUSE
            DataTable tableWareHouse = dbo.ExceSQL("SELECT F_WarehouseIndex,F_Description FROM T_WAREHOUSE").Tables[0];
            cmbWareHouse.DisplayMember = "F_Description";
            cmbWareHouse.ValueMember = "F_WarehouseIndex";

            cmbWareHouse.DataSource = tableWareHouse.DefaultView;
            
            //ʼ
            if (cmbWareHouse.SelectedValue != null)
            {
                WareHouse = cmbWareHouse.SelectedValue.ToString();
                SelectedZ = 1;
            }
        }

        #endregion

        #region ʼ

        /// <summary>
        /// ʼ
        /// </summary>
        private void InitDataTable()
        {
            string strstack = "";
            if (StackDevice != string.Empty)
            {
                strstack = " and FStack=" + StackDevice + " ";
            }
            string strlaneway = "";
            if (laneway != string.Empty)
            {
                strlaneway = " and FLaneway=" + laneway + " ";
            }
            //st_Cell ֵ
            tableLines = dbo.ExceSQL("SELECT DISTINCT F_Z FROM ST_CELL WHERE FWAREHOUSE = '" + this.wareHouse + "' " + strstack + strlaneway + " ORDER BY F_Z").Tables[0];
            cmbLine.DisplayMember = "F_Z";
            cmbLine.DataSource = this.tableLines;

            //ST_Cell
            tableCellInfoList = dbo.ExceSQL("SELECT * FROM ST_CELL WHERE  ST_CELL.FWAREHOUSE = '" + this.wareHouse + "' AND F_Z = '" + selectedZ + "' ORDER BY F_X,F_Y DESC").Tables[0];
            int count = tableCellInfoList.Rows.Count;

            //ʼֵ
            InitMaxSet();

            //ѡлλΪ
            selectedRec = Rectangle.Empty;
        }

        //ȡУù
        private void InitMaxSet()
        {
            DataView dv = dbo.ExceSQL("SELECT MAX(F_X) FROM ST_CELL WHERE FWAREHOUSE = '" + wareHouse + "' ").Tables[0].DefaultView;
            if (dv.Count > 0)
            {
                intXMax =Convert.ToInt32( dv[0][0]);
            }
            dv = dbo.ExceSQL("SELECT MAX(F_Y) FROM ST_CELL WHERE FWAREHOUSE = '" + wareHouse + "'").Tables[0].DefaultView;
            if (dv.Count > 0)
            {
                intYMax = Convert.ToInt32(dv[0][0]);
            }
            dv = dbo.ExceSQL("SELECT MIN(F_X) FROM ST_CELL WHERE FWAREHOUSE = '" + wareHouse + "'").Tables[0].DefaultView;
            if (dv.Count > 0)
            {
                intXMin = Convert.ToInt32(dv[0][0]);
            }
            dv = dbo.ExceSQL("SELECT MIN(F_Y) FROM ST_CELL WHERE FWAREHOUSE = '" + wareHouse + "' ").Tables[0].DefaultView;
            if (dv.Count > 0)
            {
                intYMin = Convert.ToInt32(dv[0][0]);
            }

            
            
            //
            panelCell.AutoScrollMinSize = new Size((Convert.ToInt32(bigWidth) + 2 * tickClearance) * (intXMax - intXMin + 1) + tickLeftBounds + 2 * tickClearance + tickFontSpac + tickScroll, (Convert.ToInt32(bigHeight) + 2 * tickClearance) * (intYMax - intYMin + 1) + 3 * tickTopBounds);
        }

        #endregion

        #region ComboBox SeletedValueChangedı

        /// <summary>
        /// ѡֿ
        /// </summary>
        private void cmbWareHouse_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cmbWareHouse.SelectedValue != null)
            {
                wareHouse = cmbWareHouse.SelectedValue.ToString();
                DataView dv = dbo.ExceSQL("SELECT F_Description FROM T_WAREHOUSE WHERE F_WarehouseIndex = '" + wareHouse+ "'").Tables[0].DefaultView;
                if (dv.Count > 0)
                {
                    wareHouseDescription = dv[0]["F_Description"].ToString();
                }
            }
            SelectedZ = 1;
        }

        /// <summary>
        /// ComboBox SeletedValueChangedı
        /// </summary>
        private void cmbLine_SelectionChangeCommitted(object sender, EventArgs e)
        {
            SetBeginData();
            SelectedZ = Convert.ToInt32(this.cmbLine.Text);
        }

        /// <summary>
        /// ָʼ
        /// </summary>
        private void SetBeginData()
        {
            //ʼʾ
            panelCell.AutoScrollPosition = new Point(0, 0);

            cellID = -1;
            selectedCellCode = string.Empty;
            BoxBarCode = string.Empty;
            selectedRec = Rectangle.Empty;
            drawedRec = Rectangle.Empty;

            lblCellCode.Text = string.Empty;
            lblCellStatus.Text = string.Empty;
            lblRunStatus.Text = string.Empty;
            lblBoxCode.Text = string.Empty;
            txtCellCode.Clear();
        }

        #endregion

        #region ƻλ

        /// <summary>
        /// ƻλ
        /// </summary>
        private void panelCell_Paint(object sender, PaintEventArgs e)
        {
            if (this.DesignMode)
                return;

            Graphics g = e.Graphics;
            //g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;

            //ù
            g.TranslateTransform(panelCell.AutoScrollPosition.X, panelCell.AutoScrollPosition.Y);

            int minBottom = 0, maxRight = 0;                                    //Ե¼
            int nextPosition = tickTopBounds;                                   //һͼλ  
            int currentPosition = 0;                                            //ǰλ 
            Rectangle cellPaint = Rectangle.Empty;                              //Ƶ
            Point p1, p2;                                                       //ĵ
            Dictionary<int, int> paintArea = new Dictionary<int, int>();        //ͼλ

            int x = 0, y = 0;										            //ƻ
            int width = 0, height = 0;                                          //ƻĳ

            //洢
            int areaWith = 0;                                                   //Ŀ
            int areaHeight = 0;                                                 //ĸ߶

            string code;                                                        //λ
            int i = 0, j = 0, k = 0;                                              //
            //char side = Char.MinValue;                                          //˫λ

            //ձļ¼
            listCellCode.Clear();
            listRecCell.Clear();
            listCellID.Clear();

            //ͼ
            foreach (DataRow rowCell in tableCellInfoList.Rows)
            {
                //λ
                code = rowCell["FCELLCODE"].ToString().TrimEnd();
                i = Convert.ToInt32(code.Split('-')[1]);
                j = Convert.ToInt32(code.Split('-')[2]);

                //ݻߴ
                
                areaWith = bigWidth + 2 * tickClearance;
                areaHeight = bigHeight + 2 * tickClearance;
                

                #region     -------

                if (k == 0 || (k > 0 && code.Split('-').Length == 3) || (k > 0 && (code.Split('-').Length == 4) && listCellCode[k - 1].Substring(0, listCellCode[k - 1].Length - 2) != code.Substring(0, code.Length - 2)))
                {
                    //㵱ǰλúһλ
                    if (paintArea.ContainsKey(j))
                    {
                        currentPosition = paintArea[j];
                        nextPosition = currentPosition + areaHeight;
                    }
                    else
                    {
                        currentPosition = nextPosition;
                        nextPosition = currentPosition + areaHeight;
                        //洢ֵ
                        paintArea[j] = currentPosition;
                    }
                    

                    //ǰ
                    x = tickLeftBounds + areaWith * (i - intXMin);
                    y = currentPosition;

                    //ɫ
                    g.FillRectangle(new SolidBrush(Color.FromArgb(-8355585)), x, y, areaWith, areaHeight);

                    //
                    //width = Convert.ToInt32(rowCell["FWIDTH"].ToString());
                    //height = (Convert.ToInt32(rowCell["FCELLMODEL"]) == 2) ? Convert.ToInt32(rowCell["FLENGTH"].ToString()) + 2 * tickClearance : Convert.ToInt32(rowCell["FLENGTH"].ToString());
                    width = bigWidth;
                    height =  bigHeight;

                    //ͼ¼ʼ
                    x += tickClearance;
                    y += tickClearance;
                }

                #endregion

                #region     ----жϻλ--λ˫λ
                
                    //洢ƻλκͻλ
                    listRecCell.Insert(k, new Rectangle(x, y, width, height));
                    listCellCode.Insert(k, code);
                    listCellID.Insert(k, Convert.ToInt32(rowCell["FID"]));

                    //񱳾ɫ
                    g.FillRectangle(new SolidBrush(Color.Black), x, y, width + 1, height + 1);
                    //洢״̬ɫ
                    if (rowCell["FCELLSTATUS"].ToString().TrimEnd() == "1")//20110101
                    {
                        g.FillRectangle(new SolidBrush(Color.Navy), listRecCell[k]);
                    }
                    else
                        if (rowCell["FCELLSTATUS"].ToString().TrimEnd() == "0")//20110101
                        {
                            g.FillRectangle(new SolidBrush(Color.FromArgb(Convert.ToInt32(-12550016))), listRecCell[k]);

                        }
                        else//-1
                        {
                            g.FillRectangle(new SolidBrush(Color.Red), listRecCell[k]);
                        }

                    //״̬ʾ
                    if (rowCell["FRUNSTATUS"].ToString().TrimEnd() == "1")
                    {
                        g.DrawString("R", fontCoordinate, new SolidBrush(Color.Lime), x + width / 2 - 5, y + height / 2 - fontCoordinate.Height / 2);
                    }
                    else
                    {
                        g.DrawString("", fontCoordinate, new SolidBrush(Color.Black), x + width / 2 - 5, y + height / 2 - fontCoordinate.Height / 2);
                    }
                

                #endregion

                //Ե
                if (intXMax == i && maxRight == 0)
                    maxRight = x + areaWith - tickLeftBounds - tickClearance;
                if (intYMin == j && minBottom == 0)
                    minBottom = nextPosition - tickTopBounds;

                //
                k++;

                //X  Ҫʾ̶
                if (((i+1) % 5 == 0 && j == intYMin) || (i == intXMax - 1 && i > 5 && j == intYMin))
                    g.DrawString((i + 1).ToString(), this.fontCoordinate, Brushes.Black, x + width / 2 - this.fontCoordinate.Height / 2 + width + 3, nextPosition + tickClearance + tickFontSpac);
                //Y
                if (i == intXMin)
                    g.DrawString(i.ToString(), this.fontCoordinate, Brushes.Black,x + width / 2 - this.fontCoordinate.Height / 2  + 3, nextPosition + tickClearance + tickFontSpac);
                if ((j % 5 == 0 && i == intXMin) || (j == intYMax && j > 5 && i == intXMin))
                    g.DrawString(j.ToString(), this.fontCoordinate, Brushes.Black, tickLeftBounds - tickFontSpac - tickClearance - 3 * this.fontCoordinate.Height / 2, y + height / 2 - this.fontCoordinate.Height / 2);
            }

            #region     ------ԭ

            //ƻͼ߿
            cellPaint = new Rectangle(tickLeftBounds, tickTopBounds, maxRight, minBottom);
            g.DrawRectangle(new Pen(paintBorderColor, 2), cellPaint);

            //X
            p1 = new Point(tickLeftBounds - tickFontSpac, cellPaint.Bottom + tickFontSpac);
            p2 = new Point(cellPaint.Right + tickClearance + tickFontSpac, cellPaint.Bottom + tickFontSpac);
            g.DrawLine(new Pen(Color.Black, 2), p1, p2);
            //Ƽͷ
            g.DrawLine(new Pen(Color.Black, 1), p2, new Point(p2.X - tickClearance, p2.Y + tickClearance));
            g.DrawLine(new Pen(Color.Black, 1), p2, new Point(p2.X - tickClearance, p2.Y - tickClearance));

            //Y
            p2 = new Point(tickLeftBounds - tickFontSpac, tickTopBounds - tickFontSpac);
            g.DrawLine(new Pen(Color.Black, 2), p1, p2);
            //Ƽͷ
            g.DrawLine(new Pen(Color.Black, 1), p2, new Point(p2.X - tickClearance, p2.Y + tickClearance));
            g.DrawLine(new Pen(Color.Black, 1), p2, new Point(p2.X + tickClearance, p2.Y + tickClearance));

            //ԭ
            p2 = new Point(tickLeftBounds - tickFontSpac - tickClearance - 3 * this.fontCoordinate.Height / 2, cellPaint.Bottom + tickFontSpac + tickClearance);
            g.DrawString("O", new Font("Tohoma", 9, FontStyle.Bold | FontStyle.Italic), Brushes.Black, p2);

            #endregion

            //ѡλĻƾδС
            if (cellID != -1)
            {
                int index = listCellID.IndexOf(cellID);
                if (index != -1)
                    selectedRec = listRecCell[index];
            }

            //ͻʾѡеĻλ
            DrawSelectedRectangel();

            //ͷ
            g.Dispose();
            paintArea.Clear();
        }

        #endregion

        #region Mouse Down Event

        /// <summary>
        /// ʱʾλϢ
        /// </summary>
        private void panelCell_MouseClick(object sender, MouseEventArgs e)
        {
            foreach (Rectangle recCell in listRecCell)
            {
                if (recCell.Contains(e.X + Math.Abs(panelCell.AutoScrollPosition.X), e.Y + Math.Abs(panelCell.AutoScrollPosition.Y)))
                {
                    //ʽ
                    if (recCell != drawedRec)
                    {
                        //ûλ
                        int index = listRecCell.IndexOf(recCell);
                        selectedCellCode = listCellCode[index];
                        cellID = listCellID[index];
                        selectedRec = listRecCell[index];

                        //ʾλϢ
                        ShowCellInformation();

                        //ʽ
                        DrawSelectedRectangel();
                    }
                    break;
                }
            }
        }

        /// <summary>
        /// ʾλϢ
        /// </summary>
        private void ShowCellInformation()
        {
            //λ
            DataRow[] rows = tableCellInfoList.Select("FID = '" + cellID + "'");
            if (rows.Length > 0)
            {
                //ѡĻλĵǰDataRow
                DataRow row = rows[0];

                //״̬
                selectedCellStatus = Convert.ToInt32(row["FCELLSTATUS"]);
                selectedRunStatus = Convert.ToInt32(row["FRUNSTATUS"]);

                //ʾϢ
                this.lblCellCode.Text = row["FCELLCODE"].ToString();
                this.lblBoxCode.Text = row["FPALLETBARCODE"].ToString();//20110425
                lblCellStatus.Text = "";
                lblRunStatus.Text = "";
            }
        }

        /// <summary>
        /// ѡĻλʽ
        /// </summary>
        private void DrawSelectedRectangel()
        {
            //жǷظλ
            if (selectedRec == Rectangle.Empty || cellID == -1)
                return;

            //ȡɵѡʽ
            if (selectedRec != drawedRec && drawedRec != Rectangle.Empty)
                panelCell.Invalidate(new Rectangle(drawedRec.X - Math.Abs(panelCell.AutoScrollPosition.X) - 1, drawedRec.Y - Math.Abs(panelCell.AutoScrollPosition.Y) - 1, drawedRec.Width + 2, drawedRec.Height + 2));

            using (Graphics g = panelCell.CreateGraphics())
            {
                Rectangle recTrans = new Rectangle(selectedRec.X - Math.Abs(panelCell.AutoScrollPosition.X), selectedRec.Y - Math.Abs(panelCell.AutoScrollPosition.Y), selectedRec.Width, selectedRec.Height);
                g.DrawRectangle(new Pen(Color.Red, 2), recTrans);
                g.FillRectangle(brushSelectedRec, recTrans);

                //¼¼ƵĻλ
                drawedRec = selectedRec;

                //ͷ
                g.Dispose();
            }
        }

        #endregion

        #region ˫ʱݻλ

        /// <summary>
        /// ˫ʱݻλ
        /// </summary>
        private void panelCell_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (e.Button != MouseButtons.Left)
                return;

            if (parentForm == null || controlCellCode == null)//20110425
                return;

            //ѡλ
            cellID = -1;
            selectedCellCode = string.Empty;
            selectedRec = Rectangle.Empty;
            BoxBarCode = string.Empty;
            foreach (Rectangle recCell in listRecCell)
            {
                if (recCell.Contains(e.X + Math.Abs(panelCell.AutoScrollPosition.X), e.Y + Math.Abs(panelCell.AutoScrollPosition.Y)))
                {
                    //ûλ
                    int index = listRecCell.IndexOf(recCell);
                    selectedCellCode = listCellCode[index];
                    cellID = listCellID[index];
                    selectedRec = listRecCell[index];
                    DataRow[] rows = tableCellInfoList.Select("FID = '" + cellID + "'");
                    if (rows.Length > 0)
                    {
                        DataRow row = rows[0];
                        BoxBarCode = row["FPALLETBARCODE"].ToString();//20110425
                    }
                    break;
                }
            }

            if (cellID == -1)
                return;

            

            //ݻλֵ
            SetCellCode();
            
        }

        /// <summary>
        /// Ϊؼݻλ
        /// </summary>
        private void SetCellCode()
        {
            if (controlCellCode.GetType() == typeof(TextBox))
            {
                TextBox textBox = controlCellCode as TextBox;
                textBox.Text = selectedCellCode;
            }
            else if (controlCellCode.GetType() == typeof(ComboBox))
            {
                ComboBox comboBox = controlCellCode as ComboBox;
                comboBox.Text = selectedCellCode;
              
            }
            if (controlBarCode!=null)
            {
            if (controlBarCode.GetType() == typeof(TextBox))
            {
                TextBox textBox = controlBarCode as TextBox;
                //if (BoxBarCode != "-")
                //{
                    textBox.Text = BoxBarCode;
                //}
            }
            else if (controlBarCode.GetType() == typeof(ComboBox))
            {
                ComboBox comboBox = controlBarCode as ComboBox;
                //if (BoxBarCode!="-")
                //{
                comboBox.Text = BoxBarCode;
                //}

            }
            }

            //ؿؼ
            if (controlShow != null)
            {
                if (controlShow.GetType() == typeof(SplitContainer))
                {
                    SplitContainer splitContainer = controlShow as SplitContainer;
                    splitContainer.Panel1Collapsed = true;
                }
            }
            //this.Hide();
            //this.Parent.Visible = false;
        }

        #endregion

        #region ˢ

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnFind_Click(object sender, EventArgs e)
        {
            if (txtCellCode.Text == string.Empty)
                return;

            int index = listCellCode.IndexOf(txtCellCode.Text);
            if (index == -1)
                return;

            //¼λϢ
            selectedCellCode = txtCellCode.Text.TrimEnd();
            cellID = listCellID[index];

            //ָλ
            FindCell();
        }

        /// <summary>
        /// ָλ
        /// </summary>
        private void FindCell()
        {
            if (cellID == -1)
                return;

            int index = listCellID.IndexOf(cellID);
            if (index == -1)
                return;

            Rectangle recFind = listRecCell[index];
            if (recFind != drawedRec)
            {
                selectedRec = recFind;

                //ʾλϢ
                ShowCellInformation();
                //ѡλʽ
                DrawSelectedRectangel();
            }

            //ֵ
            int difX = (selectedRec.X - Math.Abs(panelCell.AutoScrollPosition.X)) - panelCell.AutoScrollPosition.X - panelCell.Width / 2;
            int difY = (selectedRec.Y - Math.Abs(panelCell.AutoScrollPosition.Y)) - panelCell.AutoScrollPosition.Y - panelCell.Height / 2;

            //ù
            panelCell.AutoScrollPosition = new Point(difX, difY);
        }

        /// <summary>
        /// Ӧس,
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtCellCode_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                btnFind_Click(null, EventArgs.Empty);
            }
        }

        /// <summary>
        /// ˢ°ť
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnUpdate_Click(object sender, EventArgs e)
        {
            if (cmbLine.Text == string.Empty)
                return;

            this.SelectedZ = int.Parse(cmbLine.Text);

            //ָλ
            int index = listCellID.IndexOf(cellID);
            if (index == -1)
                return;

            //¼λϢ
            selectedCellCode = listCellCode[index];
            FindCell();
        }

        #endregion

        #region ȡѡر
        /// <summary>
        /// رջظؼ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnHide_Click(object sender, EventArgs e)
        {
            this.Hide();
            this.Parent.Visible = false;
        }

        #endregion
    }
}
