using System;
using System.Collections;
using System.Collections.Specialized;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
namespace Dictionary.DBUtility
{
    /// <summary>
    /// ݷʳ
    /// Copyright (C) 2004-2008 
    /// All rights reserved
    /// </summary>
    public abstract class DbHelperSQL
    {
        //ݿַ(web.config)
        public static string _dbconnString = ConfigurationSettings.AppSettings["_dbconnString"];
        //public static string _dbconnString = LTP.Common.DEncrypt.DESEncrypt.Decrypt(LTP.Common.ConfigHelper.GetConfigString("_dbconnString"));
        public DbHelperSQL()
        {
        }

        #region ÷

        public static int GetMaxID(string FieldName, string TableName)
        {
            string strsql = "select max(" + FieldName + ")+1 from " + TableName;
            object obj = GetSingle(strsql);
            if (obj == null)
            {
                return 1;
            }
            else
            {
                return int.Parse(obj.ToString());
            }
        }
        public static bool Exists(string strSql)
        {
            object obj =GetSingle(strSql);
            int cmdresult;
            if ((Object.Equals(obj, null)) || (Object.Equals(obj, System.DBNull.Value)))
            {
                cmdresult = 0;
            }
            else
            {
                cmdresult = int.Parse(obj.ToString());
            }
            if (cmdresult == 0)
            {
                return false;
            }
            else
            {
                return true;
            }
        }
        public static bool Exists(string strSql, params SqlParameter[] cmdParms)
        {
            object obj =GetSingle(strSql, cmdParms);
            int cmdresult;
            if ((Object.Equals(obj, null)) || (Object.Equals(obj, System.DBNull.Value)))
            {
                cmdresult = 0;
            }
            else
            {
                cmdresult = int.Parse(obj.ToString());
            }
            if (cmdresult == 0)
            {
                return false;
            }
            else
            {
                return true;
            }
        }
        #endregion

        #region  ִмSQL

        /// <summary>
        /// ִSQL䣬Ӱļ¼
        /// </summary>
        /// <param name="SQLString">SQL</param>
        /// <returns>Ӱļ¼</returns>
        public static int ExecuteSql(string SQLString)
        {
           using (IDbCommand cmd = _dbf.GetDBCommand(SQLString, _dbconn))
                {
                    try
                    {
                        Open();
                        int rows = cmd.ExecuteNonQuery();
                        return rows;
                    }
                    catch (Exception E)
                    {
                        Close();
                        throw E;
                    }
                }
            
        }

        /// <summary>
        /// ִSQL䣬ִеȴʱ
        /// </summary>
        /// <param name="SQLString"></param>
        /// <param name="Times"></param>
        /// <returns></returns>
        public static int ExecuteSqlByTime(string SQLString, int Times)
        {
            using (IDbCommand cmd = _dbf.GetDBCommand(SQLString, _dbconn))
                {
                    try
                    {
                        Open();
                        cmd.CommandTimeout = Times;
                        int rows = cmd.ExecuteNonQuery();
                        return rows;
                    }
                    catch (Exception E)
                    {
                        Close();
                        throw new Exception(E.Message);
                    }
                }
            
        }

        /// <summary>
        /// ִжSQL䣬ʵݿ
        /// </summary>
        /// <param name="SQLStringList">SQL</param>		
        public static void ExecuteSqlTran(ArrayList SQLStringList)
        {
            	conn.Open();
                IDbCommand cmd = _dbf.GetDBCommand();//IDbCommand cmd = _dbf.GetDBCommand();
                cmd.Connection = _dbconn;
                TransBegin();
                cmd.Transaction = _dbtrans 
                try
                {
                    for (int n = 0; n < SQLStringList.Count; n++)
                    {
                        string strsql = SQLStringList[n].ToString();
                        if (strsql.Trim().Length > 1)
                        {
                            cmd.CommandText = strsql;
                            cmd.ExecuteNonQuery();
                        }
                    }
                    TransCommit();
                }
                catch (Exception E)
                {
                    tx.Rollback();
                    throw new Exception(E.Message);
                }
            
        }
        /// <summary>
        /// ִдһ洢̲SQL䡣
        /// </summary>
        /// <param name="SQLString">SQL</param>
        /// <param name="content">,һֶǸʽӵ£ţͨʽ</param>
        /// <returns>Ӱļ¼</returns>
        public static int ExecuteSql(string SQLString, string content)
        {
            IDbCommand cmd = _dbf.GetDBCommand(SQLString, _dbconn);
                IDbDataParameter myParameter =_dbf.GetParameter("@content", DbType.NText);
                myParameter.Value = content;
                cmd.Parameters.Add(myParameter);
                try
                {
                    Open();
                    int rows = cmd.ExecuteNonQuery();
                    return rows;
                }
                catch (Exception E)
                {
                    throw new Exception(E.Message);
                }
                finally
                {
                    cmd.Dispose();
                    Close();
                }
           
        }
        /// <summary>
        /// ִдһ洢̲ĵSQL䡣
        /// </summary>
        /// <param name="SQLString">SQL</param>
        /// <param name="content">,һֶǸʽӵ£ţͨʽ</param>
        /// <returns>Ӱļ¼</returns>
        public static object ExecuteSqlGet(string SQLString, string content)
        {
            IDbCommand cmd = _dbf.GetDBCommand(SQLString, _dbconn);
                IDbDataParameter myParameter =_dbf.GetParameter("@content", DbType.NText);
                myParameter.Value = content;
                cmd.Parameters.Add(myParameter);
                try
                {
                    Open();
                    object obj = cmd.ExecuteScalar();
                    if ((Object.Equals(obj, null)) || (Object.Equals(obj, System.DBNull.Value)))
                    {
                        return null;
                    }
                    else
                    {
                        return obj;
                    }
                }
                catch (Exception E)
                {
                    throw new Exception(E.Message);
                }
                finally
                {
                    cmd.Dispose();
                    Close();
                }
            
        }
        /// <summary>
        /// ݿͼʽֶ(Ƶһʵ)
        /// </summary>
        /// <param name="strSQL">SQL</param>
        /// <param name="fs">ͼֽ,ݿֶΪimage</param>
        /// <returns>Ӱļ¼</returns>
        public static int ExecuteSqlInsertImg(string strSQL, byte[] fs)
        {
            IDbCommand cmd = _dbf.GetDBCommand(strSQL, _dbconn);
                IDbDataParameter myParameter =_dbf.GetParameter("@fs", DbType.Image);
                myParameter.Value = fs;
                cmd.Parameters.Add(myParameter);
                try
                {
                    Open();
                    int rows = cmd.ExecuteNonQuery();
                    return rows;
                }
                catch (Exception E)
                {
                    throw new Exception(E.Message);
                }
                finally
                {
                    cmd.Dispose();
                    Close();
                }
            
        }

        /// <summary>
        /// ִһѯ䣬زѯobject
        /// </summary>
        /// <param name="SQLString">ѯ</param>
        /// <returns>ѯobject</returns>
        public static object GetSingle(string SQLString)
        {
            using (IDbCommand cmd = _dbf.GetDBCommand(SQLString, _dbconn))
                {
                    try
                    {
                        Open();
                        object obj = cmd.ExecuteScalar();
                        if ((Object.Equals(obj, null)) || (Object.Equals(obj, System.DBNull.Value)))
                        {
                            return null;
                        }
                        else
                        {
                            return obj;
                        }
                    }
                    catch (Exception e)
                    {
                        Close();
                        throw new Exception(e.Message);
                    }
                }
            
        }


        /// <summary>
        /// ִвѯ䣬SqlDataReader(ʹø÷мҪֹرSqlDataReader)
        /// </summary>
        /// <param name="strSQL">ѯ</param>
        /// <returns>SqlDataReader</returns>
        public static IDbDataReader ExecuteReader(string strSQL)
        {
            IDbCommand cmd = _dbf.GetDBCommand(strSQL, _dbconn);
            try
            {
                Open();
                IDataReader myReader =GetDataReader( cmd);
                return myReader;
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            //finally //ڴ˹رգ򣬷صĶ޷ʹ
            //{
            //	cmd.Dispose();
            //	Close();
            //}	


        }
        /// <summary>
        /// ִвѯ䣬DataSet
        /// </summary>
        /// <param name="SQLString">ѯ</param>
        /// <returns>DataSet</returns>
        public static DataSet Query(string SQLString)
        {
            try
            {
                IDbCommand dbc = _dbf.GetDBCommand();
                if (_dbtrans != null)
                {
                    dbc.Transaction = _dbtrans;
                }
                dbc.Connection = _dbconn;
                dbc.CommandText = sql;
                IDbDataAdapter ida = _dbf.GetDataAdapter(dbc);
                DataSet ds = new DataSet();
                ida.Fill(ds);
                return ds;
            }
            catch (Exception ex)
            {
                _DBConnInfo = ex.Message;
                throw ex;
                //return null;
            }
           
        }
        /// <summary>
        /// ִвѯ䣬DataSet,ִеȴʱ
        /// </summary>
        /// <param name="SQLString"></param>
        /// <param name="Times"></param>
        /// <returns></returns>
        public static DataSet Query(string SQLString, int Times)
        {
            DataSet ds = new DataSet();
                try
                {
                    Open();
		    IDbCommand dbc = _dbf.GetDBCommand();
                    if (_dbtrans != null)
                    {
                       dbc.Transaction = _dbtrans;
                    }
                    dbc.Connection = _dbconn;
                    dbc.CommandText = SQLString;
                    SqlDataAdapter command = new SqlDataAdapter(dbc);
                    command.SelectCommand.CommandTimeout = Times;
                    command.Fill(ds, "ds");
                }
                catch (Exception ex)
                {
                    throw new Exception(ex.Message);
                }
                return ds;
            
        }



        #endregion

        #region ִдSQL

        /// <summary>
        /// ִSQL䣬Ӱļ¼
        /// </summary>
        /// <param name="SQLString">SQL</param>
        /// <returns>Ӱļ¼</returns>
        public static int ExecuteSql(string SQLString, params IDbDataParameter[] cmdParms)
        {
            using (IDbCommand cmd = _dbf.GetDBCommand())
                {
                    try
                    {
                        PrepareCommand(cmd, _dbconn, null, SQLString, cmdParms);
                        int rows = cmd.ExecuteNonQuery();
                        cmd.Parameters.Clear();
                        return rows;
                    }
                    catch (Exception E)
                    {
                        throw new Exception(E.Message);
                    }
                }
           
        }


        /// <summary>
        /// ִжSQL䣬ʵݿ
        /// </summary>
        /// <param name="SQLStringList">SQLĹϣkeyΪsql䣬valueǸSqlParameter[]</param>
        public static void ExecuteSqlTran(Hashtable SQLStringList)
        {
            Open();
                TransBegin();
                    IDbCommand cmd = _dbf.GetDBCommand();
                    try
                    {
                        //ѭ
                        foreach (DictionaryEntry myDE in SQLStringList)
                        {
                            string cmdText = myDE.Key.ToString();
                            IDbDataParameter[] cmdParms = (IDbDataParameter[])myDE.Value;
                            PrepareCommand(cmd, _dbconn, _dbtrans, cmdText, cmdParms);
                            int val = cmd.ExecuteNonQuery();
                            cmd.Parameters.Clear();

                            TransCommit();
                        }
                    }
                    catch
                    {
                        TransRollback();
                        throw;
                    }
               
            }
        }


        /// <summary>
        /// ִһѯ䣬زѯobject
        /// </summary>
        /// <param name="SQLString">ѯ</param>
        /// <returns>ѯobject</returns>
        public static object GetSingle(string SQLString, params IDbDataParameter[] cmdParms)
        {
            using (IDbCommand cmd = _dbf.GetDBCommand())
                {
                    try
                    {
                        PrepareCommand(cmd, _dbconn, null, SQLString, cmdParms);
                        object obj = cmd.ExecuteScalar();
                        cmd.Parameters.Clear();
                        if ((Object.Equals(obj, null)) || (Object.Equals(obj, System.DBNull.Value)))
                        {
                            return null;
                        }
                        else
                        {
                            return obj;
                        }
                    }
                    catch (Exception e)
                    {
                        throw new Exception(e.Message);
                    }
                }
            
        }

        /// <summary>
        /// ִвѯ䣬SqlDataReader (ʹø÷мҪֹرSqlDataReader)
        /// </summary>
        /// <param name="strSQL">ѯ</param>
        /// <returns>SqlDataReader</returns>
        public static IDataReader ExecuteReader(string SQLString, params IDbDataParameter[] cmdParms)
        {
            
            IDbCommand cmd = _dbf.GetDBCommand();
            try
            {
                PrepareCommand(cmd, _dbconn, null, SQLString, cmdParms);
                IDataReader myReader =_dbf.GetDataReader( cmd);
                cmd.Parameters.Clear();
                return myReader;
            }
            catch (Exception e)
            {
                throw new Exception(e.Message);
            }
            //finally //ڴ˹رգ򣬷صĶ޷ʹ
            //{
            //	cmd.Dispose();
            //	Close();
            //}	

        }

        /// <summary>
        /// ִвѯ䣬DataSet
        /// </summary>
        /// <param name="SQLString">ѯ</param>
        /// <returns>DataSet</returns>
        public static DataSet Query(string SQLString, params IDbDataParameter[] cmdParms)
        {
            
                IDbCommand cmd = _dbf.GetDBCommand();
                PrepareCommand(cmd, _dbconn, null, SQLString, cmdParms);
                using (IDataAdapter da = _dbf.GetDataAdapter(cmd))
                {
                    DataSet ds = new DataSet();
                    try
                    {
                        da.Fill(ds, "ds");
                        cmd.Parameters.Clear();
                    }
                    catch (Exception ex)
                    {
                        throw new Exception(ex.Message);
                    }
                    return ds;
                }
             
        }


        private static void PrepareCommand(IDbCommand cmd, IDbConnection conn, IDbTransaction trans, string cmdText, SqlParameter[] cmdParms)
        {
            Open();
            cmd.Connection = _dbconn;
            cmd.CommandText = cmdText;
            if (trans != null)
                cmd.Transaction = trans;
            cmd.CommandType = CommandType.Text;//cmdType;
            if (cmdParms != null)
            {


                foreach (IDbDataParameter parameter in cmdParms)
                {
                    if ((parameter.Direction == ParameterDirection.InputOutput || parameter.Direction == ParameterDirection.Input) &&
                        (parameter.Value == null))
                    {
                        parameter.Value = DBNull.Value;
                    }
                    cmd.Parameters.Add(parameter);
                }
            }
        }

        #endregion

        #region 洢̲

        /// <summary>
        /// ִд洢  (ʹø÷мҪֹرSqlDataReader)
        /// </summary>
        /// <param name="storedProcName">洢</param>
        /// <param name="parameters">洢̲</param>
        /// <returns>SqlDataReader</returns>
        public static IDataReader RunProcedure(string storedProcName, IDataParameter[] parameters)
        {
            
            SqlDataReader returnReader;
            Open();
            IDbCommand command = BuildQueryCommand(_dbconn, storedProcName, parameters);
            command.CommandType = CommandType.StoredProcedure;
            returnReader =_dbf.GetDataReader();
            //Close(); ڴ˹رգ򣬷صĶ޷ʹ            
            return returnReader;

        }


        /// <summary>
        /// ִд洢
        /// </summary>
        /// <param name="storedProcName">洢</param>
        /// <param name="parameters">洢̲</param>
        /// <param name="tableName">DataSetеı</param>
        /// <returns>DataSet</returns>
        public static DataSet RunProcedure(string storedProcName, IDataParameter[] parameters, string tableName)
        {
             
                DataSet dataSet = new DataSet();
                Open();
                IDbDataAdapter sqlDA = _dbf.GetDataAdapter();
                sqlDA.SelectCommand = BuildQueryCommand(_dbconn, storedProcName, parameters);
                sqlDA.Fill(dataSet, tableName);
                Close();
                return dataSet;
            
        }
        public static DataSet RunProcedure(string storedProcName, IDataParameter[] parameters, string tableName, int Times)
        {
           
                DataSet dataSet = new DataSet();
                Open();
                IDbDataAdapter sqlDA = _dbf.GetDataAdapter();
                sqlDA.SelectCommand = BuildQueryCommand(_dbconn, storedProcName, parameters);
                sqlDA.SelectCommand.CommandTimeout = Times;
                sqlDA.Fill(dataSet, tableName);
                Close();
                return dataSet;
            
        }


        /// <summary>
        ///  SqlCommand (һһֵ)
        /// </summary>
        /// <param name="_dbconn">ݿ</param>
        /// <param name="storedProcName">洢</param>
        /// <param name="parameters">洢̲</param>
        /// <returns>SqlCommand</returns>
        private static IDbCommand BuildQueryCommand(IDbConnection _dbconn, string storedProcName, IDataParameter[] parameters)
        {
            IDbCommand command = _dbf.GetDBCommand(storedProcName, _dbconn);
            command.CommandType = CommandType.StoredProcedure;
            foreach (SqlParameter parameter in parameters)
            {
                if (parameter != null)
                {
                    // δֵ,DBNull.Value.
                    if ((parameter.Direction == ParameterDirection.InputOutput || parameter.Direction == ParameterDirection.Input) &&
                        (parameter.Value == null))
                    {
                        parameter.Value = DBNull.Value;
                    }
                    command.Parameters.Add(parameter);
                }
            }

            return command;
        }

        /// <summary>
        /// ִд洢̣Ӱ		
        /// </summary>
        /// <param name="storedProcName">洢</param>
        /// <param name="parameters">洢̲</param>
        /// <param name="rowsAffected">Ӱ</param>
        /// <returns></returns>
        public static int RunProcedure(string storedProcName, IDataParameter[] parameters, out int rowsAffected)
        {
             
                int result;
                Open();
                IDbCommand command = BuildIntCommand(_dbconn, storedProcName, parameters);
                rowsAffected = command.ExecuteNonQuery();
                result = (int)command.Parameters["ReturnValue"].Value;
                //Close();
                return result;
             
        }

        /// <summary>
        ///  SqlCommand ʵ(һֵ)	
        /// </summary>
        /// <param name="storedProcName">洢</param>
        /// <param name="parameters">洢̲</param>
        /// <returns>SqlCommand ʵ</returns>
        private static IDbCommand BuildIntCommand(IDbConnection _dbconn, string storedProcName, IDataParameter[] parameters)
        {
            IDbCommand command = BuildQueryCommand(_dbconn, storedProcName, parameters);
            command.Parameters.Add(new SqlParameter("ReturnValue",
                SqlDbType.Int, 4, ParameterDirection.ReturnValue,
                false, 0, 0, string.Empty, DataRowVersion.Default, null));
            return command;
        }
        #endregion

    }

}
