using System;
using System.Collections.Generic;
using System.Text;
using ICommLayer;
using DBFactory;
using System.Data;
using Microsoft.VisualBasic;
namespace SimensProdave6
{
    public class CSendDeviceOrder:ISendDeviceOrder
    {
        string _commLayerError;

        public string CommLayerError
        {
            get { return _commLayerError; }
            set { _commLayerError = value; }
        }
        DBOperator dbo = CSimensProdave6_S7.dbo;
        public CSendDeviceOrder()
        {
            dbo.Open();
        }
        /// <summary>
        /// ͶѶ
        /// </summary>
        /// <param name="MessageIndex">Ϣ</param>
        /// <param name="TaskIndex"></param>
        /// <param name="Order">Ѷ</param>
        ///1-λ 
        ///2-ȡ 
        ///3-
        ///4-ȡ
        ///5-Ż
        ///6-ȡŻ
        /// <param name="DeviceIndex">豸</param>
        /// <param name="StartX">ʼx꣬-ع</param>
        /// <param name="StartY">ʼy꣬-߶ȷ</param>
        /// <param name="StartZ">ʼz꣬-Ѷ壬1-࣬2-Ҳ</param>
        /// <param name="EndX">Ŀx꣬-ع</param>
        /// <param name="EndY">Ŀy꣬-߶ȷ</param>
        /// <param name="EndZ">Ŀz꣬-Ѷ壬1-࣬2-Ҳ</param>
        /// <returns>ͶѶǷɹ</returns>
        public bool SendDeviceOrder(int MessageIndex, int TaskIndex, int Order, int DeviceIndex, int StartX, int StartY, int StartZ, int EndX, int EndY, int EndZ)
        {
            try
            {
                int sn = 0;
                Model.MDevice devinfo = Model.CGetInfo.GetDeviceInfo(DeviceIndex);
                //DataView dv = dbo.ExceSQL("SELECT F_DBW1Address,F_DBWSendLength,F_DeviceIndex,F_DeviceKindIndex,F_OPCProgID, F_RemoteIP FROM T_Base_Device where F_DeviceIndex=" + DeviceIndex).Tables[0].DefaultView;
                if (devinfo.DeviceIndex == 0)
                {
                    _commLayerError = "SimensProdave6.CSendDeviceOrder.SendDeviceOrder豸ûҵ豸";
                    return false;
                }
                else
                {
                    if ((devinfo.DeviceKind.ToString() != "1") )
                    {//Ѷʹô˷
                        _commLayerError = "SimensProdave6.CSendDeviceOrder.SendDeviceOrder󣺶ѶRGV豸ʹô˷ȷ!";
                        return false;
                    }
                    #region Ѷ
                    
                    if (devinfo.DeviceKind.ToString() == "1")
                    {
                        byte[] wdata = new byte[10];
                        sn = Convert.ToInt32(devinfo.Dbw1Address);
                        wdata[0] =(byte) MessageIndex;
                        wdata[1] = (byte)Order;
                        wdata[2] = (byte)(TaskIndex>>8);
                        wdata[3] = (byte)(TaskIndex & 255);
                        if (MessageIndex == 1)
                        {
                            wdata[4] = (byte)(StartX + 1);
                        }
                        else
                        {
                            wdata[4] = (byte)StartX;
                        }
                        wdata[5] = (byte)StartY;
                        wdata[6] = (byte)StartZ;
                        if (MessageIndex == 1)
                        {
                            wdata[7] = (byte)(EndX + 1);
                        }
                        else
                        {
                            wdata[7] = (byte)EndX;
                        }
                        //wdata[7] = (byte)EndX;
                        wdata[8] = (byte)EndY;
                        wdata[9] = (byte)EndZ;
                        if (CSimensProdave6_S7.DB_Write_Prodave(0, 1, Convert.ToUInt16(sn), Convert.ToUInt32(devinfo.Dbw1SendLength), wdata) == false)
                        {
                            _commLayerError = "SimensProdave6.CSendDeviceOrder.SendDeviceOrder" + CSimensProdave6_S7.ErrorsText;
                            return false;
                        }
                        if (WriteBarcode(DeviceIndex, TaskIndex) == false)
                        {
                            return false;
                        }
                    }

                    #endregion
                   
                }
                return true;
            }
            catch (Exception ex)
            {
                _commLayerError = "SimensProdave6.CSendDeviceOrder.SendDeviceOrder" + ex.Message;
                return false;
            }
            
        }
        /// <summary>
        /// ʹ󳵡ͻ豸
        /// </summary>
        /// <param name="MessageIndex">Ϣ</param>
        /// <param name="TaskIndex"></param>
        /// <param name="Order"></param>
        /// ֣ 
        ///1-λ 
        ///2-ӻ
        ///3-ͻ
        ///4-ҽӻ
        ///5-ͻ
        ///6-ֹͣ
        ///7-˶˶45ָֽĿ豸
        ///ͻ֣
        ///1-⣨⣩
        ///2-⣨⣩
        ///3-ͻ
        ///4-ӻ
        ///5-ֹͣ
        /// <param name="DeviceIndex">豸</param>
        ///<param name="ArrowDeviceIndex">ͻ󳵴Ŀ豸
        /// 0-һ豸ƣĿ豸165535Ŀ豸յͻ豸</param>
        /// <returns>ʹ󳵡ͻ豸Ƿɹ</returns>
        public bool SendDeviceOrder(int MessageIndex, int TaskIndex, int Order, int DeviceIndex, int ArrowDeviceIndex)
        {
            try
            {
                string[] itemnames = new string[4];
                string[] itemvalues = new string[4];
                int sn = 0;
                Model.MDevice devinfo = Model.CGetInfo.GetDeviceInfo(DeviceIndex);
                //DataView dv = dbo.ExceSQL("SELECT F_DBW1Address,F_DBWSendLength,F_DeviceIndex,F_DeviceKindIndex,F_OPCProgID, F_RemoteIP FROM T_Base_Device where F_DeviceIndex=" + DeviceIndex).Tables[0].DefaultView;
                if (devinfo.DeviceIndex == 0)
                {
                    _commLayerError = "SimensProdave6.CSendDeviceOrder.SendDeviceOrder豸!";
                    return false;
                }
                else
                {
                    if (devinfo.DeviceKind.ToString() == "7")
                    {
                        return true;
                    }
                    if ((devinfo.DeviceKind.ToString() == "1") )
                    {//Ѷʹô˷
                        _commLayerError = "SimensProdave6.CSendDeviceOrder.SendDeviceOrder󣺶ѶRGVʹô˷!";
                        return false;
                    }
                    byte[] wdata = new byte[6];
                    sn = Convert.ToInt32(devinfo.Dbw1Address);
                    wdata[0] = (byte)MessageIndex;
                    wdata[1] = (byte)Order;
                    wdata[2] = (byte)(TaskIndex >> 8);
                    wdata[3] = (byte)(TaskIndex & 255);
                    wdata[4] = (byte)(ArrowDeviceIndex >> 8);
                    wdata[5] = (byte)(ArrowDeviceIndex & 255);
                    if (CSimensProdave6_S7.DB_Write_Prodave(0, 1, Convert.ToUInt16(sn), Convert.ToUInt32(devinfo.Dbw1SendLength), wdata) == false)
                    {
                        _commLayerError = "SimensProdave6.CSendDeviceOrder.SendDeviceOrder" + CSimensProdave6_S7.ErrorsText;
                        return false;
                    }
                    byte[] www = new byte[6];
                    Array.Copy(wdata, www, 6);
                    CommonClassLib.CCarryConvert.WriteDarkCasket("SimensProdave6", "SendDeviceOrder", DeviceIndex.ToString(), www);
                    if (WriteBarcode(DeviceIndex, TaskIndex) == false)
                    {
                        return false;
                    }
                    
                }
                return true;
            }
            catch (Exception ex)
            {
                _commLayerError = "SimensProdave6.CSendDeviceOrder.SendDeviceOrder" + ex.Message;
                return false;
            }
           
        }
        /// <summary>
        /// λλ䰴ƷֵϢ15ֽ,ʱдʵݣȫд
        /// </summary>
        /// <param name="DeviceIndex">λ豸</param>
        /// <param name="TobaccoCode">1--13ֽ,</param>
        /// <param name="HaveFirstProjectCode">14ֽ,1-һŹ,0-һŹ</param>
        /// <param name="IfSmallTobacco">15ֽ,1-С,0-</param>
        /// <returns>䰴ƷֵϢǷɹ</returns>
        public bool SendDeviceOrder(int DeviceIndex, string TobaccoCode, bool HaveFirstProjectCode, bool IfSmallTobacco,int Count)
        {
            try
            {
                byte[] wdata = new byte[15];
                Model.MDevice devinfo = Model.CGetInfo.GetDeviceInfo(DeviceIndex);
                //DataView dv = dbo.ExceSQL("SELECT F_DBW1Address,F_DBWSendLength,F_DeviceIndex,F_DeviceKindIndex,F_OPCProgID, F_RemoteIP FROM T_Base_Device where F_DeviceIndex=" + DeviceIndex).Tables[0].DefaultView;
                if (devinfo.DeviceIndex == 0)
                {
                    _commLayerError = "SimensProdave6.CSendDeviceOrder.SendDeviceOrder豸!";
                    return false;
                }
                else
                {
                    for (int i = 0; i < 13; i++)
                    {
                        wdata[i]=(byte)Strings.Asc(TobaccoCode.Substring(i,1));
                    }

                    if (HaveFirstProjectCode == true)
                    {
                        wdata[13] = 1;
                    }
                    else
                    {
                        wdata[13] = 0;
                    }
                    if (IfSmallTobacco == true)
                    {
                        wdata[14] = 1;
                    }
                    else
                    {
                        wdata[14] = 1;
                    }

                    if (CSimensProdave6_S7.DB_Write_Prodave(0, 1, Convert.ToUInt16(devinfo.Dbw1Address), Convert.ToUInt32(devinfo.Dbw1SendLength), wdata) == false)
                    {
                        return false;
                    }
                }
                return true;
            }
            catch (Exception ex)
            {
                _commLayerError = "SimensProdave6.CSendDeviceOrder.SendDeviceOrder" + ex.Message;
                return false;
            }
        }
        bool WriteBarcode(int deviceindex,int taskindex)
        {
            string barcode="";
            byte[] wdata = new byte[11];
            DataView dvb = dbo.ExceSQL("SELECT F_MonitorIndex, F_TxtParam FROM T_Monitor_Task WHERE (F_MonitorIndex = "+taskindex +")").Tables[0].DefaultView;
            if (dvb.Count > 0)
            {
                barcode = dvb[0]["F_TxtParam"].ToString();
                if (barcode == "-") return true;
            }
            else
            {
                _commLayerError = "SimensProdave6.CSendDeviceOrder.SendDeviceOrderд븽ʱڵûҵ!";
                return false;
            }
            Model.MDevice devinfo = Model.CGetInfo.GetDeviceInfo(deviceindex);
            
            //DataView dv0 = dbo.ExceSQL("SELECT F_AppendBarcode, F_DeviceIndex FROM T_Base_Device WHERE (F_AppendBarcode <>-1) AND (F_DeviceIndex = "+deviceindex +")").Tables[0].DefaultView;
            if (devinfo.AppendBarcode > 0)
            {
                Model.MDevice devinfo1 = Model.CGetInfo.GetDeviceInfo(devinfo.AppendBarcode);
                //DataView dv = dbo.ExceSQL("SELECT F_DBW1Address,F_DBWSendLength,F_DeviceIndex,F_DeviceKindIndex,F_OPCProgID, F_RemoteIP FROM T_Base_Device where F_DeviceIndex=" + Convert.ToInt32(dv0[0]["F_AppendBarcode"])).Tables[0].DefaultView;
                if (devinfo1.DeviceIndex == 0)
                {
                    _commLayerError = "SimensProdave6.CSendDeviceOrder.SendDeviceOrderд븽ʱ豸!";
                    return false;
                }
                else
                {
                    wdata[0] = 1;
                    for (int i = 1; i <= barcode.Length; i++)
                    {
                        wdata[i] =(byte) Strings.Asc(barcode.Substring(i-1, 1));
                    }
                    if (CSimensProdave6_S7.DB_Write_Prodave(0, 1, Convert.ToUInt16(devinfo1.Dbw1Address), Convert.ToUInt32(devinfo1.Dbw1SendLength), wdata) == false)
                    {
                        _commLayerError = "SimensProdave6.CSendDeviceOrder.SendDeviceOrderд븽ʧ!";
                        return false;
                    }
                }
                return true;
            }
            else
            {
                return true; ;
            }
        }
        /// <summary>
        /// PLCDBд
        /// </summary>
        /// <param name="ItemNames">ǩ</param>
        /// <param name="ItemValues">ǩֵ</param>
        /// <returns></returns>
        public bool WriteDBData(string[] ItemNames, string[] ItemValues)
        {
            return true;
        }
    }
}
