using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Threading;
using Microsoft.VisualBasic;
using DBFactory;
using ICommLayer;

namespace SocketsTCPIP
{
    /// <summary>
    /// ʹSocketsTCPIPĿͻ˽ͨѶ
    /// 豸
    /// ߣRichard.Liu
    /// </summary>
    public class CSendDeviceOrder: ISendDeviceOrder
    {
        string _commLayerError;

        public string CommLayerError
        {
            get { return _commLayerError; }
            set { _commLayerError = value; }
        }
        
        DBOperator dbo = CClientTCPIP.dbo;
        string AGVAllowSingleFork = CommonClassLib.AppSettings.GetValue("AGVAllowSingleFork");
        public CSendDeviceOrder()
        {
            dbo.Open();
        }
        public bool SendDeviceOrder(int MessageIndex, int TaskIndex, int Order, int DeviceIndex, int StartX, int StartY, int StartZ, int EndX, int EndY, int EndZ,string DoubleFork)
        {
            return true;
        }


        /// <summary>
        /// ÿֽڣһ֣һ֡
        /// 1ͻ־ͷ61ͻ˶Ͽ־ͷ62
        /// 2ʼ־ͷ63ȼ1--8ȡλţ룫ͻλţ
        /// 뺬壺0޶1ϳ⣻2̻գ3ֽ̡Ļգ4ʣศϷ⣻5ϳ⣬ͬʱ̻
        /// 3ȡ񣺱־ͷ65ţ̨ţ
        /// 4ֹͣȷϣϻؿͻŻ־ͷ67
        /// 5ѯС״̬־ͷ69С
        /// </summary>
        /// <param name="MessageIndex">Ϣ</param>
        /// <param name="TaskIndex"></param>
        /// <param name="Order">AGV</param>
        /// <param name="DeviceIndex">豸</param>
        /// <param name="StartX">[N1]:ȡ</param>
        /// <param name="StartY"></param>
        /// <param name="StartZ"></param>
        /// <param name="EndX">[N2]:Ż</param>
        /// <param name="EndY"></param>
        /// <param name="EndZ"></param>
        /// <returns>AGVǷɹ</returns>
        public bool SendDeviceOrder(int MessageIndex, int TaskIndex, int Order, int DeviceIndex, int StartX, int StartY, int StartZ, int EndX, int EndY, int EndZ)
        {
            //StartXȡ豸 EndX豸

            //28901ǰȡ 28902ǰ 28903ǰȡ 28904ǰ
            //28905ȡ 28906 28907ȡ 28908
            //28909˫ȡ 28910˫ 28911˫ȡ 28912˫

            //20100413StartXȡ豸ǰ복βԶ桢󣨾복β
            //order==1 StartXȡ豸õ ȡңorder==2 EndX豸õ 
            //վڳβнҷ
            //жϹ˫Ƿͬ
            char useAwayFork = '0';
            char channelLeft = '0';
            int AGVAddress = 0;
            int dorder = 0;
            int _device =  GetAGVNoFromMonitor(TaskIndex);
            byte[] _Sdata;
            
            
            try
            {
                switch (Order)
                {
                    case 1://ȡ StartXȡ豸
                        GetDeviceInfoFromAGVGate(StartX, ref channelLeft, ref useAwayFork, ref AGVAddress);
                        if ((Model.CGeneralFunction.DoubleForkIfSync(TaskIndex, DeviceIndex, 6) == false) && (AGVAllowSingleFork=="1"))//20100710
                        {//ͬ
                            GetDeviceInfoFromAGVGate(StartX, ref channelLeft, ref useAwayFork, ref AGVAddress);
                            if (useAwayFork == '1')//ǰ
                            {
                                if (channelLeft == '1')
                                {
                                    dorder = 28901;//ǰȡ
                                }
                                else
                                {
                                    dorder = 28903;//ǰȡ
                                }

                            }
                            else//
                            {
                                if (channelLeft == '1')
                                {
                                    dorder = 28905;//ȡ
                                }
                                else
                                {
                                    dorder = 28907;//ȡ
                                }
                            }
                        }
                        else
                        {//ͬ
                            if (channelLeft == '1')
                            {
                                dorder = 28909;//˫ȡ
                            }
                            else
                            {
                                dorder = 28911;//˫ȡ
                            }

                        }
                        _Sdata = new byte[10];
                        _Sdata[0] = 72;
                        _Sdata[1] = 0;
                        _Sdata[2] = Convert.ToByte(TaskIndex & 255); 
                        _Sdata[3] = Convert.ToByte(TaskIndex >> 8);
                        _Sdata[4] = Convert.ToByte(AGVAddress & 255);
                        _Sdata[5] = Convert.ToByte(AGVAddress >> 8);
                        _Sdata[6] = Convert.ToByte(dorder & 255);
                        _Sdata[7] = Convert.ToByte(dorder >> 8);
                        _Sdata[8] = Convert.ToByte(_device & 255);
                        _Sdata[9] = Convert.ToByte(_device >> 8);

                        return SendData(DeviceIndex, _Sdata);
                        
                    case 2://ͻ
                        GetDeviceInfoFromAGVGate(EndX, ref channelLeft, ref useAwayFork, ref AGVAddress);
                        if ((Model.CGeneralFunction.DoubleForkIfSync(TaskIndex, DeviceIndex, 6) == false) && (AGVAllowSingleFork == "1"))//20100710
                        {//ͬ
                            GetDeviceInfoFromAGVGate(EndX, ref channelLeft, ref useAwayFork, ref AGVAddress);
                            if (useAwayFork == '1')//ǰ
                            {
                                if (channelLeft == '1')
                                {
                                    dorder = 28902;//ǰ
                                }
                                else
                                {
                                    dorder = 28904;//ǰ
                                }

                            }
                            else//
                            {
                                if (channelLeft == '1')
                                {
                                    dorder = 28906;//
                                }
                                else
                                {
                                    dorder = 28908;//
                                }
                            }
                        }
                        else
                        {//ͬ
                            if (channelLeft == '1')
                            {
                                dorder = 28910;//˫
                            }
                            else
                            {
                                dorder = 28912;//˫
                            }

                        }
                        _Sdata = new byte[10];
                        _Sdata[0] = 72;
                        _Sdata[1] = 0;
                        _Sdata[2] = Convert.ToByte(TaskIndex & 255);
                        _Sdata[3] = Convert.ToByte(TaskIndex >> 8);
                        _Sdata[4] = Convert.ToByte(AGVAddress & 255);
                        _Sdata[5] = Convert.ToByte(AGVAddress >> 8);
                        _Sdata[6] = Convert.ToByte(dorder & 255);
                        _Sdata[7] = Convert.ToByte(dorder >> 8);
                        _Sdata[8] = Convert.ToByte(_device & 255);
                        _Sdata[9] = Convert.ToByte(_device >> 8);

                        return SendData(DeviceIndex, _Sdata);
                    case 3:
                        //ɵӦ֡75

                        _Sdata = new byte[6];
                        _Sdata[0] = 75;
                        _Sdata[1] = 0;
                        TaskIndex = GetAGVTaskFromMonitor(TaskIndex);
                        _Sdata[2] = Convert.ToByte(TaskIndex & 255);
                        _Sdata[3] = Convert.ToByte(TaskIndex >> 8);
                        _Sdata[4] = Convert.ToByte(65535 & 255);
                        _Sdata[5] = Convert.ToByte(65535 >> 8);
                        return SendData(DeviceIndex, _Sdata);
                    case 4:
                        //
                        GetDeviceInfoFromAGVGate(EndX, ref channelLeft, ref useAwayFork, ref AGVAddress);
                        _Sdata = new byte[10];
                        _Sdata[0] = 72;
                        _Sdata[1] = 0;
                        _Sdata[2] = Convert.ToByte(TaskIndex & 255);
                        _Sdata[3] = Convert.ToByte(TaskIndex >> 8);
                        _Sdata[4] = Convert.ToByte(AGVAddress & 255);
                        _Sdata[5] = Convert.ToByte(AGVAddress >> 8);
                        _Sdata[6] = Convert.ToByte(65535 & 255);//
                        _Sdata[7] = Convert.ToByte(65535 >> 8);
                        _Sdata[8] = Convert.ToByte(_device & 255);
                        _Sdata[9] = Convert.ToByte(_device >> 8);
                        return SendData(DeviceIndex, _Sdata);

                    default:
                        break;
                }


                return false;
            }
            catch (Exception ex)
            {
                _commLayerError = this.ToString() + ":SendDeviceOrder---" +ex.Message ;
                return false;
            }

        }
        /// <summary>
        /// AGV
        /// </summary>
        /// <param name="MessageIndex">Ϣ</param>
        /// <param name="TaskIndex"></param>
        /// <param name="Order">AGV MAN֪ͨLCͨѶӽMAN֪ͨLCͨѶӶϿ</param>
        /// <param name="DeviceIndex">豸</param>
        /// <returns>AGV豸Ƿɹ</returns>
        public bool SendDeviceOrder(int MessageIndex, int TaskIndex, int Order, int DeviceIndex, int ArrowDeviceIndex)
        {
            try
            {
                byte[] _Sdata = new byte[2];
                _Sdata[0] =Convert.ToByte(Order); 
                _Sdata[1] = 0;
                _Sdata[2] =Convert.ToByte(TaskIndex & 255);//Ͱλ
                _Sdata[3] = Convert.ToByte(TaskIndex >> 8);//߰λ
                
                //DeviceIndex,õSocketsͨѶĳʼ
                DataSet ds = dbo.ExceSQL("SELECT  F_DeviceIndex,F_DeviceKindIndex, F_LocalIP,  F_LocalPort, F_RemoteIP,  F_RemotePort  FROM T_Base_Device where F_DeviceIndex=" + DeviceIndex);
                DataView dv = ds.Tables[0].DefaultView;

                if (ds.Tables[0].DefaultView.Count == 0)
                {
                    return false;
                }
                else
                {

                    CClientTCPIP.Send(dv[0]["F_RemoteIP"].ToString(), (int)dv[0]["F_RemotePort"], _Sdata);
                    return true;

                }

            }
            catch (Exception ex)
            {
                _commLayerError = this.ToString() + ":SendDeviceOrder---" + ex.Message;
                return false;
            }

        }
        /// <summary>
        /// λλ䰴ƷֵϢ15ֽ,ʱдʵݣȫд
        /// </summary>
        /// <param name="DeviceIndex">λ豸</param>
        /// <param name="TobaccoCode">1--13ֽ,</param>
        /// <param name="HaveFirstProjectCode">14ֽ,1-һŹ,0-һŹ</param>
        /// <param name="IfSmallTobacco">15ֽ,1-С,0-</param>
        /// <returns></returns>
        public bool SendDeviceOrder(int DeviceIndex, string TobaccoCode, bool HaveFirstProjectCode, bool IfSmallTobacco,int Count)
        {
            return true;
        }
        bool SendData(int devID, byte[] _Sdata)
        {
            //DeviceIndex,õSocketsͨѶĳʼ
            DataSet ds = dbo.ExceSQL("SELECT  F_DeviceIndex,F_DeviceKindIndex, F_LocalIP,  F_LocalPort, F_RemoteIP,  F_RemotePort  FROM T_Base_Device where F_DeviceIndex=" + devID);
            DataView dv = ds.Tables[0].DefaultView;
            if (dv.Count == 0)
            {
                return false;
            }
            else
            {

                if (CClientTCPIP.Send(dv[0]["F_RemoteIP"].ToString(), Convert.ToInt32(dv[0]["F_RemotePort"]), _Sdata) == false)
                {
                    if (CClientTCPIP.TcpError != null) _commLayerError = CClientTCPIP.TcpError;
                    return false;
                }
                return true;

            }
        }
        /// <summary>
        /// PLCDBд
        /// </summary>
        /// <param name="ItemNames">ǩ</param>
        /// <param name="ItemValues">ǩֵ</param>
        /// <returns></returns>
        public bool WriteDBData(StringBuilder[] ItemNames, StringBuilder[] ItemValues,int deviceindex)
        {
            return true;
        }
        void GetDeviceInfoFromAGVGate(int agvGateDevice,ref char channelLeft,ref char useAwayFork,ref int AGVAddress)
        {
            DataView dv;
            try
            {
                dv = dbo.ExceSQL("SELECT  F_Address,F_IfChannelLeft,F_UseAwayFork FROM T_Base_AGV_Gate WHERE (F_AGVGateDeviceIndex = " + agvGateDevice + ")").Tables[0].DefaultView;
                if (dv.Count > 0)
                {
                    channelLeft = Convert.ToChar(dv[0]["F_IfChannelLeft"]);
                    useAwayFork = Convert.ToChar(dv[0]["F_UseAwayFork"]);
                    AGVAddress = Convert.ToChar(dv[0]["F_Address"]);
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                dv = null;
            }
        }
        int GetAGVNoFromMonitor(int taskIndex)
        {

            DataView dv;
            try
            {
                dv = dbo.ExceSQL("SELECT F_AgvNo FROM T_Monitor_Task WHERE (F_MonitorIndex = " + taskIndex + ") and (F_AgvNo is not null)").Tables[0].DefaultView;
                if (dv.Count > 0)
                {
                    return Convert.ToInt32(dv[0][0]);
                }
                else
                {
                    return 65535;
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                dv = null;
            }
        }
        int GetAGVTaskFromMonitor(int taskIndex)
        {

            DataView dv;
            try
            {
                dv = dbo.ExceSQL("SELECT F_AgvTask FROM T_Monitor_Task WHERE (F_MonitorIndex = " + taskIndex + ") and (F_AgvTask is not null)").Tables[0].DefaultView;
                if (dv.Count > 0)
                {
                    return Convert.ToInt32(dv[0][0]);
                }
                else
                {
                    return 65535;
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                dv = null;
            }
        }
    }
}
